********************************************************************
***      Definition of all parameters                            ***
***                                                              ***
********************************************************************
Parameters
Db_in(input_no,db_prop)
residual_P_wind_eval(input_no,I_reg,wind,modelled_status,T)
residual_P_wind(I_reg,wind,T)
residual_wind_nuts2_eval(input_no,nuts2,wind,modelled_status,T)
residual_wind_nuts2(nuts2,wind,T)

residual_PV_nuts2_eval(input_no,nuts2,modelled_status,T)
residual_PV_nuts2(nuts2,T)

residual_P_hydro_eval(input_no,I_reg,hydro,modelled_status,T)
residual_P_hydro(I_reg,hydro,T)
Residual_P_others_eval(input_no,I_reg,others,modelled_status,T)
Residual_P_others(I_reg,others,T)
Residual_P_GEO_eval(input_no,I_reg,geothermal,modelled_status,T)
Residual_P_GEO(I_reg,geothermal,T)

residual_P_thermal_eval(input_no,I_reg,thermal,plant_type,modelled_status,eval_prop,T)
residual_P_thermal(I_reg,thermal,plant_type,cap_prop,T,inv_year)

sites_res_wind_nuts2_eval(input_no,nuts2,wind,modelled_status,T)
sites_res_wind_nuts2(nuts2,wind,T)
sites_res_P_hydro_eval(input_no,nuts2,hydro,modelled_status,T)
sites_res_P_hydro(nuts2,hydro,T)
sites_res_P_others_eval(input_no,nuts2,others,modelled_status,T)
sites_res_P_others(nuts2,others,T)
sites_res_P_GEO_eval(input_no,nuts2,geothermal,modelled_status,T)
sites_res_P_GEO(nuts2,geothermal,T)
sites_res_P_thermal_eval(input_no,nuts2,thermal,plant_type,modelled_status,T)
sites_res_P_thermal(nuts2,thermal,plant_type,T)

totsites_res_wind_nuts2_eval(input_no,nuts2,wind,modelled_status)
totsites_res_wind_nuts2(nuts2,wind)
totsites_res_P_hydro_eval(input_no,nuts2,hydro,modelled_status)
totsites_res_P_hydro(nuts2,hydro)
totsites_res_P_others_eval(input_no,nuts2,others,modelled_status)
totsites_res_P_others(nuts2,others)
totsites_res_P_GEO_eval(input_no,nuts2,geothermal,modelled_status)
totsites_res_P_GEO(nuts2,geothermal)
totsites_res_P_thermal_eval(input_no,nuts2,thermal,plant_type,modelled_status)
totsites_res_P_thermal(nuts2,thermal,plant_type)


*residual_P_thermal_eval2(input_no,region,thermal,plant_type,modelled_status,cap_prop,inv_year)
*residual_P_thermal_eval3(region,thermal,plant_type,cap_prop,inv_year)

*res_P(I_reg,thermal,plant_type,T)

***      Process parameters      ***
T_num(T)
Num_inv_year(inv_year)
country_num(regions)
fuel_num(all_en_type)
status_num(status_Db)
com_num(Time)
plant_type_num(plant_type)


***      Assumptions     ***
tech_life(en_type)
*nutsnumber(nuts2)
;
parameter nutsnumber(nuts2)
/
$include %include_path%nutsnumber.inc
/
;

$oneolcom
         T_num(T)=ord(T)+2009;           !!Ordningstal plus ret fre frsta r i tidsserien
         Num_inv_year(inv_year)=ord(inv_year)+1899;
         country_num(dbcountry)=ord(dbcountry);
         country_num(EPODreg)=sum(dbcountry$country_to_EPODreg(dbcountry,EPODreg),country_num(dbcountry));
         fuel_num('B')=1;
         fuel_num('H')=2;
         fuel_num('G')=3;
         fuel_num('O')=4;
         fuel_num('P')=5;
         fuel_num('W')=6;
         fuel_num('WA')=7;
         fuel_num('U')=8;
         fuel_num('WON')=9;
         fuel_num('WOFF')=10;
         fuel_num('RO')=11;
         fuel_num('PS')=12;
         fuel_num('BCCS')=13;
         fuel_num('HCCS')=14;
         fuel_num('GCCS')=15;
         fuel_num('BWCCS')=16;
         fuel_num('HWCCS')=17;
         fuel_num('PV')=18;
         fuel_num('STH')=19;
         fuel_num('T')=20;
         fuel_num('WV')=21;
         fuel_num('Small_hydro')=22;
         fuel_num('GEO')=23;
         fuel_num('HY')=24;
         fuel_num('Z')=25;
         fuel_num('ICE')=26;
         fuel_num('ICI')=27;
         status_num(status_Db)=ord(status_Db);
         com_num(Time)=ord(Time)+1899;   !!Ordningstal plus ret fre frsta r i tidsserien
         plant_type_num(plant_type)=ord(plant_type);


Scalars
MW_to_GW
;

MW_to_GW=1000;


