********************************************************************
***      Boundary conditions in model                            ***
***                                                              ***
********************************************************************
Inv_NP_trade.fx(I_reg,import_reg,year)=0;
Inv_NP_trade.up(I_reg,import_reg,year)$(T_num(year) ge 2020 and valid_NP_trade(I_reg,import_reg))=5;
NP_trade.fx(I_reg,import_reg,T)$(not valid_NP_trade(I_reg,import_reg))=0;

$ifi %national%==yes $goto national_cables
valid_NP_trade('SE1','SE2')=yes;
valid_NP_trade('SE2','SE1')=yes;
valid_NP_trade('NO1','DE4')=yes;
valid_NP_trade('DE4','NO1')=yes;
valid_NP_trade('NO1','UK1')=yes;
valid_NP_trade('UK1','NO1')=yes;
valid_NP_trade('NO1','DK2')=yes;
valid_NP_trade('DK2','NO1')=yes;
valid_NP_trade('DE1','DE4')=yes;
valid_NP_trade('DE4','DE1')=yes;
valid_NP_trade('DE2','DE5')=yes;
valid_NP_trade('DE5','DE2')=yes;
valid_NP_trade('DE1','DE2')=yes;
valid_NP_trade('DE2','DE1')=yes;
valid_NP_trade('UK1','UK2')=yes;
valid_NP_trade('UK2','UK1')=yes;
*Inv_NP_trade.fx('SE1','SE2','2015')=1.4;
*Inv_NP_trade.fx('SE2','SE1','2015')=1.4;
*Inv_NP_trade.fx('NO1','DE4','2018')=1.4;
*Inv_NP_trade.fx('DE4','NO1','2018')=1.4;
*Inv_NP_trade.fx('NO1','UK1','2020')=1.4;
*Inv_NP_trade.fx('UK1','NO1','2020')=1.4;
*Inv_NP_trade.fx('NO1','DK2','2014')=0.7;
*Inv_NP_trade.fx('DK2','NO1','2014')=0.7;
*Inv_NP_trade.fx('DE1','DE4','2020')=6;
*Inv_NP_trade.fx('DE4','DE1','2020')=6;
*Inv_NP_trade.fx('DE2','DE5','2020')=2;
*Inv_NP_trade.fx('DE5','DE2','2020')=2;
*Inv_NP_trade.fx('DE1','DE2','2020')=2;
*Inv_NP_trade.fx('DE2','DE1','2020')=2;
*Inv_NP_trade.fx('UK1','UK2','2016')=2;
*Inv_NP_trade.fx('UK2','UK1','2016')=2;

$label national_cables
EE_import11.fx(import_reg,export_reg,T,Time_step)$(not valid_EP_trade(import_reg,export_reg))=0;
EE_export11.fx(import_reg,export_reg,T,Time_step)$(not valid_EP_trade(import_reg,export_reg))=0;
NE_import11.fx(import_reg,export_reg,T,Time_step)$(not valid_NP_trade(import_reg,export_reg))=0;
NE_export11.fx(import_reg,export_reg,T,Time_step)$(not valid_NP_trade(import_reg,export_reg))=0;
*EE_trade.fx(export_reg,import_reg,T,Time_step)$(not valid_EP_trade(export_reg,import_reg))=0;
*NE_trade.fx(export_reg,import_reg,T,Time_step)$(not valid_NP_trade(export_reg,import_reg))=0;
*NP_trade.up(I_reg,import_reg,T)$(valid_NP_trade(I_reg,import_reg))=;


$oneolcom
********************************************
*** Boundary conditions for whole region ***
********************************************
gen.lo(T)=sum(I_reg,demand(I_reg,T));
gen.up(T)=sum(I_reg,demand(I_reg,T))+500;

tot_RES_Ireg.lo(I_reg,T)=demand_RES(I_reg,T)*demand(I_reg,T);
*tot_solar_Ireg.lo(I_reg,T)$(T_num(T) ge 2020)=((T_num(T)-2020))*0.005*demand_RES(I_reg,T)*demand(I_reg,T);

scalar
EU_RES_target_2020
EU_RES_target_2050
;
EU_RES_target_2020=sum(I_reg,tot_RES_Ireg.lo(I_reg,"2020"))/sum(I_reg,demand(I_reg,"2020"));       !!Fraction of total EU demand
EU_RES_target_2050=0.95;

$if %scenario%=="GP" tot_RES.lo(T)$(T_num(T) gt 2020) = (EU_RES_target_2020+(((EU_RES_target_2050-EU_RES_target_2020)/30)*(T_num(T)-2020)))*sum(I_reg,demand(I_reg,T));


*** Hydro ***
$ontext
upper_lim_hydro(I_reg,T)$(smax(year,residual_P_hydro(I_reg,"RO",year)) lt hydro_stat(I_reg,"RO"))=hydro_stat(I_reg,"RO")-residual_P_hydro(I_reg,"RO",T);  !!Eurostat instlled capacity
upper_lim_hydro(I_reg,T)$(smax(year,residual_P_hydro(I_reg,"RO",year)) ge hydro_stat(I_reg,"RO"))=smax(year,residual_P_hydro(I_reg,"RO",year))-residual_P_hydro(I_reg,"RO",T);  !!Eurostat instlled capacity

loop(T,
         min_year_hydro(I_reg)$(upper_lim_hydro(I_reg,T) eq smin(year,upper_lim_hydro(I_reg,year)))=2002+ord(T);
)
;

VNPH.up(I_reg,"RO",T)$(T_num(T) le min_year_hydro(I_reg))=smin(year,upper_lim_hydro(I_reg,year));
VNPH.up(I_reg,"RO",T)$(T_num(T) gt min_year_hydro(I_reg))=upper_lim_hydro(I_reg,T);
Inv_VNPH.up(I_reg,"RO",T)=VNPH.up(I_reg,"RO",T);
Inv_VNPH.fx(I_reg,"PS",T)=0;
VNPH.fx(I_reg,"PS",T)=0;
$offtext
*hydro_prod_max(I_reg,"run_riv",T)=smax(year,residual_P_hydroclass(I_reg,"run_riv",year))*sum(Time_step,LFH(I_reg,Time_step));
VEEH_REG.up(I_reg,T)=0;
$ifi %regional%==yes VEEH_REG.up(I_reg,T)=sum(dbcountry$(country_to_EPODreg(dbcountry,I_reg) and hydro_region(I_reg)),hydro_prod_ref(dbcountry,"reg"));
$ifi %national%==yes VEEH_REG.up(I_reg,T)=hydro_prod_ref(I_reg,"reg");
*** Wind ***
$ontext
upper_lim_wind(I_reg,wind_class,T)$(wind_pot(I_reg,wind_class) gt 0 and sum(Time_step,LFW(I_reg,wind_class,Time_step) gt 0))=wind_pot(I_reg,wind_class)/sum(Time_step,LFW(I_reg,wind_class,Time_step))-residual_P_windclass(I_reg,wind_class,T);
upper_lim_wind(I_reg,"low",T)$(wind_pot(I_reg,"low") gt 0 and sum(Time_step,LFW(I_reg,"low",Time_step)) gt 0 and T_num(T) ge 2020 and demand(I_reg,T)*0.0375/sum(Time_step,LFW(I_reg,"low",Time_step)) gt wind_pot(I_reg,"low")/sum(Time_step,LFW(I_reg,"low",Time_step)))=demand(I_reg,T)*0.0375/sum(Time_step,LFW(I_reg,"low",Time_step))-residual_P_windclass(I_reg,"low",T);
upper_lim_wind(I_reg,"up",T)$(wind_pot(I_reg,"up") gt 0 and sum(Time_step,LFW(I_reg,"up",Time_step)) gt 0 and T_num(T) ge 2020 and demand(I_reg,T)*0.0375/sum(Time_step,LFW(I_reg,"up",Time_step)) gt wind_pot(I_reg,"up")/sum(Time_step,LFW(I_reg,"up",Time_step)))=demand(I_reg,T)*0.0375/sum(Time_step,LFW(I_reg,"up",Time_step))-residual_P_windclass(I_reg,"up",T);
upper_lim_wind(I_reg,"off",T)$(wind_pot(I_reg,"off") gt 0 and sum(Time_step,LFW(I_reg,"off",Time_step)) gt 0 and T_num(T) ge 2020 and demand(I_reg,T)*0.125/sum(Time_step,LFW(I_reg,"off",Time_step)) gt wind_pot(I_reg,"off")/sum(Time_step,LFW(I_reg,"off",Time_step)))=demand(I_reg,T)*0.125/sum(Time_step,LFW(I_reg,"low",Time_step))-residual_P_windclass(I_reg,"off",T);

loop(T,
         min_year_wind(I_reg,wind_class)$(upper_lim_wind(I_reg,wind_class,T) eq smin(year,upper_lim_wind(I_reg,wind_class,year)))=2002+ord(T);
)
;
$offtext
VNPW.up(nuts2,wind_type,T)$(not valid_wind_type(nuts2,wind_type))=0;
VNEW1_nuts2.up(nuts2,wind_type,T,Time_step)$(not valid_wind_type(nuts2,wind_type))=0;

Inv_VNPW.up(nuts2,wind_type,T)=0;
Inv_VNPW.up(nuts2,wind_type,T)$(valid_wind_type(nuts2,wind_type))=1;


upper_lim_wind(nuts2,wind_type,T)=wind_pot(nuts2,wind_type)*Wind_cap_intensity;
*-residual_P_windclass(I_reg,wind_class,T);
*loop(T,
*         min_year_wind(I_reg,wind_class)$(upper_lim_wind(I_reg,wind_class,T) eq smin(year,upper_lim_wind(I_reg,wind_class,year)))=2009+ord(T);
*)
;

VNPW.up(nuts2,wind_type,T)=0;
VNPW.up(nuts2,wind_type,T)=upper_lim_wind(nuts2,wind_type,T);

**********************************************************************************************************
**** OBS! OBS! OBS! OBS! OBS! OBS! OBS! OBS! Wind and Solar capacity limitations   *****
*************************************************************************************************************
parameter
lim_VRES(I_reg,T);

lim_VRES(I_reg,T)$(T_num(T) lt 2030)=0.75*smax(an_hour,load_profile(an_hour,I_reg)*Demand(I_reg,T));
lim_VRES(I_reg,T)$(T_num(T) ge 2030)=(0.0225*T_num(T)-44.925)*smax(an_hour,load_profile(an_hour,I_reg)*Demand(I_reg,T));

*lim_VRES("Germany",T)=lim_VRES("Germany",T)*3;
*lim_VRES("Denmark",T)=lim_VRES("Denmark",T)*2;
*lim_VRES("Spain",T)=lim_VRES("Spain",T)*3;
*lim_VRES("Italy",T)=lim_VRES("Italy",T)*3;

*tot_P_VRES_Ireg.up(I_reg,T)=lim_VRES(I_reg,T);

**********************************************************************************************************
**** OBS! OBS! OBS! OBS! OBS! OBS! OBS! OBS! Wind and Solar capacity limitations   *****
*************************************************************************************************************

* What is this?    Commented out by zack
*Inv_VNPSol.up(solar_type,nuts2,T)=5;

*tot_solar_area.up(nuts2,T)=solar_pot(nuts2);

VNPSol.up(solar_type,solar_sites,T)$(not valid_solar_sites(solar_sites))=0;
VNESol1_sites.up(solar_type,solar_sites,T,Time_step)$(not valid_solar_sites(solar_sites))=0;

$if %solar_grid_parity% == "yes" V_solar_value.up(I_reg,TWh,T)=1;

$ontext
tot_solar.lo("Germany","2015")=25;
tot_solar.lo("Germany","2016")=26;
tot_solar.lo("Germany","2017")=27;
tot_solar.lo("Germany","2018")=28;
tot_solar.lo("Germany","2019")=29;
tot_solar.lo("Germany","2020")=30;
tot_solar.lo("Germany","2021")=31;
tot_solar.lo("Germany","2022")=32;
tot_solar.lo("Germany","2023")=33;
tot_solar.lo("Germany","2024")=34;
tot_solar.lo("Germany",T)$(T_num(T) ge 2025)=35;

tot_solar.lo("Spain","2015")=3.1;
tot_solar.lo("Spain","2016")=3.9;
tot_solar.lo("Spain","2017")=4.7;
tot_solar.lo("Spain","2018")=5.5;
tot_solar.lo("Spain","2019")=6.3;
tot_solar.lo("Spain",T)$(T_num(T) ge 2020)=7.1;

tot_solar.lo("Italy","2015")=12;
tot_solar.lo("Italy","2016")=12.7;
tot_solar.lo("Italy","2017")=13.5;
tot_solar.lo("Italy","2018")=14.2;
tot_solar.lo("Italy","2019")=14.9;
tot_solar.lo("Italy",T)$(T_num(T) ge 2020)=15.5;
$offtext
$ontext
VNPSol_tot_Ireg.lo("Germany",T)$(T_num(T) eq 2014)=35;
VNPSol_tot_Ireg.lo("Germany",T)$(T_num(T) eq 2015)=38;
VNPSol_tot_Ireg.lo("Germany",T)$(T_num(T) eq 2016)=41;
VNPSol_tot_Ireg.lo("Germany",T)$(T_num(T) eq 2017)=44;
VNPSol_tot_Ireg.lo("Germany",T)$(T_num(T) eq 2018)=47;
VNPSol_tot_Ireg.lo("Germany",T)$(T_num(T) ge 2019)=50;

VNPSol_tot_Ireg.lo("Italy",T)$(T_num(T) eq 2014)=18;
VNPSol_tot_Ireg.lo("Italy",T)$(T_num(T) eq 2015)=20;
VNPSol_tot_Ireg.lo("Italy",T)$(T_num(T) eq 2016)=22;
VNPSol_tot_Ireg.lo("Italy",T)$(T_num(T) eq 2017)=24;
VNPSol_tot_Ireg.lo("Italy",T)$(T_num(T) eq 2018)=26;
VNPSol_tot_Ireg.lo("Italy",T)$(T_num(T) ge 2019)=28;

VNPSol_tot_Ireg.lo("Spain",T)$(T_num(T) eq 2014)=5;
VNPSol_tot_Ireg.lo("Spain",T)$(T_num(T) eq 2015)=7;
VNPSol_tot_Ireg.lo("Spain",T)$(T_num(T) eq 2016)=9;
VNPSol_tot_Ireg.lo("Spain",T)$(T_num(T) eq 2017)=11;
VNPSol_tot_Ireg.lo("Spain",T)$(T_num(T) eq 2018)=13;
VNPSol_tot_Ireg.lo("Spain",T)$(T_num(T) ge 2019)=15;

$offtext

*upper_lim_solar(nuts2,T)=solar_pot(nuts2)*solar_cap_intensity(solar_type);

display upper_lim_wind;

$ontext
VNPW.up(I_reg,wind_class,T)$(T_num(T) lt 2010)=0;
VNPW.up(I_reg,wind_class,"2011")=0.1;
VNPW.up(I_reg,wind_class,"2012")=0.2;
VNPW.up(I_reg,wind_class,"2013")=0.3;
VNPW.up(I_reg,wind_class,"2014")=0.4;
VNPW.up(I_reg,wind_class,"2015")=0.5;
$offtext

*VNPW.up(I_reg,wind_class,T)$(T_num(T) le min_year_wind(I_reg,wind_class))=smin(year,upper_lim_wind(I_reg,wind_class,year));
*VNPW.up(I_reg,wind_class,T)$(T_num(T) gt min_year_wind(I_reg,wind_class))=upper_lim_wind(I_reg,wind_class,T);
*Inv_VNPW.up(I_reg,wind_class,T)=VNPW.up(I_reg,wind_class,T);

*** Thermal ***
$if %linear_fossil_cost_supply% == "yes"         V_cost_supply_fuel.up(cost_supply,TWh,T)=1;           !!should be 1 when Europe is modelled
$if %linear_biomarket_cost_supply% == "yes"            V_cost_supply_biomarket.up(TWh,T)=1;                    !!should be 1 when Europe is modelled
*$if %linear_fossil_cost_supply% == "yes"         gas_peakfuel.fx(I_reg,"H",T)=0;
*$if %linear_fossil_cost_supply% == "yes"         gas_peakfuel.fx(I_reg,"B",T)=0;
*$if %linear_fossil_cost_supply% == "yes"         cost_supply_fuelEQU1.l(cost_supply,T)=1;

lignite_fuel.up(I_reg,T)=fuel_pot(I_reg,"B");
totH_CHP.lo(I_reg,T,Time_step)=demand_CHP_timestep(I_reg,T,Time_step);
*totH_CHP.lo("Austria",T,Time_step)$(T_num(T) le 2015)=0;
totH_CHP.lo(I_reg,T,Time_step)$(T_num(T) le 2015 and country_num(I_reg) eq country_num("Norway"))=0;
totH_CHP.lo(I_reg,T,Time_step)$(T_num(T) le 2015 and country_num(I_reg) eq country_num("UK"))=0;
totH_CHP.lo(I_reg,T,Time_step)$(T_num(T) le 2015 and country_num(I_reg) eq country_num("Ireland"))=0;
totH_CHP.lo(I_reg,T,Time_step)$(T_num(T) le 2015 and country_num(I_reg) eq country_num("Switzerland"))=0;
totH_CHP.lo(I_reg,T,Time_step)$(T_num(T) le 2015 and country_num(I_reg) eq country_num("Spain"))=0;
totH_CHP.lo(I_reg,T,Time_step)$(T_num(T) le 2015 and country_num(I_reg) eq country_num("Bulgaria"))=0;
totH_CHP.lo(I_reg,T,Time_step)$(T_num(T) le 2015 and country_num(I_reg) eq country_num("Hungary"))=0;
*        totH_CHP.up(I_reg,T,Time_step)=demand_CHP_timestep(I_reg,T,Time_step)+100;

* back pressure sensitivity
* BP_el.up(I_reg,T)=BP_E_in(I_reg,"BP");
BP_el.up(I_reg,T)=0;
VBio_nation.up(I_reg,bio_class,T)=Biomass_supply(I_reg,bio_class,T)/3;     !!1/3 of the potential biomass goes to power production
Vwaste_nation.up(I_reg,waste_class,T)=waste_supply(I_reg,waste_class,T);

Inv_VNPTtype.up(I_reg,thermal,plant_type,year)=0;

*Inv_VNPTtype.up(I_reg,thermal,plant_type,year)$(T_num(year) ge 2010)=15;
*** Test
Inv_VNPTtype.up(I_reg,thermal,plant_type,year)$(T_num(year) eq 2015)=0.2*smax((T,inv_year),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el",T,inv_year))+0.2;
Inv_VNPTtype.up(I_reg,thermal,plant_type,year)$(T_num(year) eq 2016)=0.4*smax((T,inv_year),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el",T,inv_year))+0.2;
Inv_VNPTtype.up(I_reg,thermal,plant_type,year)$(T_num(year) eq 2017)=0.6*smax((T,inv_year),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el",T,inv_year))+0.2;
Inv_VNPTtype.up(I_reg,thermal,plant_type,year)$(T_num(year) eq 2018)=0.8*smax((T,inv_year),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el",T,inv_year))+0.2;
Inv_VNPTtype.up(I_reg,thermal,plant_type,year)$(T_num(year) ge 2019)=smax((T,inv_year),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el",T,inv_year))+0.2;
Inv_VNPTtype.up(I_reg,thermal,"CHP",year)$(T_num(year) lt 2015)=1;

Inv_VNPTtype.up(I_reg,"B",plant_type,year)$(T_num(year) lt 2020)=0;
Inv_VNPTtype.up(I_reg,"H",plant_type,year)$(T_num(year) lt 2020)=0;
Inv_VNPTtype.fx(I_reg,"WA",B_P,year)=0;

*Inv_VNPTtype.up(I_reg,thermal,plant_type,year)$(T_num(year) lt 2010)=0;
*Inv_VNPTtype.up(I_reg,thermal,plant_type,"2003")=0.1;
*Inv_VNPTtype.up(I_reg,"G",C_HP,year)=15;

*Inv_VNPTtype.fx(I_reg,"B",plant_type,T)=0;
*Inv_VNPTtype.up(I_reg,"B",plant_type,T)$(fuel_pot(I_reg,"B") gt 0 and T_num(T) le 2015)=15;
*Inv_VNPTtype.fx(I_reg,"H",plant_type,T)$(T_num(T) gt 2015)=0;
*VNPTtype.up(I_reg,"B",plant_type,T,year)=smax(year,sum(inv_year,Residual_P_thermal(I_reg,"B",plant_type,"capacity_el",year,inv_year)))-sum(inv_year,Residual_P_thermal(I_reg,"B",plant_type,"capacity_el",T,inv_year));
*VNPTtype.up(I_reg,"B",plant_type,T)$((VNPTtype.up(I_reg,"B",plant_type,T)-VNPTtype.up(I_reg,"B",plant_type,T-1)) lt 0)=0;
*VNPTtype.up(I_reg,"H",plant_type,T)=smax(year,sum(inv_year,Residual_P_thermal(I_reg,"H",plant_type,"capacity_el",year,inv_year)))-sum(inv_year,Residual_P_thermal(I_reg,"H",plant_type,"capacity_el",T,inv_year));
*VNPTtype.up(I_reg,"H",plant_type,T)$((VNPTtype.up(I_reg,"H",plant_type,T)-VNPTtype.up(I_reg,"H",plant_type,T-1)) lt 0)=0;

*Inv_VNPTtype.fx(I_reg,"O",plant_type,year)=0;
Inv_VNPTtype.fx(I_reg,"P",plant_type,year)=0;
Inv_VNPTtype.fx(I_reg,"U",plant_type,year)=0;

Inv_VNPTtype.up(nuclear_inv,"U","condens",year)$(T_num(year) ge 2020)=15;
$if %scenario% == "GP" Inv_VNPTtype.up(nuclear_inv,"U","condens",year)$(T_num(year) ge 2020)=0;

*Inv_VNPTtype.l(I_reg,thermal,plant_type,year)=0.3;
*Inv_VNPTtype.l(I_reg,"B",plant_type,year)=0;
*Inv_VNPTtype.l(I_reg,"O",plant_type,year)=0;
*Inv_VNPTtype.l("Germany","B",plant_type,T)=0;
VNPTtype1.fx(I_reg,thermal,plant_type,T,year)=0;
VNPTtype1.up(I_reg,thermal,plant_type,T,year)$(T_num(T) ge T_num(year)
         and T_num(T) lt T_num(year)+EPT_TL(I_reg,thermal,plant_type)
         and T_num(year) le T_num(T)
         and valid_thermal(I_reg,thermal,plant_type))=Inv_VNPTtype.up(I_reg,thermal,plant_type,year);
VNPTtype_5year.fx(I_reg,thermal,plant_type,T,fiveyear_period)=0;
VNPTtype_5year.up(I_reg,thermal,plant_type,T,fiveyear_period)=sum(year$(T_num(year) ge first_year5(fiveyear_period) and T_num(year) le last_year5(fiveyear_period)),
                 VNPTtype1.up(I_reg,thermal,plant_type,T,year));
*VNPTtype.up(I_reg,thermal,plant_type,T)=sum(year$(T_num(year) gt T_num(T-EPT_TL(I_reg,thermal,plant_type)) and T_num(year) le T_num(T)),
*                 Inv_VNPTtype.up(I_reg,thermal,plant_type,year));
VNPTtype.up(I_reg,thermal,plant_type,T)=sum(year,VNPTtype1.up(I_reg,thermal,plant_type,T,year));

*** Peak gas
Inv_VNPPgas.up(I_reg,year)=0;
Inv_VNPPgas.up(I_reg,year)$(T_num(year) ge 2010)=15;
* Limit for Luxembourg
Inv_VNPPgas.up(I_reg,year)$(sameas(I_reg, "Luxembourg") or sameas(I_reg,"LU")) = 0.1;
VNPPgas1.fx(I_reg,T,year)=0;
VNPPgas1.up(I_reg,T,year)$(T_num(T) ge T_num(year)
         and T_num(T) lt T_num(year)+TL_peakgas(I_reg)
         and T_num(year) le T_num(T))=Inv_VNPPgas.up(I_reg,year);
VNPPgas_5year.fx(I_reg,T,fiveyear_period)=0;
VNPPgas_5year.up(I_reg,T,fiveyear_period)=sum(year$(T_num(year) ge first_year5(fiveyear_period) and T_num(year) le last_year5(fiveyear_period)),
                 VNPPgas1.up(I_reg,T,year));
VNPPgas.up(I_reg,T)=sum(year$(T_num(year) gt T_num(T-TL_peakgas(I_reg)) and T_num(year) le T_num(T)),
                 Inv_VNPPgas.up(I_reg,year));


$if %national%==yes totP_nuclear_Ireg.up(I_reg,T)=nuclear_cap_lim(I_reg,T);
$ifi %regional%==yes totP_nuclear_dbcountry.up(dbcountry,T)$(nuclear_cap_lim(dbcountry,T)-sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum(tenyear_period,Residual_P_thermal_10(I_reg,"U","Condens","capacity_el",T,tenyear_period))) gt 0)=nuclear_cap_lim(dbcountry,T);
$ifi %regional%==yes totP_nuclear_dbcountry.up(dbcountry,T)$(nuclear_cap_lim(dbcountry,T)-sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum(tenyear_period,Residual_P_thermal_10(I_reg,"U","Condens","capacity_el",T,tenyear_period))) le 0)=sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum(tenyear_period,Residual_P_thermal_10(I_reg,"U","Condens","capacity_el",T,tenyear_period)));

*VNPTtype.up(nuclear_inv,"U","Condens",T)$(T_num(T) ge 2020 )=smax(year,sum(inv_year,Residual_P_thermal(nuclear_inv,"U","condens","capacity_el",year,inv_year)))-sum(inv_year,Residual_P_thermal(nuclear_inv,"U","condens","capacity_el",T,inv_year));

$ontext
VNPTtype.up(nuclear_inv,"U","condens",T)$(T_num(T) ge 2020)=smax(year,sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",year,inv_year)))*1.1-sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",T,inv_year));
VNPTtype.up(nuclear_inv,"U","condens",T)$(T_num(T) ge 2025)=smax(year,sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",year,inv_year)))*1.20-sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",T,inv_year));
VNPTtype.up(nuclear_inv,"U","condens",T)$(T_num(T) ge 2030)=smax(year,sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",year,inv_year)))*1.25-sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",T,inv_year));
VNPTtype.up(nuclear_inv,"U","condens",T)$(T_num(T) ge 2035)=smax(year,sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",year,inv_year)))*1.30-sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",T,inv_year));
VNPTtype.up(nuclear_inv,"U","condens",T)$(T_num(T) ge 2040)=smax(year,sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",year,inv_year)))*1.35-sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",T,inv_year));
VNPTtype.up(nuclear_inv,"U","condens",T)$(T_num(T) ge 2045)=smax(year,sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",year,inv_year)))*1.4-sum((plant_type,inv_year),Residual_P_thermal(nuclear_inv,"U",plant_type,"capacity_el",T,inv_year));

*$ontext
Inv_VNPTtype.up(I_reg,"U","condens",year)$(T_num(year) ge 2018 and country_num(I_reg)=8)=1.8;    !!Finland
VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2018 and country_num(I_reg)=8)=1.8;
VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2020 and country_num(I_reg)=8)=sum((plant_type,inv_year),Residual_P_thermal(I_reg,"U",plant_type,"capacity_el","2010",inv_year)-Residual_P_thermal(I_reg,"U",plant_type,"capacity_el",T,inv_year))+3.4;
*VNPTtype.up("Finland","U","condens",T)$(T_num(T) ge 2013)=0.953;
*VNPTtype.up("Finland","U","condens",T)$(T_num(T) ge 2014)=1.906;


VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2020 and country_num(I_reg)=22)=1.8;     !!Poland
VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2025 and country_num(I_reg)=22)=3.6;


VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2020 and country_num(I_reg)=3)=sum((plant_type,inv_year),Residual_P_thermal(I_reg,"U",plant_type,"capacity_el","2010",inv_year)-Residual_P_thermal(I_reg,"U",plant_type,"capacity_el",T,inv_year))+1.9061;
VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2020 and country_num(I_reg)=9)=sum((plant_type,inv_year),Residual_P_thermal(I_reg,"U",plant_type,"capacity_el","2010",inv_year)-Residual_P_thermal(I_reg,"U",plant_type,"capacity_el",T,inv_year))+1.8;
VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2018 and country_num(I_reg)=17)=1.6;
VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2020 and country_num(I_reg)=17)=sum((plant_type,inv_year),Residual_P_thermal(I_reg,"U",plant_type,"capacity_el","2010",inv_year)-Residual_P_thermal(I_reg,"U",plant_type,"capacity_el",T,inv_year))+1.6;
VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2018 and country_num(I_reg)=24)=1.44;
VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2020 and country_num(I_reg)=24)=sum((plant_type,inv_year),Residual_P_thermal(I_reg,"U",plant_type,"capacity_el","2010",inv_year)-Residual_P_thermal(I_reg,"U",plant_type,"capacity_el",T,inv_year))+1.44;
*VNPTtype.up("Slovakia","U","condens",T)$(T_num(T) ge 2012)=0.408;
*VNPTtype.up("Slovakia","U","condens",T)$(T_num(T) ge 2013)=0.816;
VNPTtype.up(I_reg,"U","condens",T)$(T_num(T) ge 2020 and country_num(I_reg)=25)=sum((plant_type,inv_year),Residual_P_thermal(I_reg,"U",plant_type,"capacity_el","2010",inv_year)-Residual_P_thermal(I_reg,"U",plant_type,"capacity_el",T,inv_year))+0.8161;
$offtext


VNPTtype.up(I_reg,"B",plant_type,T)=smax(year,sum(inv_year,Residual_P_thermal(I_reg,"B",plant_type,"capacity_el",year,inv_year)))-sum(inv_year,Residual_P_thermal(I_reg,"B",plant_type,"capacity_el",T,inv_year));
VNPTtype.up(I_reg,"B",plant_type,T)$((VNPTtype.up(I_reg,"B",plant_type,T)-VNPTtype.up(I_reg,"B",plant_type,T-1)) lt 0)=0;
VNPTtype.up(I_reg,"H",plant_type,T)=smax(year,sum(inv_year,Residual_P_thermal(I_reg,"H",plant_type,"capacity_el",year,inv_year)))-sum(inv_year,Residual_P_thermal(I_reg,"H",plant_type,"capacity_el",T,inv_year));
VNPTtype.up(I_reg,"H",plant_type,T)$((VNPTtype.up(I_reg,"H",plant_type,T)-VNPTtype.up(I_reg,"H",plant_type,T-1)) lt 0)=0;


*$ontext
loop(T,
         min_year_lig(I_reg,plant_type)$(VNPTtype.up(I_reg,"B",plant_type,T) eq smin(year,VNPTtype.up(I_reg,"B",plant_type,year)))=2009+ord(T);
)
;
VNPTtype.up(I_reg,"B",plant_type,T)$(T_num(T) lt min_year_lig(I_reg,plant_type))=0;

loop(T,
         min_year_coal(I_reg,plant_type)$(VNPTtype.up(I_reg,"H",plant_type,T) eq smin(year,VNPTtype.up(I_reg,"H",plant_type,year)))=2009+ord(T);
)
;
VNPTtype.up(I_reg,"H",plant_type,T)$(T_num(T) lt min_year_coal(I_reg,plant_type))=0;
*$offtext


VEETtype1.up(I_reg,thermal,plant_type,T,tenyear_period,Time_step)=Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period)*EPT_LF(I_reg,thermal,plant_type)*Time_step_length(Time_step);
VEETtype1.fx(I_reg,thermal,plant_type,T,tenyear_period,Time_step)$(Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period) eq 0)=0;

VEHTtype1.up(I_reg,thermal,C_HP,T,tenyear_period,Time_step)=Residual_P_thermal_10(I_reg,thermal,C_HP,"capacity_heat",T,tenyear_period)*EPT_LF(I_reg,thermal,C_HP)*Time_step_length(Time_step);
VEHTtype1.fx(I_reg,thermal,C_HP,T,tenyear_period,Time_step)$(Residual_P_thermal_10(I_reg,thermal,C_HP,"capacity_heat",T,tenyear_period) eq 0)=0;

VEFTtype1.up(I_reg,thermal,plant_type,T,tenyear_period,Time_step)=Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_boiler",T,tenyear_period)*EPT_LF(I_reg,thermal,plant_type)*Time_step_length(Time_step);
VEFTtype1.fx(I_reg,thermal,plant_type,T,tenyear_period,Time_step)$(Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_boiler",T,tenyear_period) eq 0)=0;

VEETtype.up(I_reg,thermal,plant_type,T)=sum((tenyear_period,Time_step),VEETtype1.up(I_reg,thermal,plant_type,T,tenyear_period,Time_step));
VEHTtype.up(I_reg,thermal,C_HP,T)=sum((tenyear_period,Time_step),VEHTtype1.up(I_reg,thermal,C_HP,T,tenyear_period,Time_step));
VEFTtype.up(I_reg,thermal,plant_type,T)=sum((tenyear_period,Time_step),VEFTtype1.up(I_reg,thermal,plant_type,T,tenyear_period,Time_step));

VNETtype1.fx(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)=0;
VNETtype1.up(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)$(valid_thermal(I_reg,thermal,plant_type) and T_num(T) ge first_year5(fiveyear_period))=
         VNPTtype_5year.up(I_reg,thermal,plant_type,T,fiveyear_period)*EPT_LF(I_reg,thermal,plant_type)*Time_step_length(Time_step);
VNHTtype1.fx(I_reg,thermal,C_HP,T,fiveyear_period,Time_step)=0;
VNHTtype1.up(I_reg,thermal,C_HP,T,fiveyear_period,Time_step)$(valid_thermal(I_reg,thermal,C_HP) and T_num(T) ge first_year5(fiveyear_period))=
         VNETtype1.up(I_reg,thermal,C_HP,T,fiveyear_period,Time_step)/EPT_alfa_5year(thermal,C_HP,fiveyear_period);
VNFTtype1.fx(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)=0;
VNFTtype1.up(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)$(valid_thermal(I_reg,thermal,plant_type) and T_num(T) ge first_year5(fiveyear_period))=
         VNETtype1.up(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)/eta_el_5year(thermal,plant_type,fiveyear_period);
VNETtype.up(I_reg,thermal,plant_type,T)=VNPTtype.up(I_reg,thermal,plant_type,T)*EPT_LF(I_reg,thermal,plant_type)*8.76;
VNHTtype.up(I_reg,thermal,C_HP,T)=sum((fiveyear_period,Time_step),VNHTtype1.up(I_reg,thermal,C_HP,T,fiveyear_period,Time_step));
VNFTtype.up(I_reg,thermal,plant_type,T)=sum((fiveyear_period,Time_step),VNFTtype1.up(I_reg,thermal,plant_type,T,fiveyear_period,Time_step));

***Peak gas
VNEPgas1.fx(I_reg,T,fiveyear_period,Time_step)=0;
VNEPgas1.up(I_reg,T,fiveyear_period,Time_step)$(T_num(T) ge first_year5(fiveyear_period))=
         VNPPgas_5year.up(I_reg,T,fiveyear_period)*LF_peakgas(I_reg)*Time_step_length(Time_step);
VNFPgas1.fx(I_reg,T,fiveyear_period,Time_step)=0;
VNFPgas1.up(I_reg,T,fiveyear_period,Time_step)$(T_num(T) ge first_year5(fiveyear_period))=
         VNEPgas1.up(I_reg,T,fiveyear_period,Time_step)/eta_el_5year_Pgas(fiveyear_period);
VNEPgas.up(I_reg,T)=VNPPgas.up(I_reg,T)*LF_peakgas(I_reg)*8.76;
VNFPgas.up(I_reg,T)=sum((fiveyear_period,Time_step),VNFPgas1.up(I_reg,T,fiveyear_period,Time_step));

*VPT_Lh_exist.up(I_reg,thermal,plant_type,T)=EPT_LF(I_reg,thermal,plant_type)*8.76;
*VPT_Lh_exist.l(I_reg,thermal,plant_type,T)=VPT_Lh_exist.up(I_reg,thermal,plant_type,T);
*VPT_Lh_new.up(I_reg,thermal,plant_type,T)=EPT_LF(I_reg,thermal,plant_type)*8.76;
*VPT_Lh_new.l(I_reg,thermal,plant_type,T)=VPT_Lh_new.up(I_reg,thermal,plant_type,T);
*VPT_Lh_new.lo(I_reg,thermal,plant_type,T)=0.2;
*VPT_Lh_new.lo(I_reg,"G",plant_type,T)=0.05;

*** others ***
Inv_VNPO.up(I_reg,non_PV,T)=0;
Inv_VNPO.up(I_reg,non_PV,T)$(T_num(T) ge 2010)=15;
*Inv_VNPO.up(I_reg,others,T)$(T_num(T) lt 2010)=0;
*Inv_VNPO.up(I_reg,"PV",T)=0;

VNPO.up(I_reg,non_PV,T)=sum(year$(T_num(year) gt T_num(T-NPO_TL(I_reg,non_PV)) and T_num(year) le T_num(T)),
                 Inv_VNPO.up(I_reg,non_PV,year));

VNPO.up(I_reg,"small_hydro",T)=0;
*VNPO.up(I_reg,"PV",T)=0;

VNPO.up(I_reg,"small_hydro",T)$(sum(Time_step,LFO(I_reg,"small_hydro",Time_step)) gt 0)=small_RO_pot(I_reg,"small_hydro")/sum(time_step,LFO(I_reg,"small_hydro",Time_step));


*VPGEO_Lh.up(I_reg,geothermal,T)=NPGEO_LF(I_reg,geothermal)*8.76;
*VPGEO_Lh.l(I_reg,geothermal,T)=NPGEO_LF(I_reg,geothermal)*8.76;
*VPGEO_Lh.lo(I_reg,geothermal,T)=0.2;
Inv_VNPGEO.up(I_reg,geothermal,T)=0;
Inv_VNPGEO.up(I_reg,geothermal,T)$(T_num(T) ge 2020)=10;


*** CO2 limitations for whole region
parameters
emission_cap(I_reg,T)
em_1990(I_reg)                   CO2 emissions in 1990
em_2003(I_reg)                   CO2 emissions in 2003
reduct_2020(I_reg)               percentual reduction in relation to 1990
reduct_2030(I_reg)               percentual reduction in relation to 1990
reduct_2050(I_reg)               percentual reduction in relation to 1990
target_2020(I_reg)               emission cap in 2020
target_2030(I_reg)               emission cap in 2020
target_2050(I_reg)               emission cap in 2050
;

em_1990(I_reg)=CO2_reference(I_reg,"1990");

em_2003(I_reg)=CO2_reference(I_reg,"2003");

$if %scenario%=="REF" reduct_2020(I_reg)=0.3;
$if %scenario%=="CM" reduct_2020(I_reg)=0.3;
$if %scenario%=="RP" reduct_2020(I_reg)=0.3;
$if %scenario%=="GP" reduct_2020(I_reg)=0.3;
$if %scenario%=="REF" reduct_2030(I_reg)=0.5;
$if %scenario%=="CM" reduct_2030(I_reg)=0.5;
$if %scenario%=="RP" reduct_2030(I_reg)=0.5;
$if %scenario%=="GP" reduct_2030(I_reg)=0.5;
$if %scenario%=="REF" reduct_2050(I_reg)=0.6;
$if %scenario%=="CM" reduct_2050(I_reg)=0.93;
$if %scenario%=="RP" reduct_2050(I_reg)=0.99;
$if %scenario%=="GP" reduct_2050(I_reg)=0.93;

target_2020(I_reg)=em_1990(I_reg)*(1-reduct_2020(I_reg));
target_2030(I_reg)=em_1990(I_reg)*(1-reduct_2030(I_reg));
target_2050(I_reg)=em_1990(I_reg)*(1-reduct_2050(I_reg));

*VCO2_reg.lo(I_reg,T)=0;

emission_cap(I_reg,T)$(T_num(T) lt 2020)=
         em_2003(I_reg)-(((em_2003(I_reg)-target_2020(I_reg))/17)*(T_num(T)-2003));

emission_cap(I_reg,T)$(T_num(T) ge 2020 and T_num(T) lt 2030)=
         target_2020(I_reg)-(((target_2020(I_reg)-target_2030(I_reg))/10)*(T_num(T)-2020));

emission_cap(I_reg,T)$(T_num(T) ge 2030)=
         target_2030(I_reg)-(((target_2030(I_reg)-target_2050(I_reg))/20)*(T_num(T)-2030));


VCO2.up(T)=sum(I_reg,emission_cap(I_reg,T));
*VCO2.l(T)=sum(I_reg,emission_cap(I_reg,T));

$if %scenario% == "REF" CCS_intro(CCS)=2025;
$if %scenario% == "REF" CCS_intro(CCS_bio)=2030;
$if %scenario% == "CM" CCS_intro(CCS)=2025;
$if %scenario% == "CM" CCS_intro(CCS_bio)=2030;
$if %scenario% == "RP" CCS_intro(CCS)=2030;
$if %scenario% == "RP" CCS_intro(CCS_bio)=2035;
$if %scenario%=="GP" CCS_intro(CCS)=2025;
$if %scenario%=="GP" CCS_intro(CCS_bio)=2030;

Inv_VNPCCStype.fx(I_reg,CCS,plant_type,year)=0;
Inv_VNPCCStype.up(I_reg,"BCCS","Condens",year)$(valid_CCS(I_reg,"BCCS","Condens") and T_num(year) ge CCS_intro("BCCS") and fuel_pot(I_reg,"B") gt 0)=5;
Inv_VNPCCStype.up(I_reg,"HCCS","Condens",Year)$(valid_CCS(I_reg,"HCCS","Condens") and T_num(year) ge CCS_intro("HCCS"))=5;
Inv_VNPCCStype.up(I_reg,"GCCS","Condens",Year)$(valid_CCS(I_reg,"GCCS","Condens") and T_num(year) ge CCS_intro("GCCS"))=5;
Inv_VNPCCStype.up(I_reg,"BWCCS","Condens",Year)$(valid_CCS(I_reg,"BWCCS","Condens") and T_num(year) ge CCS_intro("BWCCS") and fuel_pot(I_reg,"B") gt 0)=5;
Inv_VNPCCStype.up(I_reg,"HWCCS","Condens",Year)$(valid_CCS(I_reg,"HWCCS","Condens") and T_num(year) ge CCS_intro("HWCCS"))=5;

$if %scenario%=="GP" Inv_VNPCCStype.fx(I_reg,CCS,plant_type,year)=0;

VNPCCStype1.up(I_reg,CCS,plant_type,T,year)=0;
VNPCCStype1.up(I_reg,CCS,plant_type,T,year)$(valid_CCS(I_reg,CCS,plant_type) and T_num(T) ge T_num(year) and T_num(T) lt T_num(year)+NPCCS_TL(I_reg,CCS,plant_type))=Inv_VNPCCStype.up(I_reg,CCS,plant_type,year);
VNPCCStype_5year.fx(I_reg,CCS,plant_type,T,fiveyear_period)=0;
VNPCCStype_5year.up(I_reg,CCS,plant_type,T,fiveyear_period)=sum(year$(T_num(year) ge first_year5(fiveyear_period) and T_num(year) le last_year5(fiveyear_period)),
                 VNPCCStype1.up(I_reg,CCS,plant_type,T,year));
VNPCCStype.up(I_reg,CCS,plant_type,T)=sum(year$(T_num(year) gt T_num(T-NPCCS_TL(I_reg,CCS,plant_type)) and T_num(year) le T_num(T)),
                 Inv_VNPCCStype.up(I_reg,CCS,plant_type,year));

$if %scenario%=="GP" VNPCCStype1.up(I_reg,CCS,plant_type,T,year)=0;

VNECCStype1.fx(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)=0;
VNECCStype1.up(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)$(valid_CCS(I_reg,CCS,plant_type) and T_num(T) ge first_year5(fiveyear_period))=
         VNPCCStype_5year.up(I_reg,CCS,plant_type,T,fiveyear_period)*NPCCS_LF(I_reg,CCS,plant_type)*Time_step_length(Time_step);
VNFCCStype1.fx(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)=0;
VNFCCStype1.up(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)$(valid_CCS(I_reg,CCS,plant_type) and T_num(T) ge first_year5(fiveyear_period))=
         VNECCStype1.up(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)/eta_elCCS_5year(CCS,plant_type,fiveyear_period);
VNECCStype.up(I_reg,CCS,plant_type,T)=VNPCCStype.up(I_reg,CCS,plant_type,T)*NPCCS_LF(I_reg,CCS,plant_type)*8.76;

$if %scenario%=="GP" VNECCStype1.fx(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)=0;


*Inv_VNPCCStype.l(I_reg,"BCCS","Condens",year)$(T_num(year) ge 2020 and fuel_pot(I_reg,"B") gt 0)=10;
*Inv_VNPCCStype.l(I_reg,"HCCS","Condens",year)$(T_num(year) ge 2020)=1;
