********************************************************************
***      Definition of parameters in model                       ***
***                                                              ***
********************************************************************

Parameters
demand_in(I_reg,start)                  Base year net electrcity demand [TWh]
*demand_GR(I_reg,T)                      Percentual growth rate per year
product_GR(I_reg,T)                     Product of annual growth rates
demand(I_reg,T)                         Net electrcity demand per year [TWh]
demand_RES_in(I_reg,RES_years)          RES energy profiles per country [fraction of tot demand]
CO2_reference(I_reg,CO2_years)           Referens emissions in Mton in 1990 and 2003
demand_heat_in(I_reg,eco_years)         Net heat demand at start and end-year
demand_heat(I_reg,T)                    Net heat demand
*CHP_indicator_in(I_reg,EET_years)       percent CHP electrcity at EET years
*CHP_indicator(I_reg,T)                  percent CHP electrcity annually
CHP_fraction_in(I_reg,eco_years)       percent CHP electrcity at EET years
CHP_fraction(I_reg,T)                  percent CHP electrcity annually
*demand_CHP_el(I_reg,T)                  Net CHP electrcity demand
demand_CHP(I_reg,T)                     Net CHP heat demand
demand_CHP_timestep(I_reg,T,Time_step)                     Net CHP heat demand
demand_BP_in(I_reg,former_start)                     Net CHP heat demand
demand_BP(I_reg,T)                     Net CHP heat demand
demand_RES(I_reg,T)
load_profile(an_hour,I_reg)             Load profiles from hourly load curves
heat_load_profile(an_hour,I_reg)
demand_timestep(I_reg,T,Time_step)      electrcity demand within each timestep
Time_step_length(Time_step)              Hours in each time step


*residual_P_windclass(I_reg,wind_class,T)
*EEW1(I_reg,wind_class,T,Time_step)                        Generation in present wind capacities [TWh]
*EEW(I_reg,wind_class,T)                        Generation in present wind capacities [TWh]
EEW1_nuts2(nuts2,T,Time_step)
EEW1(I_reg,T,Time_step)
EEW(I_reg,T)

residual_P_hydroclass(I_reg,hydro_class,T)
EEH1_RO(I_reg,T,Time_step)                       Generation in present hydro capacities [TWh]
EEH_RO(I_reg,T)                       Generation in present hydro capacities [TWh]
EEO1(I_reg,non_PV,T,Time_step)      Generation in present other capacities [TWh] per time step
EEO(I_reg,non_PV,T)      Generation in present other capacities [TWh]

Residual_P_thermal_10(I_reg,thermal,plant_type,cap_prop,T,tenyear_period)

EPT_LF(I_reg,thermal,plant_type)        Maximum annual load factor thermal
others_full_Lh(I_reg,others)
*EPW_LF1(an_hour,I_reg,wind_class)
EPW_LF1_nuts(an_hour,nuts2)           Load factor statistics
wind_full_Lh(I_reg,wind_type)
Wind_full_Lh_nuts(nuts2)
EPW_LF(an_hour,nuts2,wind_type)
EPW_LF_nuts(an_hour,nuts2)           Load factor statistics
EPH_LF(an_hour,I_reg)          Load factor statistics
EPO_LF1(an_hour,I_reg,others)           Production profile normalized to fractions of annual prod per hour
EPO_LF(an_hour,I_reg,others)            Production profile in actual power output from the installed capacity per hour
*NPO_LF(I_reg,others,statistics)         Load factor statistics
NPGEO_LF(I_reg,geothermal)              Maximum annual load factor geothermal
NPCCS_LF(I_reg,CCS,plant_type)          Maximum annual load factor CCS
LFW(nuts2,wind_type,Time_step)                    Load factor wind capacities for present turbines [kh time step]
LFW_nuts2(nuts2,Time_step)                    Load factor wind capacities for present turbines [kh time step]
LFH(I_reg,Time_step)                       Load factor hydro capacities for all hydro [kh per time step]
LFO(I_reg,others,Time_step)                      Load factor others [kh per time step]

TL_num(TL_year)                          Convert years into numbers
EPT_TL(I_reg,thermal,plant_type)         Technical lifetime thermal capacities
EPW_TL(nuts2)                       Technical lifetime wind capacities
EPSol_TL(solar_type)                Technical lifetime solar capacities
EPH_TL(I_reg,hydro_class)                      Technical lifetime hydro capacities
NPCCS_TL(I_reg,CCS,plant_type)           Technical lifetime CCS capacities
NPO_TL(I_reg,others)                     Technical lifetime other capacities
NPGEO_TL(I_reg,geothermal)               Technical lifetime geothermal capacities
EPStorage_TL(storage_systems)               Technical lifetime storage capacities

EPT_alfa(thermal,C_HP,T)                 Calculated alfa value thermal CHP capacities
EPT_alfa_5year(thermal,C_HP,fiveyear_period)                 Calculated alfa value thermal CHP capacities
eta_T_factors(thermal,plant_type,eta_prop)       Shaping factors for eta function
eta_CCS_factors(CCS,plant_type,eta_prop) Shaping factors for eta function
eta_tot(thermal,T)                       Calculated total efficiency for CHP plants
eta_el(thermal,plant_type,T)
eta_el_5year(thermal,plant_type,fiveyear_period)
eta_elCCS(CCS,plant_type,T)
eta_elCCS_5year(CCS,plant_type,fiveyear_period)

bio_fraction(CCS_bio)                    Biomass fraction in CCS co-combustion alternatives
Cum_bio_supply2020(I_reg,bio_class)     Cumulative biomass supplies in the biomass classes by 2020 PJ per year
Cum_bio_supply2050(I_reg,bio_class)     Cumulative biomass supplies in the biomass classes by 2050 PJ per year
Biomass_supply(I_reg,bio_class,T)       Biomass potential per biomass class I_reg and year
Cum_waste_supply2020(I_reg,waste_class)
Cum_waste_supply2050(I_reg,waste_class)
waste_supply(I_reg,waste_class,T)        Waste potential per biomass class I_reg and year

NPT_Ic(I_reg,thermal,plant_type,inv_prop,year)    Investment costs for new facilities
NPH_Ic(I_reg,hydro_class,inv_prop,year)                   Investment costs for new facilities
NPW_Ic(nuts2,wind_type,inv_prop,year)                    Investment costs for new facilities
NPO_Ic(I_reg,others,inv_prop,year)                  Investment costs for new facilities
NPCCS_Ic(I_reg,CCS,plant_type,inv_prop,year)      Investment costs for new facilities
*NPCCS_Ic_year(I_reg,CCS,plant_type,inv_prop,year)      Investment costs for new facilities
NPGEO_Ic(I_reg,geothermal,inv_prop,year)             Investment costs for new facilities
EPT_OM(I_reg,thermal,plant_type,OM_prop)     Operation and maintainance costs
EPH_OM(I_reg,hydro,OM_prop)                    Operation and maintainance costs
EPW_OM(I_reg,wind_type,OM_prop,year)               Operation and maintainance costs
NPCCS_OM(I_reg,CCS,plant_type,OM_prop)                     Operation and maintainance costs
EPO_OM(I_reg,others,OM_prop)                   Operation and maintainance costs
NPGEO_OM(I_reg,geothermal,OM_prop)                   Operation and maintainance costs
Fc(I_reg,thermal,T)                            Fuel costs over time
Fc_national_bio(I_reg,bio_class)                       National biomass costs in the biomass supply classes M per TWh
Fc_national_waste(I_reg,waste_class)
LHV(I_reg,thermal)                             Lower heating values for carbon emitting technologies
C_intensity(I_reg,thermal)                     Carbon intensity [kg C per GJ fuel]
C_EF(I_reg,thermal)                            Carbon emission factor [ton CO2 per ton fuel]
CCS_capt(CCS)                                    CCS capture factor
CCS_EF(I_reg,CCS)                                CO2 emissions from CCS Units after capture
CCS_store_EF(I_reg,CCS)                          Captured CO2 from CCS units
Fc_CCS(I_reg,CCS,T)                              Levelized fuel costs in CCS units
CCS_intro(CCS)                                   Year of introduction for each class

CO2_store_cost(I_reg,store_prop)
*CO2_tran_cost(I_reg,T)                          CO2 Transportation costs [ per ton]
*CO2_store_cost(I_reg,T)                         CO2 storage costs [ per ton]

NEStorage_Ic(storage_systems,I_reg,year)            Investment cost for battery storage [MEUR per TWh]
NEStorage_OM(storage_systems,I_reg,OM_prop,year)    O&M costs for battery storage [MEUR per TWh]

system_cap_factor(I_reg,T)                       Capacity to generation factor
system_cap_nordic(T)                             Capacity to generation factor

system_max_load(I_reg,T)                         Maximum connected load during the year [GW]
system_max_load_nordic(T)                        Maximum connected load during the year [GW]

cap_factor_wind_exist(nuts2)
cap_factor_wind_new(nuts2,wind_type)
cap_factor_solar_new(solar_type,solar_sites)
cap_factor_solar_exist(solar_type,nuts2)
cap_factor_hydro(I_reg,hydro_class)
cap_factor_others(I_reg,others)
cap_factor_thermal(I_reg,thermal,plant_type)
cap_factor_CCS(I_reg,CCS,plant_type)
cap_factor_geothermal(I_reg,geothermal)

hydro_stat(regions,hydro)                         Current installed capacity in Hydro stations GW
hydro_prod(regions,hydro_class)
hydro_prod_max(regions,hydro_class,T)
fuel_pot(I_reg,thermal_pot)                     Fuel potential for lignite and biomass TWh fuel
wind_pot(nuts2,wind_type)                            Wind potentials TWh el
wind_input(an_hour,nuts2)                        power prod in percent of installed power per annual hour
wind_profile(an_hour,nuts2)                      Wind profile per nuts I_reg normalized to 1 for the year
BP_E_in(I_reg,B_P)                              Current BP levels TWh el
small_RO_pot(I_reg,small_RO)                    potentials for small scale hydro
upper_lim_hydro(I_reg,T)                        Upper limits hydro RO
min_year_hydro(I_reg)
upper_lim_wind(nuts2,wind_type,T)                        Upper limits Wind
min_year_wind(I_reg,wind_type)
min_year_lig(I_reg,plant_type)
min_year_coal(I_reg,plant_type)

first_year10(tenyear_period)
last_year10(tenyear_period)
first_year5(fiveyear_period)
last_year5(fiveyear_period)

EPCON(exp_region,imp_region)
NP_trade_Ic(export_reg,import_reg,year)

*** Peak gas
TL_peakgas(I_reg)
LF_peakgas(I_reg)
eta_el_5year_Pgas(fiveyear_period)
NPPgas_Ic(I_reg,inv_prop,year)
EPPgas_OM(I_reg,OM_prop)
cap_factor_Pgas(I_reg)
cap_factor_intercon(I_reg)

wind_CF(nuts2,wind_type)
solar_input_systems(solar_systems,solar_sites,an_hour)
solar_input(solar_type,solar_sites,an_hour)
Solar_full_Lh_sites(solar_type,solar_sites)
Solar_profile(solar_type,solar_sites,an_hour)
EPS_LF(solar_type,solar_sites,an_hour)
NPSol_Ic(solar_type,solar_sites,Inv_prop,year)
EPSol_OM(solar_type,I_reg,OM_prop,year)

LFS(solar_type,solar_sites,Time_step)

EESol1_nuts2(nuts2,T,Time_step)
EESol1(I_reg,T,Time_step)
EESol(I_reg,T)
upper_lim_solar(nuts2,T)
solar_cap_intensity(solar_type)
solar_pot_buildings(solar_sites)
solar_pot_centralized(solar_sites)

* Storage parameters
storageEfficiency(storage_systems)            Round-trip efficiency of storage




* exponential learning curve cost coefficients
solar_invest_cost_coef_a(solar_type)
solar_invest_cost_coef_b(solar_type)
solar_fixed_OM_cost_coef_a(solar_type)
solar_fixed_OM_cost_coef_b(solar_type)
wind_invest_cost_coef_a(wind_systems)
wind_invest_cost_coef_b(wind_systems)
wind_fixed_OM_cost_coef_a(wind_systems)
wind_fixed_OM_cost_coef_b(wind_systems)
storage_invest_cost_coef_a(storage_systems)
storage_invest_cost_coef_b(storage_systems)

Solar_deduct(I_reg,TWh,T)
*Residential_el(dbcountry)
solar_mean_FLH(I_reg)
solar_deduct_input(dbcountry)
;


Scalar
wind_cap_factor
NP_trade_TL
Wind_cap_intensity
iter
USD_to_EUR

;


TL_num(TL_year)=ord(TL_year);
first_year10(tenyear_period)=(ord(tenyear_period)-1)*10+1900;
last_year10(tenyear_period)=(ord(tenyear_period)-1)*10+1909;
last_year10("10year_15")=2050;
first_year5(fiveyear_period)=(ord(fiveyear_period)-1)*5+2010;
*first_year5("5year_1")=2003;
last_year5(fiveyear_period)=(ord(fiveyear_period)-1)*5+2014;
last_year5("5year_8")=2050;


display first_year5,first_year10,last_year5,last_year10;

