$oneolcom
***      Set calculus interest rate                     ***
* Sensitivity analysis Ir = 0: zero discount rate
Ir=0.05;

*Set USD to EUR conversion rate 2012 from WEIO2014PGAssumptions
USD_to_EUR = 0.78;

**DEMAND***
product_GR(I_reg,T)=demand(I_reg,T)/demand_in(I_reg,"2010");
*demand(I_reg,T)=demand_in(I_reg,"2010")*product_GR(I_reg,T)/1000;

*** DEMAND RES ***
set RES_years1020(RES_years)
         /2010*2020/
;
loop((T,RES_years1020),
demand_RES(I_reg,T)$(T_num(T) ge 2010 and T_num(T) le 2020 and ord(T) eq ord(RES_years1020))=demand_RES_in(I_reg,RES_years1020);
)
;
demand_RES(I_reg,"2010")=demand_RES_in(I_reg,"2010");
demand_RES(I_reg,"2011")=demand_RES_in(I_reg,"2011");
demand_RES(I_reg,"2012")=demand_RES_in(I_reg,"2012");
demand_RES(I_reg,"2013")=demand_RES_in(I_reg,"2013");
demand_RES(I_reg,"2014")=demand_RES_in(I_reg,"2014");
demand_RES(I_reg,"2015")=demand_RES_in(I_reg,"2015");
demand_RES(I_reg,"2016")=demand_RES_in(I_reg,"2016");
demand_RES(I_reg,"2017")=demand_RES_in(I_reg,"2017");
demand_RES(I_reg,"2018")=demand_RES_in(I_reg,"2018");
demand_RES(I_reg,"2019")=demand_RES_in(I_reg,"2019");
demand_RES(I_reg,"2020")=demand_RES_in(I_reg,"2020");
$if %Scenario% == "RP" demand_RES(I_reg,T)$(T_num(T) ge 2020 and T_num(T) lt 2025)=demand_RES_in(I_reg,"2020")+(T_num(T)-2020)*((demand_RES_in(I_reg,"2025")-demand_RES_in(I_reg,"2020"))/5);
$if %Scenario% == "RP" demand_RES(I_reg,T)$(T_num(T) ge 2025 and T_num(T) lt 2030)=demand_RES_in(I_reg,"2025")+(T_num(T)-2025)*((demand_RES_in(I_reg,"2030")-demand_RES_in(I_reg,"2025"))/5);
$if %Scenario% == "RP" demand_RES(I_reg,T)$(T_num(T) ge 2030 and T_num(T) lt 2040)=demand_RES_in(I_reg,"2030")+(T_num(T)-2030)*((demand_RES_in(I_reg,"2040")-demand_RES_in(I_reg,"2030"))/10);
$if %Scenario% == "RP" demand_RES(I_reg,T)$(T_num(T) ge 2040 and T_num(T) lt 2050)=demand_RES_in(I_reg,"2040")+(T_num(T)-2040)*((demand_RES_in(I_reg,"2050")-demand_RES_in(I_reg,"2040"))/10);
$if %Scenario% == "RP" demand_RES(I_reg,T)$(T_num(T) eq 2050)=demand_RES_in(I_reg,"2050");

display demand_RES;

demand_heat(I_reg,T)=(demand_heat_in(I_reg,"2003")+((demand_heat_in(I_reg,"2050")-demand_heat_in(I_reg,"2003"))/47)*(T_num(T)-2003))/1000;
$ontext
CHP_indicator(I_reg,T)$(T_num(T) ge 2010 and T_num(T) lt 2015)=((CHP_indicator_in(I_reg,"2015")-CHP_indicator_in(I_reg,"2010"))/5)*(T_num(T)-2010)+CHP_indicator_in(I_reg,"2010");
CHP_indicator(I_reg,T)$(T_num(T) ge 2015 and T_num(T) lt 2020)=((CHP_indicator_in(I_reg,"2020")-CHP_indicator_in(I_reg,"2015"))/5)*(T_num(T)-2015)+CHP_indicator_in(I_reg,"2015");
CHP_indicator(I_reg,T)$(T_num(T) ge 2020 and T_num(T) lt 2025)=((CHP_indicator_in(I_reg,"2025")-CHP_indicator_in(I_reg,"2020"))/5)*(T_num(T)-2020)+CHP_indicator_in(I_reg,"2020");
CHP_indicator(I_reg,T)$(T_num(T) ge 2025)=((CHP_indicator_in(I_reg,"2030")-CHP_indicator_in(I_reg,"2025"))/5)*(T_num(T)-2025)+CHP_indicator_in(I_reg,"2025");

demand_CHP_el(I_reg,T)=demand(I_reg,T)*CHP_indicator(I_reg,T)/100;
$offtext

CHP_fraction(I_reg,T)=CHP_fraction_in(I_reg,"2003")+((CHP_fraction_in(I_reg,"2050")-CHP_fraction_in(I_reg,"2003"))/47)*(T_num(T)-2003);

demand_BP(I_reg,T)=demand_BP_in(I_reg,"2003")/1000;
demand_CHP(I_reg,T)=demand_heat(I_reg,T)*CHP_fraction(I_reg,T)-demand_BP(I_reg,"2010");
***FUEL***
Fc(I_reg,thermal,T)$(T_num(T) lt 2010)=Fc_in(thermal,"2000")+(T_num(T)-2000)*((Fc_in(thermal,"2010")-Fc_in(thermal,"2000"))/10);
Fc(I_reg,thermal,T)$(T_num(T) ge 2010 and T_num(T) lt 2015)=Fc_in(thermal,"2010")+(T_num(T)-2010)*((Fc_in(thermal,"2015")-Fc_in(thermal,"2010"))/5);
Fc(I_reg,thermal,T)$(T_num(T) ge 2015 and T_num(T) lt 2020)=Fc_in(thermal,"2015")+(T_num(T)-2015)*((Fc_in(thermal,"2020")-Fc_in(thermal,"2015"))/5);
Fc(I_reg,thermal,T)$(T_num(T) ge 2020 and T_num(T) lt 2025)=Fc_in(thermal,"2020")+(T_num(T)-2020)*((Fc_in(thermal,"2025")-Fc_in(thermal,"2020"))/5);
Fc(I_reg,thermal,T)$(T_num(T) ge 2025 and T_num(T) lt 2030)=Fc_in(thermal,"2025")+(T_num(T)-2025)*((Fc_in(thermal,"2030")-Fc_in(thermal,"2025"))/5);
Fc(I_reg,thermal,T)$(T_num(T) ge 2030)=Fc_in(thermal,"2030")+(T_num(T)-2030)*((Fc_in(thermal,"2035")-Fc_in(thermal,"2030"))/5);
*!! 1.3245 conversion from dollars to Euro WEO 2011, 1.6998 conv from boe to MWh
Fc(I_reg,thermal,T)=Fc(I_reg,thermal,T)/(1.3245*1.6998);

$if not %linear_fossil_cost_supply% == "yes" $goto nofossilcostsupply
***** Linear cost-supply on fuels from WEO2011 based on current policy, new policy and 450 scenario

Set
cost_supply(thermal)
/B
H
G
/

cs_par /k_cost,m_cost/
;

Parameter linear_cost_parameters(cost_supply,cs_par);
linear_cost_parameters("H","k_cost")=0.0039;                            !!WEO2013 (old WEO 2011 0.0032)
linear_cost_parameters("H","m_cost")=5.6634;                            !!WEO2013 (old WEO 2011 5.8613)
linear_cost_parameters("G","k_cost")=0.0117;                            !!WEO2013 (old WEO 2011 0.0055)
linear_cost_parameters("G","m_cost")=13.733;                            !!WEO2013 (old WEO 2011 18.332)
linear_cost_parameters("B",cs_par)=0.55839416*linear_cost_parameters("H",cs_par);

Parameter
Fc_linear_cost_supply_fossil(cost_supply,TWh)
;

Fc_linear_cost_supply_fossil("B",TWh)=0.55839409*(ord(TWh)*0.0032+5.8613);
Fc_linear_cost_supply_fossil("H",TWh)=ord(TWh)*0.0032+5.8613;
Fc_linear_cost_supply_fossil("G",TWh)=ord(TWh)*0.0055+18.332;

$label nofossilcostsupply



$if not %linear_biomarket_cost_supply% == "yes" $goto nobiocostsupply
Parameter
Fc_linear_cost_supply_biomarket(TWh)
;

Fc_linear_cost_supply_biomarket(TWh)=ord(TWh)*(2/300)+30;

$label nobiocostsupply


*!!3.6 converts PJ to TWh
Biomass_supply(I_reg,bio_class,T)$(T_num(T) le 2020)=(Cum_bio_supply2020(I_reg,bio_class)-Cum_bio_supply2020(I_reg,bio_class-1))/3.6;
Biomass_supply(I_reg,bio_class,T)$(T_num(T) gt 2020)=(Biomass_supply(I_reg,bio_class,"2020")+(T_num(T)-2020)*((Cum_bio_supply2050(I_reg,bio_class)-Cum_bio_supply2050(I_reg,bio_class-1))-Biomass_supply(I_reg,bio_class,"2020"))/30)/3.6;
*Fc_national_bio(I_reg,"bio_class1")=9;
Fc_national_bio(I_reg,"bio_class1")=10.8;
Fc_national_bio(I_reg,"bio_class2")=12.6;
Fc_national_bio(I_reg,"bio_class3")=14.4;
Fc_national_bio(I_reg,"bio_class4")=16.2;
Fc_national_bio(I_reg,"bio_class5")=18;
Fc_national_bio(I_reg,"bio_class6")=19.8;
Fc_national_bio(I_reg,"bio_class7")=21.6;
Fc_national_bio(I_reg,"bio_class8")=23.4;
Fc_national_bio(I_reg,"bio_class9")=25.2;
Fc_national_bio(I_reg,"bio_class10")=27;
Fc_national_bio(I_reg,"bio_class11")=28.8;

*!!3.6 converts PJ to TWh
waste_supply(I_reg,waste_class,T)=(Cum_waste_supply2020(I_reg,waste_class)-Cum_waste_supply2020(I_reg,waste_class-1))*product_GR(I_reg,T)/3.6;
*waste_supply_ref(I_reg,waste_class,T)$_ref(T_num_ref(T) le 2020)=_ref(Cum_waste_supply2020_ref(I_reg,waste_class)-Cum_waste_supply2020_ref(I_reg,waste_class-1))/3.6;   !!3.6 converts PJ to TWh
*waste_supply_ref(I_reg,waste_class,T)$_ref(T_num_ref(T) gt 2020)=_ref(waste_supply_ref(I_reg,waste_class,"2020")+_ref(T_num_ref(T)-2020)*_ref(_ref(Cum_waste_supply2050_ref(I_reg,waste_class)-Cum_waste_supply2050_ref(I_reg,waste_class-1))-waste_supply_ref(I_reg,waste_class,"2020"))/30)/3.6;
$ontext
Fc_national_waste_ref(I_reg,"waste_class1")=90;
Fc_national_waste_ref(I_reg,"waste_class2")=108;
Fc_national_waste_ref(I_reg,"waste_class3")=126;
Fc_national_waste_ref(I_reg,"waste_class4")=144;
Fc_national_waste_ref(I_reg,"waste_class5")=162;
Fc_national_waste_ref(I_reg,"waste_class6")=180;
Fc_national_waste_ref(I_reg,"waste_class7")=198;
Fc_national_waste_ref(I_reg,"waste_class8")=216;
Fc_national_waste_ref(I_reg,"waste_class9")=234;
Fc_national_waste_ref(I_reg,"waste_class10")=252;
Fc_national_waste_ref(I_reg,"waste_class11")=270;
$offtext

valid_thermal(I_reg,"B",plant_type)$(fuel_pot(I_reg,"B") eq 0)=no;

LHV(I_reg,'B')=9.152;
LHV(I_reg,'H')=25.174;
LHV(I_reg,'G')=46.5;
LHV(I_reg,'O')=42.83;
LHV(I_reg,'P')=21;
LHV(I_reg,'W')=19;
LHV(I_reg,"WA")=0;
LHV(I_reg,'U')=0;

C_intensity(I_reg,'B')=30.35;
C_intensity(I_reg,'H')=25.93;
C_intensity(I_reg,'G')=15.68;
C_intensity(I_reg,'O')=20;
C_intensity(I_reg,'P')=29.26;
C_intensity(I_reg,'W')=30.68;
C_intensity(I_reg,'WA')=10;
C_intensity(I_reg,'U')=0;

C_EF(I_reg,thermal)=LHV(I_reg,thermal)*C_intensity(I_reg,thermal)*(44/12);

* Technical lifetimes from IEA "Projected Costs of Generating Electricity" (v. 2010)
***THERMAL****
tech_life("B")=40;
tech_life("H")=40;
tech_life("G")=30;
tech_life("O")=30;
tech_life("P")=40;
tech_life("W")=40;
tech_life("WA")=40;
tech_life("U")=60;
$if %Scenario% =="GP" tech_life("U")=45;

tech_life("WON")=25;
tech_life("WOFF")=25;
tech_life("RO")=80;
tech_life("PS")=80;
tech_life("BCCS")=40;
tech_life("HCCS")=40;
tech_life("GCCS")=30;
tech_life("BWCCS")=40;
tech_life("HWCCS")=40;
tech_life("PV")=25;
tech_life("STH")=25;
tech_life("T")=20;
tech_life("WV")=20;
tech_life("small_hydro")=80;
tech_life("GEO")=40;

EPT_TL(I_reg,thermal,plant_type)=tech_life(thermal);
TL_peakgas(I_reg)=tech_life("G");

EPT_LF(I_reg,thermal,plant_type)=0.85;
$ifi %national%==yes EPT_LF("Sweden","U",plant_type)=0.78;
$ifi %regional%==yes EPT_LF("SE2","U",plant_type)=0.78;
LF_peakgas(I_reg)=0.85;
$ontext
NPT_Ic(I_reg,'B',plant_type,'plant',year)=1577;
NPT_Ic(I_reg,'H',plant_type,'plant',year)=1368;
NPT_Ic(I_reg,'G',CON,'plant',year)=650;
NPT_Ic(I_reg,'G',C_HP,'plant',year)=843;
NPT_Ic(I_reg,'G',B_P,'plant',year)=843;
NPT_Ic(I_reg,'O',plant_type,'plant',year)=1000;
*640;
NPT_Ic(I_reg,'P',plant_type,'plant',year)=2500;
NPT_Ic(I_reg,'W',CON,'plant',year)=2500;       !! test med WEO 2011 CHP minus bio co-fire
NPT_Ic(I_reg,'W',C_HP,'plant',year)=2900;       !! test med WEO 2011
NPT_Ic(I_reg,'W',B_P,'plant',year)=2900;       !! test med WEO 2010
NPT_Ic(I_reg,'WA',plant_type,'plant',year)=8640;       !! WEO 2011

NPT_Ic(I_reg,'U',plant_type,'plant',year)=3900;       !! test med WEO 2011

NPPgas_Ic(I_reg,'plant',year)=389;
$offtext

* All investment and O&M costs from WEIO2014PGAssumptions
* Assume same investment cost for hard coal and brown coal plants
NPT_Ic(I_reg,'B',plant_type,'plant',year)=2000*USD_to_EUR;
NPT_Ic(I_reg,'H',plant_type,'plant',year)=2000*USD_to_EUR;
NPT_Ic(I_reg,'G',CON,'plant',year)=1000*USD_to_EUR;
* Assume same investment cost for back pressure as CHP gas plants
NPT_Ic(I_reg,'G',C_HP,'plant',year)=1300*USD_to_EUR;
NPT_Ic(I_reg,'G',B_P,'plant',year)=1300*USD_to_EUR;
NPPgas_Ic(I_reg,'plant',year)=500*USD_to_EUR;
* Oil plants are assumed to cost 20% more than equivalent gas plants
NPT_Ic(I_reg,'O',plant_type,'plant',year)=NPT_Ic(I_reg,'G',plant_type,'plant',year)*1.2;

*NPT_Ic(I_reg,'W',CON,'plant',year)=50762604131*T_num(year)**(-2.21311635);
*NPT_Ic(I_reg,'W',C_HP,'plant',year)=6.23418E+14*T_num(year)**(-3.432080537);
*NPT_Ic(I_reg,'W',B_P,'plant',year)=6.23418E+14*T_num(year)**(-3.432080537);
NPT_Ic(I_reg,'W',CON,'plant',year)=2380*USD_to_EUR;
* Assume same investment cost for back pressure as CHP biomass plants
NPT_Ic(I_reg,'W',C_HP,'plant',year)=4040*USD_to_EUR;
NPT_Ic(I_reg,'W',B_P,'plant',year)=4040*USD_to_EUR;
* Peat plants are assumed to cost 20% more than equivalent biomass plants
NPT_Ic(I_reg,'P',plant_type,'plant',year)=NPT_Ic(I_reg,'W',plant_type,'plant',year)*1.2;

NPT_Ic(I_reg,'WA',plant_type,'plant',year)=8500*USD_to_EUR;

NPT_Ic(I_reg,'U',plant_type,'plant',year)=6600*USD_to_EUR;

* Assume same O&M costs for hard and brown coal plants
EPT_OM(I_reg,'B',plant_type,'fix')=43*USD_to_EUR;
EPT_OM(I_reg,'H',plant_type,'fix')=43*USD_to_EUR;
EPT_OM(I_reg,'G',CON,'fix')=25*USD_to_EUR;
* Assume same O&M costs for CHP and back-pressure gas plants
EPT_OM(I_reg,'G',C_HP,'fix')=39*USD_to_EUR;
EPT_OM(I_reg,'G',B_P,'fix')=39*USD_to_EUR;
* O&M for oil plants assumed to be 20% more than equivalent gas plants
EPT_OM(I_reg,'O',plant_type,'fix')=EPT_OM(I_reg,'G',plant_type,'fix')*1.2;
* O&M for peat plants assumed to be 20% more than equivalent biomass plants
EPT_OM(I_reg,'P',plant_type,'fix')=EPT_OM(I_reg,'W',plant_type,'fix')*1.2;
EPT_OM(I_reg,'W',CON,'fix')=83*USD_to_EUR;
EPT_OM(I_reg,'W',C_HP,'fix')=152*USD_to_EUR;
EPT_OM(I_reg,'W',B_P,'fix')=152*USD_to_EUR;
EPT_OM(I_reg,'WA',plant_type,'fix')=323*USD_to_EUR;
EPT_OM(I_reg,'U',plant_type,'fix')=198*USD_to_EUR;

EPPgas_OM(I_reg,'fix')=20*USD_to_EUR;

EPT_OM(I_reg,'B',plant_type,'var')=0;
EPT_OM(I_reg,'H',plant_type,'var')=0;
EPT_OM(I_reg,'G',plant_type,'var')=0;
EPT_OM(I_reg,'O',plant_type,'var')=0;
EPT_OM(I_reg,'P',plant_type,'var')=0;
EPT_OM(I_reg,'W',plant_type,'var')=0;
EPT_OM(I_reg,'WA',plant_type,'var')=0;
EPT_OM(I_reg,'U',plant_type,'var')=0;

EPPgas_OM(I_reg,'var')=0;

eta_tot(thermal,T)=(eta_T_factors(thermal,"BP",'a')*(1-exp(-(eta_T_factors(thermal,"BP",'b')*
                 (T_num(T)-eta_T_factors(thermal,"BP",'c'))**
                 eta_T_factors(thermal,"BP",'d')))));

eta_tot("W",T)=(1.1*(1-exp(-(0.00004674*
                 (T_num(T)-1800)**
                 2.072))));

eta_tot("G",T)=0.9;

EPT_alfa(thermal,C_HP,T)$(fuel_num(thermal) ne fuel_num("WA"))=(eta_T_factors(thermal,C_HP,'a')*(1-exp(-(eta_T_factors(thermal,C_HP,'b')*
                 (T_num(T)-eta_T_factors(thermal,C_HP,'c'))**
                 eta_T_factors(thermal,C_HP,'d')))))/(eta_tot(thermal,T)-(eta_T_factors(thermal,C_HP,'a')*(1-exp(-(eta_T_factors(thermal,C_HP,'b')*
                 (T_num(T)-eta_T_factors(thermal,C_HP,'c'))**
                 eta_T_factors(thermal,C_HP,'d'))))));

EPT_alfa("WA",C_HP,T)=EPT_alfa("W",C_HP,T)/2;

EPT_alfa_5year(thermal,C_HP,fiveyear_period)=sum(T$(T_num(T) ge first_year5(fiveyear_period) and T_num(T) le last_year5(fiveyear_period)),EPT_alfa(thermal,C_HP,T))/5;
*EPT_alfa_5year(thermal,C_HP,"5year_1")=sum(T$(T_num(T) ge first_year5("5year_1") and T_num(T) le last_year5("5year_1")),EPT_alfa(thermal,C_HP,T))/7;
EPT_alfa_5year(thermal,C_HP,"5year_8")=sum(T$(T_num(T) ge first_year5("5year_8") and T_num(T) le last_year5("5year_8")),EPT_alfa(thermal,C_HP,T))/6;

eta_el(thermal,plant_type,T)=(eta_T_factors(thermal,plant_type,'a')*(1-exp(-(eta_T_factors(thermal,plant_type,'b')*
                 (T_num(T)-eta_T_factors(thermal,plant_type,'c'))**
                 eta_T_factors(thermal,plant_type,'d')))));

*eta_el("WA",CON,T)=eta_el("W",CON,T)-0.2;
*eta_el("WA",C_HP,T)=eta_el("W",C_HP,T)-0.15;

eta_el_5year(thermal,plant_type,fiveyear_period)=sum(T$(T_num(T) ge first_year5(fiveyear_period) and T_num(T) le last_year5(fiveyear_period)),eta_el(thermal,plant_type,T))/5;
*eta_el_5year(thermal,plant_type,"5year_1")=sum(T$(T_num(T) ge first_year5("5year_1") and T_num(T) le last_year5("5year_1")),eta_el(thermal,plant_type,T))/7;
eta_el_5year(thermal,plant_type,"5year_8")=sum(T$(T_num(T) ge first_year5("5year_8") and T_num(T) le last_year5("5year_8")),eta_el(thermal,plant_type,T))/6;
eta_el_5year_Pgas(fiveyear_period)=eta_el_5year("G","condens",fiveyear_period)-0.25;

*** WIND ***
wind_cap_factor=1;
EPW_TL(nuts2)=tech_life("WON");

* Sensitivity ONSHORE WIND capacity density FACTOR 0.0003
wind_cap_intensity=0.003;        !!GW per sqr-km

valid_wind_type(nuts2,wind_type)=no;
loop(I_reg,
valid_wind_type(nuts2,wind_type)$(wind_pot(nuts2,wind_type) gt 0 and regions_to_nuts2(I_reg,nuts2))=yes;
)
;

alias(an_hour,annual_hour);

wind_full_Lh_nuts(nuts2)=sum(an_hour,wind_input(an_hour,nuts2)/100);
wind_profile(an_hour,nuts2)$(wind_full_Lh_nuts(nuts2) gt 0)=wind_input(an_hour,nuts2)/(wind_full_Lh_nuts(nuts2)*100);

EPW_LF(an_hour,nuts2,wind_type)=wind_profile(an_hour,nuts2)*wind_CF(nuts2,wind_type)*8760;

EPW_LF_nuts(an_hour,nuts2)=wind_input(an_hour,nuts2)/100;

scalar upwind_scale;
upwind_scale=1.2;

*** with learning ***
* ONSHORE WIND PRICE SENSITIVITY FACTOR 1000/1380 (from Fraunhofer Levelized Cost (2013) low price)
NPW_Ic(nuts2,onwind,'plant',year)=wind_invest_cost_coef_a("onshore_wind")*exp(wind_invest_cost_coef_b("onshore_wind")*T_num(year));
* OFFSHORE WIND PRICE SENSITIVITY FACTOR 3400/3840 (from Fraunhofer Levelized Cost (2013) low price)
NPW_Ic(nuts2,"offwind",'plant',year)=wind_invest_cost_coef_a("offshore_wind")*exp(wind_invest_cost_coef_b("offshore_wind")*T_num(year));

EPW_OM(I_reg,onwind,'fix',year)=wind_fixed_OM_cost_coef_a("onshore_wind")*exp(wind_fixed_OM_cost_coef_b("onshore_wind")*T_num(year));
EPW_OM(I_reg,onwind,'var',year)=0;
EPW_OM(I_reg,'offwind','fix',year)=wind_fixed_OM_cost_coef_a("offshore_wind")*exp(wind_fixed_OM_cost_coef_b("offshore_wind")*T_num(year));
EPW_OM(I_reg,'offwind','var',year)=0;

***HYDRO***
EPH_TL(I_reg,hydro_class)=tech_life("RO");

*LFH(I_reg,hydro,T)=EPH_LF(I_reg,hydro,"mean")*8.76;

NPH_Ic(I_reg,hydro_class,'plant',year)=2270*USD_to_EUR;

EPH_OM(I_reg,'RO','fix')=53*USD_to_EUR;
EPH_OM(I_reg,'PS','fix')=53*USD_to_EUR;
EPH_OM(I_reg,'RO','var')=0;
EPH_OM(I_reg,'PS','var')=0;

*** OTHERS ***
NPO_TL(I_reg,others)=25;
NPO_TL(I_reg,"small_hydro")=75;

EPO_LF(an_hour,I_reg,others)=EPO_LF1(an_hour,I_reg,others)*others_full_Lh(I_reg,others);

*LFO(I_reg,others,T)=NPO_LF(I_reg,others,"mean")*8.76;

*NPO_Ic(I_reg,'PV','Plant',year)=3.9079E+133*T_num(year)**(-39.39034284);
NPO_Ic(I_reg,'STH','Plant',year)=7250*USD_to_EUR;
* Assume tidal and wave are same cost as "marine" technologies
NPO_Ic(I_reg,'T','Plant',year)=7090*USD_to_EUR;
NPO_Ic(I_reg,'Wv','Plant',year)=7090*USD_to_EUR;
NPO_Ic(I_reg,'small_hydro','Plant',year)=4040*USD_to_EUR;

*EPO_OM(I_reg,'PV','fix')=27.36;
EPO_OM(I_reg,'STH','fix')=290*USD_to_EUR;
EPO_OM(I_reg,'T','fix')=204*USD_to_EUR;
EPO_OM(I_reg,'Wv','fix')=204*USD_to_EUR;
EPO_OM(I_reg,'small_hydro','fix')=70*USD_to_EUR;

*EPO_OM(I_reg,'PV','var')=0;
EPO_OM(I_reg,'STH','var')=0;
EPO_OM(I_reg,'T','var')=0;
EPO_OM(I_reg,'Wv','var')=0;
EPO_OM(I_reg,'small_hydro','var')=0;

*** Geothermal ***
NPGEO_TL(I_reg,geothermal)=30;
* load factor for geothermal from WEIO2014PGAssumptions
NPGEO_LF(I_reg,geothermal)=0.7;

NPGEO_Ic(I_reg,geothermal,'plant',year)=2980*USD_to_EUR;

NPGEO_OM(I_reg,geothermal,'fix')=60*USD_to_EUR;
NPGEO_OM(I_reg,geothermal,'var')=0;

*** CCS ***
NPCCS_TL(I_reg,CCS,plant_type)=40;
NPCCS_LF(I_reg,CCS,plant_type)=0.85;

* Assume BCCS and HCCS are same investments costs, from Oxyfuel + CCS in WEIO2014PGAssumptions
NPCCS_Ic(I_reg,'BCCS',plant_type,'plant',year)=3850*USD_to_EUR;
NPCCS_Ic(I_reg,'HCCS',plant_type,'plant',year)=3850*USD_to_EUR;
* Assume CCGT + CCS investment costs from WEIO2014PGAssumptions
NPCCS_Ic(I_reg,'GCCS',plant_type,'plant',year)=1800*USD_to_EUR;
* Assume Biomass cofiring investment costs from WEIO2014PGAssumptions plus base coal plant CCS investment costs
NPCCS_Ic(I_reg,'BWCCS',plant_type,'plant',year)=NPCCS_Ic(I_reg,'BCCS',plant_type,'plant',year)+590*USD_to_EUR;
NPCCS_Ic(I_reg,'HWCCS',plant_type,'plant',year)=NPCCS_Ic(I_reg,'HCCS',plant_type,'plant',year)+590*USD_to_EUR;
*NPCCS_Ic_year(I_reg,CCS,plant_type,'plant',year)$(T_num(year) le 2035)=NPCCS_Ic(I_reg,CCS,plant_type,'plant');
*NPCCS_Ic_year(I_reg,CCS,plant_type,'plant',year)$(T_num(year) gt 2035)=0.85*NPCCS_Ic(I_reg,CCS,plant_type,'plant');

* Assume BCCS and HCCS are same O&M costs, from Oxyfuel + CCS in WEIO2014PGAssumptions
NPCCS_OM(I_reg,'BCCS',plant_type,'fix')=116*USD_to_EUR;
NPCCS_OM(I_reg,'HCCS',plant_type,'fix')=116*USD_to_EUR;
* Assume CCGT + CCS O&M costs from WEIO2014PGAssumptions
NPCCS_OM(I_reg,'GCCS',plant_type,'fix')=45*USD_to_EUR;
* Assume Biomass cofiring O&M costs from WEIO2014PGAssumptions plus base coal plant CCS O&M costs
NPCCS_OM(I_reg,'BWCCS',plant_type,'fix')=NPCCS_OM(I_reg,'BCCS',plant_type,'fix')+22*USD_to_EUR;
NPCCS_OM(I_reg,'HWCCS',plant_type,'fix')=NPCCS_OM(I_reg,'BCCS',plant_type,'fix')+22*USD_to_EUR;

NPCCS_OM(I_reg,'BCCS',plant_type,'var')=0;
NPCCS_OM(I_reg,'HCCS',plant_type,'var')=0;
NPCCS_OM(I_reg,'GCCS',plant_type,'var')=0;
NPCCS_OM(I_reg,'BWCCS',plant_type,'var')=0;
NPCCS_OM(I_reg,'HWCCS',plant_type,'var')=0;

eta_elCCS(CCS,plant_type,T)=(eta_CCS_factors(CCS,plant_type,'a')*(1-exp(-(eta_CCS_factors(CCS,plant_type,'b')*
                 (T_num(T)-eta_CCS_factors(CCS,plant_type,'c'))**
                 eta_CCS_factors(CCS,plant_type,'d')))));


eta_elCCS_5year(CCS,plant_type,fiveyear_period)=sum(T$(T_num(T) ge first_year5(fiveyear_period) and T_num(T) le last_year5(fiveyear_period)),eta_elCCS(CCS,plant_type,T))/5;
*eta_elCCS_5year(CCS,plant_type,"5year_1")=sum(T$(T_num(T) ge first_year5("5year_1") and T_num(T) le last_year5("5year_1")),eta_elCCS(CCS,plant_type,T))/7;
eta_elCCS_5year(CCS,plant_type,"5year_8")=sum(T$(T_num(T) ge first_year5("5year_8") and T_num(T) le last_year5("5year_8")),eta_elCCS(CCS,plant_type,T))/6;

display eta_elCCS, eta_elCCS_5year;

CCS_capt('BCCS')=0.889;
CCS_capt('HCCS')=0.877;
CCS_capt('GCCS')=0.885;
CCS_capt('BWCCS')=0.889;
CCS_capt('HWCCS')=0.877;

bio_fraction('BWCCS')=0.10;
bio_fraction('HWCCS')=0.10;

CCS_EF(I_reg,"BCCS")=(1-CCS_capt("BCCS"))*C_intensity(I_reg,"B")*3.6*44/(1000*12);
CCS_EF(I_reg,"HCCS")=(1-CCS_capt("HCCS"))*C_intensity(I_reg,"H")*3.6*44/(1000*12);
CCS_EF(I_reg,"GCCS")=(1-CCS_capt("GCCS"))*C_intensity(I_reg,"G")*3.6*44/(1000*12);
CCS_EF(I_reg,"BWCCS")=(((1-CCS_capt("BWCCS"))*
                 ((1-bio_fraction("BWCCS"))*C_intensity(I_reg,"B")+
                 bio_fraction("BWCCS")*C_intensity(I_reg,"W")))-
                 bio_fraction("BWCCS")*C_intensity(I_reg,"W"))*3.6*44/(1000*12);
CCS_EF(I_reg,"HWCCS")=(((1-CCS_capt("HWCCS"))*
                 ((1-bio_fraction("HWCCS"))*C_intensity(I_reg,"B")+
                 bio_fraction("HWCCS")*C_intensity(I_reg,"W")))-
                 bio_fraction("HWCCS")*C_intensity(I_reg,"W"))*3.6*44/(1000*12);

CCS_store_EF(I_reg,"BCCS")=(CCS_capt("BCCS"))*C_intensity(I_reg,"B")*3.6*44/(1000*12);
CCS_store_EF(I_reg,"HCCS")=(CCS_capt("HCCS"))*C_intensity(I_reg,"H")*3.6*44/(1000*12);
CCS_store_EF(I_reg,"GCCS")=(CCS_capt("GCCS"))*C_intensity(I_reg,"G")*3.6*44/(1000*12);
CCS_store_EF(I_reg,"BWCCS")=(CCS_capt("BWCCS")*
                 (1-bio_fraction("BWCCS"))*C_intensity(I_reg,"B")+
                 CCS_capt("BWCCS")*bio_fraction("BWCCS")*C_intensity(I_reg,"W"))*3.6*44/(1000*12);
CCS_store_EF(I_reg,"HWCCS")=(CCS_capt("HWCCS")*
                 (1-bio_fraction("HWCCS"))*C_intensity(I_reg,"H")+
                 CCS_capt("HWCCS")*bio_fraction("HWCCS")*C_intensity(I_reg,"W"))*3.6*44/(1000*12);

Fc_CCS(I_reg,"BCCS",T)=Fc(I_reg,"B",T);
Fc_CCS(I_reg,"HCCS",T)=Fc(I_reg,"H",T);
Fc_CCS(I_reg,"GCCS",T)=Fc(I_reg,"G",T);
Fc_CCS(I_reg,"BWCCS",T)=(1-bio_fraction("BWCCS"))*Fc(I_reg,"B",T)+bio_fraction("BWCCS")*Fc(I_reg,"W",T);
Fc_CCS(I_reg,"HWCCS",T)=(1-bio_fraction("HWCCS"))*Fc(I_reg,"H",T)+bio_fraction("HWCCS")*Fc(I_reg,"W",T);

****SOLAR**************

*solar_input("opt_csi",an_hour,nuts2)=solar_input_opt_csi(an_hour,nuts2);
*solar_input("two_csi",an_hour,nuts2)=solar_input_two_csi(an_hour,nuts2);
*solar_input("opt_cd_te",an_hour,nuts2)=solar_input_opt_cd_te(an_hour,nuts2);
*solar_input("two_cd_te",an_hour,nuts2)=solar_input_two_cd_te(an_hour,nuts2);


Solar_full_Lh_sites(solar_type,solar_sites)=sum(an_hour,solar_input(solar_type,solar_sites,an_hour));
Solar_profile(solar_type,solar_sites,an_hour)$(Solar_full_Lh_sites(solar_type,solar_sites) gt 0)=solar_input(solar_type,solar_sites,an_hour)/Solar_full_Lh_sites(solar_type,solar_sites);


EPS_LF(solar_type,solar_sites,an_hour)=solar_input(solar_type,solar_sites,an_hour);

*Learning curves and cost development over time need to be here, read in cost parameters from gdx file
*look for a curve representation for reasonable learning curves

* SOLAR PV PRICE SENSITIVITY FACTOR 1000/1821 (from Fraunhofer Levelized Cost (2013) low price for large PV)
NPSol_Ic(solar_type,solar_sites,'plant',year)=solar_invest_cost_coef_a(solar_type)*exp(solar_invest_cost_coef_b(solar_type)*T_num(year));
* CSP PRICE SENSITIVITY FACTOR 2500/5459 (from Fraunhofer Levelized Cost (2013) low price for fresnel CSP)
NPSol_Ic('tracking_CSP',solar_sites,'plant',year)=solar_invest_cost_coef_a('tracking_CSP')*exp(solar_invest_cost_coef_b('tracking_CSP')*T_num(year));
* HCPV PRICE SENSITIVITY FACTOR 1400/2731 (from Fraunhofer Levelized Cost (2013) low price)
*NPSol_Ic('tracking_HCPV',solar_sites,'plant',year)=1400/2731*solar_invest_cost_coef_a('tracking_HCPV')*exp(solar_invest_cost_coef_b('tracking_HCPV')*T_num(year));

* Run with original IEA prices
*NPSol_Ic(solar_type,solar_sites,'plant',year) = NPSol_Ic(solar_type,solar_sites,'plant',year);
*NPSol_Ic("two_csi",nuts2,'plant',year)=NPSol_Ic("opt_csi",nuts2,'plant',year)+500;
*NPSol_Ic("opt_cd_te",nuts2,'plant',year)=NPSol_Ic("opt_csi",nuts2,'plant',year);
*NPSol_Ic("two_cd_te",nuts2,'plant',year)=NPSol_Ic("opt_csi",nuts2,'plant',year)+500;

* need to read in from gdx file
EPSol_OM(solar_type,I_reg,'fix',year)=solar_fixed_OM_cost_coef_a(solar_type)*exp(solar_fixed_OM_cost_coef_b(solar_type)*T_num(year));
*CSP PRICE SENSITIVITY FACTOR 35/218*0.28/0.18 (ratio from Fraunhofer Levelized Cost (2013) - ratio that variable OM cost for CSP is higher than onshore wind in 2013 is 0.28/0.18, and the scaling factor 35/218 is the O&M cost in 2013 for wind and CSP from IEA which is the basis for the original curve.
EPSol_OM('tracking_CSP',I_reg,'fix',year)=solar_fixed_OM_cost_coef_a('tracking_CSP')*exp(solar_fixed_OM_cost_coef_b('tracking_CSP')*T_num(year));
EPSol_OM(solar_type,I_reg,'var',year)=0;

EPSol_TL(solar_type)=tech_life("PV");

* add to gdx file

* Sensitivity case: Low solar capacity intensity 1/10 (comment out if not used)
*solar_cap_intensity(solar_type) = solar_cap_intensity(solar_type)/10;

*solar_cap_intensity(thin_film)=solar_cap_intensity("opt_csi")/2;

*** SOLAR MARKET added value (should be refined)
*defines a higher value to in-house used electrcity generation for small scale consumers/producers
*based on array to load ratio and linearly reduction of added value (larger arrays gives more hours with export to grid)
*solar_mean_FLH(I_reg)=0.9;
* Experimental calculation of solar FLH
* Average of all nuts2 in region
solar_mean_FLH(I_reg) = sum(solar_sites$(solar_sites_to_regions(solar_sites,I_reg)), Solar_full_Lh_sites("fixed_building_monoSi",solar_sites))/sum(solar_sites$(solar_sites_to_regions(solar_sites,I_reg)),1)/1000;
*solar_deduct_input(I_reg)=100;
Set regs_no_solar(I_reg);
regs_no_solar(I_reg)$(sum(solar_sites$(solar_sites_to_regions(solar_sites,I_reg)),1) eq 0) = yes;
If(sum(regs_no_solar,1)>0,
         execute_unload 'regs_no_solar.gdx',regs_no_solar;
);

* Use residential el. share for country when regional
Parameter
         building_el_reg(I_reg)
         solar_deduct_reg(I_reg);
$if %regional%=="yes" building_el_reg(I_reg) = sum((dbcountry,sector)$(country_to_EPODreg(dbcountry,I_reg)),building_el_demand(dbcountry,sector));
$if %national%=="yes" building_el_reg(I_reg) = sum(sector,building_el_demand(I_reg,sector));
$if %regional%=="yes" solar_deduct_reg(I_reg) = sum(dbcountry$(country_to_EPODreg(dbcountry,I_reg)),solar_deduct_input(dbcountry));
$if %national%=="yes" solar_deduct_reg(I_reg) = solar_deduct_input(I_reg);

*Residential_el(I_reg)=0.15;

$ifthen %net_metering% == "yes"
         Solar_deduct(I_reg,TWh,T)$(ord(TWh) le building_el_reg(I_reg)*Demand(I_reg,T))=solar_deduct_reg(I_reg);
$else
         Solar_deduct(I_reg,TWh,T)$(ord(TWh) le 0.5*building_el_reg(I_reg)*Demand(I_reg,T)*solar_mean_FLH(I_reg)/8.76)=solar_deduct_reg(I_reg);
         Solar_deduct(I_reg,TWh,T)$(ord(TWh) gt 0.5*building_el_reg(I_reg)*Demand(I_reg,T)*solar_mean_FLH(I_reg)/8.76
                         and ord(TWh) le 3*building_el_reg(I_reg)*Demand(I_reg,T)*solar_mean_FLH(I_reg)/8.76)=
                         solar_deduct_reg(I_reg)*(3/2.5-1/(2.5*building_el_reg(I_reg)*Demand(I_reg,T)*solar_mean_FLH(I_reg)/8.76)*ord(TWh));
         Solar_deduct(I_reg,TWh,T)$(ord(TWh) gt 3*building_el_reg(I_reg)*Demand(I_reg,T)*solar_mean_FLH(I_reg)/8.76)=0;
$endif

* Storage
* Tesla cost / 2 for testing
*NEStorage_Ic(storage_systems,I_reg,year) = 175.0e3*USD_to_EUR;
* STORAGE PRICE SENSITVITY FACTOR: 2/3 - Aqueous Hybrid Ion systems for example are available today at 150 USD/kWh
NEStorage_Ic(storage_systems,I_reg,year) = storage_invest_cost_coef_a(storage_systems)*exp(storage_invest_cost_coef_b(storage_systems)*T_num(year));
NEStorage_OM(storage_systems,I_reg,"var",year) = 0;
NEStorage_OM(storage_systems,I_reg,"fix",year) = 0;

* Ranges from 0.82 to .95, but most commonly around .9
storageEfficiency('battery') = 0.9;
* STE roadmap article
storageEfficiency('TES') = 0.95;

EPStorage_TL('battery') = 10;
EPStorage_TL('TES') = EPSol_TL('tracking_CSP');
*NEStorage_Ic('TES',I_reg,year) = 15.0e3/0.35*USD_to_EUR;

***INTERCONNECTORS****
NP_trade_TL=40;

valid_EP_trade(I_reg,import_reg)=no;
valid_EP_trade(I_reg,import_reg)$(EPCON(I_reg,import_reg) gt 0)=yes;
valid_NP_trade(I_reg,import_reg)=no;
valid_NP_trade(I_reg,import_reg)$(NP_trade_Ic_ref(I_reg,import_reg) gt 0)=yes;

parameter
import_cap(import_reg,export_reg)
;
import_cap(import_reg,export_reg)=EPCON(import_reg,export_reg);

*** System capacity factor ***
system_cap_factor(I_reg,T)=(sum(wind,Residual_P_wind(I_reg,wind,"2010"))*wind_cap_factor+
                         Residual_P_hydro(I_reg,"RO","2010")+
                         sum((thermal,plant_type,inv_year),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el","2010",inv_year)))/
                         (demand_in(I_reg,"2010")/1000);
*** ala MARKAL peak equation ***
cap_factor_wind_exist(nuts2)=wind_full_Lh_nuts(nuts2)/8760;
*cap_factor_wind_exist(I_reg,"up")=0.3;
*cap_factor_wind_exist(I_reg,"off")=0.4;

*EPW_LF(I_reg,wind,"mean");
* Write down the value of variable generation in capacity constraint by 0.7
cap_factor_wind_new(nuts2,wind_type)=wind_CF(nuts2,wind_type)*0.7;
cap_factor_solar_new(solar_type,solar_sites)=0.7*Solar_full_Lh_sites(solar_type,solar_sites)/8760;
cap_factor_solar_exist(solar_type,nuts2)$(sum(solar_sites$solar_sites_to_nuts2(solar_sites,nuts2),1) gt 0)=
         0.7*sum(solar_sites$solar_sites_to_nuts2(solar_sites,nuts2),cap_factor_solar_new(solar_type,solar_sites))/sum(solar_sites$solar_sites_to_nuts2(solar_sites,nuts2),1);
*cap_factor_wind_new(I_reg,"up")=0.4;
*cap_factor_wind_new(I_reg,"off")=0.5;
*EPW_LF(I_reg,wind,"mean")+0.5/8.76;
cap_factor_hydro(I_reg,"run_riv")$(residual_P_hydroclass(I_reg,"run_riv","2010") gt 0)=(hydro_prod(I_reg,"run_riv")/residual_P_hydroclass(I_reg,"run_riv","2010"))/8.76;    !!full load hours is in 1000hours i.e. between about 2-3
cap_factor_hydro(I_reg,"reg")=1;
cap_factor_others(I_reg,others)=others_full_Lh(I_reg,others)/8760;       !!others full lh is in hours i.e. between about 1000-5000
cap_factor_thermal(I_reg,thermal,plant_type)=EPT_LF(I_reg,thermal,plant_type);
cap_factor_thermal(I_reg,thermal,B_P)=0.5;
*cap_factor_thermal(I_reg,thermal,C_HP)=0.5;
*cap_factor_thermal(I_reg,"G",CON)=1.2;
*cap_factor_thermal(I_reg,"U",CON)=1;
*cap_factor_thermal(I_reg,"B",CON)=1;
*cap_factor_thermal(I_reg,"H",CON)=1;
cap_factor_Pgas(I_reg)=1;
cap_factor_intercon(I_reg)=0;

cap_factor_CCS(I_reg,CCS,plant_type)=NPCCS_LF(I_reg,CCS,plant_type);
*cap_factor_CCS(I_reg,CCS,CON)=1;

cap_factor_geothermal(I_reg,geothermal)=NPGEO_LF(I_reg,geothermal);

system_max_load(I_reg,"2010")=     sum((nuts2,wind)$(regions_to_nuts2(I_reg,nuts2)),Residual_wind_nuts2(nuts2,wind,"2010")*cap_factor_wind_exist(nuts2))+
                                           sum(nuts2$(regions_to_nuts2(I_reg,nuts2)),residual_PV_nuts2(nuts2,"2010")*cap_factor_solar_exist("fixed_building_monoSi",nuts2))+
                                   residual_P_hydroclass(I_reg,"run_riv","2010")*cap_factor_hydro(I_reg,"run_riv")+
                                   residual_P_hydroclass(I_reg,"reg","2010")*cap_factor_hydro(I_reg,"reg")+
                                   sum((thermal,plant_type,inv_year),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el","2010",inv_year)*cap_factor_thermal(I_reg,thermal,plant_type))

                                  +sum(exp_region,EPCON(exp_region,I_reg)*cap_factor_intercon(I_reg))
;
*system_max_load_nordic("2003")=sum(nordic,system_max_load(nordic,"2003"));

system_max_load(I_reg,T)=product_GR(I_reg,T)*system_max_load(I_reg,"2010");
*system_max_load(I_reg,T)=((T_num(T)-2010)/41)*system_max_load(I_reg,T);
*system_max_load_nordic(T)=sum(nordic,system_max_load(nordic,T));


execute_unload 'solar_cap_intensity.gdx',solar_cap_intensity;

