********************************************************************
***      Definition of variables in model                        ***
***                                                              ***
********************************************************************
$ontext
set Ttype_tuple(I_reg,thermal,plant_type,T,year)
;
Ttype_tuple(I_reg,thermal,plant_type,T,year)$(T_num(T) ge T_num(year)
                 and T_num(T) lt T_num(year)+EPT_TL(I_reg,thermal,plant_type)
                 and T_num(year) le T_num(T))=yes;

set CCStype_tuple(I_reg,CCS,plant_type,T,year)
;
CCStype_tuple(I_reg,CCS,plant_type,T,year)$(T_num(T) ge T_num(year)
                 and T_num(T) lt T_num(year)+NPCCS_TL(I_reg,CCS,plant_type)
                 and T_num(year) le T_num(T))=yes;
$offtext

Variable
tot_cost;
*EE_trade(export_reg,import_reg,T,Time_step)
*NE_trade(export_reg,import_reg,T,Time_step)
***************************VCO2CCS(I_reg,CCS,T)                             CO2 emissions from CCS facilities [Mton CO2]
*negative variable
*;

Positive variables
Prod_cost(I_reg,T)                               Production costs [M]
disprod_cost(I_reg,T)                            Discounted prod costs NPV [M]
aninv_cost(I_reg,T)                              Annualized investment costs [M]
disaninv_cost(I_reg,T)                           Discounted annualized inv costs NPV [M]
gen(T)                                           Tot generation in all regions [TWh]
gen_region(I_reg,T,Time_step)                              Tot generation in each region [TWh]
*consump_timestep(I_reg,T,Time_step)
NP_trade(I_reg,import_reg,T)
Inv_NP_trade(I_reg,import_reg,year)
EE_export(I_reg,T,Time_step)
EE_import(I_reg,T,Time_step)
EE_export11(I_reg,import_reg,T,Time_step)
EE_import11(I_reg,export_reg,T,Time_step)
NE_export(I_reg,T,Time_step)
NE_import(I_reg,T,Time_step)
NE_export11(I_reg,import_reg,T,Time_step)
NE_import11(I_reg,export_reg,T,Time_step)

tot_RES(T)                                       RES electrcity generation
tot_RES_Ireg(I_reg,T)
tot_solar_Ireg(I_reg,T)

$if %national%==yes totP_nuclear_Ireg(I_reg,T)
$if %regional%==yes totP_nuclear_dbcountry(dbcountry,T)

BP_el(I_reg,T)
*gen_nordic(T)                                    Tot generation in nordic region [TWh]
lignite_fuel(I_reg,T)
****************totF(I_reg,thermal,T)                            Fuel consumption per fuel and region [TWhfuel]
VBio_nation(I_reg,bio_class,T)                   Biomass and Waste fuels from national resources [TWh] per biomass class
VBio_market(I_reg,T)                             Biomass and waste fuels from international market [TWh]
$if %linear_biomarket_cost_supply% == "yes"                    V_cost_supply_biomarket_cost(T)         biofuel costs from international market with cost-supply
$if %linear_biomarket_cost_supply% == "yes"                    V_cost_supply_biomarket(TWh,T)          biofuel use from international market with cost-supply
Vwaste_nation(I_reg,waste_class,T)
*****************totP_wind(I_reg,wind,T)                          Total wind capacity per region and type [GW]
*totE_wind(I_reg,wind,T)                          Total wind Generation per region and type [TWh]
******************totP_hydro(I_reg,hydro,T)                        Total hydro capacity per region and type [GW]
*totP_thermal(I_reg,thermal,T)                    Total thermal capacity per region and fuel [GW]
**********************totE_BP(I_reg,T)                                 Total generation in BP facilities per region [TWh]
totH_CHP(I_reg,T,Time_step)                                Total heat production in CHP facilities per region [TWhheat]
*totP(I_reg,T)                                    Total installed capacity per region [GW]
*totP_nordic(T)                                   Total installed capacity in nordic region [GW]
*system_load(I_reg,T)
**********************system_load_nordic(T)


VEETtype1(I_reg,thermal,plant_type,T,tenyear_period,Time_step)             Generation present thermal facilities [TWh]
VEHTtype1(I_reg,thermal,C_HP,T,tenyear_period,Time_step)                   Heat production in present thermal facilities [TWh]
VEETtype(I_reg,thermal,plant_type,T)             Generation present thermal facilities [TWh]
VEHTtype(I_reg,thermal,C_HP,T)                   Heat production in present thermal facilities [TWh]

VNPTtype1(I_reg,thermal,plant_type,T,year)             Active new capacity thermal [GW]
VNPTtype_5year(I_reg,thermal,plant_type,T,fiveyear_period)
VNPTtype(I_reg,thermal,plant_type,T)             Active new capacity thermal [GW]
Inv_VNPTtype(I_reg,thermal,plant_type,year)      Annual new investments thermal [GW]
*VNPHTtype(I_reg,thermal,C_HP,T)                  Active new heat capacity thermal [GWheat]
*VNPBTtype(I_reg,thermal,plant_type,T)            Active new boiler capacity thermal [GWthermal]

*VNPW_Ireg(I_reg,wind_type,T)
VNPW(nuts2,wind_type,T)                               Active new capacity wind [GW]
Inv_VNPW(nuts2,wind_type,year)                        Annual new investments wind [GW]
VNPH(I_reg,hydro_class,T)                              Active new capacity hydro [GW]
Inv_VNPH(I_reg,hydro_class,year)                       Annual new investments hydro [GW]
VNPCCStype1(I_reg,CCS,plant_type,T,year)               Active new capacity CCS [GW]
VNPCCStype_5year(I_reg,CCS,plant_type,T,fiveyear_period)
VNPCCStype(I_reg,CCS,plant_type,T)               Active new capacity CCS [GW]
Inv_VNPCCStype(I_reg,CCS,plant_type,year)        Annual new investments CCS [GW]
*VNPBCCStype(I_reg,CCS,plant_type,T)              Active new boiler capacity CCS [GW]
VNPO(I_reg,non_PV,T)                             Active new capacity others [GW]
Inv_VNPO(I_reg,non_PV,year)                      Annual new investments others [GW]
VNPGEO(I_reg,geothermal,T)                       Active new capacity geothermal [GW]
Inv_VNPGEO(I_reg,geothermal,year)                Annual new investments geothermal [GW]

Inv_VNPSol(solar_type,solar_sites,year)

*Storage
Inv_VNEStorage(storage_systems,I_reg,year)          Annual investments in daily battery storage capacity [TWh]
VNEStorageCap(storage_systems,I_reg,T)              Active new storage capacity [TWh]
VNEStorageIn(storage_systems,I_reg,T,Time_step)     Charging storage [TWh]
VNEStorageOut(storage_systems,I_reg,T,Time_step)    Discharging storage [TWh]
VNEStorageLevel(storage_systems,I_reg,T,Time_step)  Energy currently in storage [TWh]


VNETtype1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)             Generation in active new thermal capacity [TWh]
VNETtype(I_reg,thermal,plant_type,T)             Generation in active new thermal capacity [TWh]
VNHTtype1(I_reg,thermal,C_HP,T,fiveyear_period,Time_step)                   Heat production in active new thermal capacity [TWh]
VNHTtype(I_reg,thermal,C_HP,T)                   Heat production in active new thermal capacity [TWh]
VNEW1_nuts2(nuts2,wind_type,T,Time_step)
VNEW1(I_reg,wind_type,T,Time_step)                               Generation in active new wind capacity [TWh]
VNEW(I_reg,wind_type,T)                               Generation in active new wind capacity [TWh]


VEEH1_REG(I_reg,T,Time_step)
VEEH_REG(I_reg,T)
VNEH1_RO(I_reg,T,Time_step)
VNEH_RO(I_reg,T)
VNEH1_REG(I_reg,T,Time_step)
VNEH_REG(I_reg,T)

VNECCStype1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)               Generation in active new CCS capacity [TWh]
VNECCStype(I_reg,CCS,plant_type,T)               Generation in active new CCS capacity [TWh]
VNEO1(I_reg,non_PV,T,Time_step)
VNEO(I_reg,non_PV,T)                             Generation in active new other capacity [TWh]
VNEGEO(I_reg,geothermal,T)                       Generation in active new geothermal capacity [TWh]

VEFTtype1(I_reg,thermal,plant_type,T,tenyear_period,Time_step)             Fuel consumption in residual thermal capacities [TWhfuel]
VEFTtype(I_reg,thermal,plant_type,T)             Fuel consumption in residual thermal capacities [TWhfuel]

VNFTtype1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)             Fuel consumption in active new thermal capacities [TWhfuel]
VNFTtype(I_reg,thermal,plant_type,T)             Fuel consumption in active new thermal capacities [TWhfuel]
VNFCCStype1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)               Energy consumption in active new CCS capacities [TWhfuel]
VNFCCStype(I_reg,CCS,plant_type,T)               Energy consumption in active new CCS capacities [TWhfuel]
VNFCCS(I_reg,thermal,T)                          Fuel consumption in active new CCS capacities [TWhfuel]

*VPT_Lh_exist(I_reg,thermal,plant_type,T,inv_year)         Load factor in all existing thermal capacities [kh per year]
*VPT_Lh_new(I_reg,thermal,plant_type,T)           Load factor in all new invested thermal capacities [kh per year]
*VPCCS_Lh(I_reg,CCS,plant_type,T)                 Load factor in CCS capacities [kh per year]
*VPGEO_Lh(I_reg,geothermal,T)                     Load factor in geothermal capacities [kh per year]


VCO2(T)                                          Total CO2 emission all regions [Mton CO2]
***************************VCO2_stored(I_reg,T)                             CO2 emissions captured from CCS facilities [Mton CO2]
*** Peak gas variables
VNPPgas1(I_reg,T,year)
Inv_VNPPgas(I_reg,year)
VNPPgas_5year(I_reg,T,fiveyear_period)
VNPPgas(I_reg,T)
VNEPgas1(I_reg,T,fiveyear_period,Time_step)
VNEPgas(I_reg,T)
VNFPgas1(I_reg,T,fiveyear_period,Time_step)
VNFPgas(I_reg,T)

VNPSol(solar_type,solar_sites,T)
*VNPSol_tot_Ireg(I_reg,T)
VNESol1_sites(solar_type,solar_sites,T,Time_step)
VNESol1(solar_type,I_reg,T,Time_step)
VNESol(solar_type,I_reg,T)

tot_solar_area(solar_sites,T)
tot_solar(I_reg,T)
*tot_P_VRES_Ireg(I_reg,T)

*$if %linear_fossil_cost_supply% == "yes"         gas_peakfuel(I_reg,cost_supply,T)
$if %linear_fossil_cost_supply% == "yes"         V_cost_supply_fuel(cost_supply,TWh,T)
*$if %linear_fossil_cost_supply% == "yes"         V_price_cost_supply(cost_supply,T)
$if %linear_fossil_cost_supply% == "yes"         V_cost_supply_fuel_cost(T)
$ifi %regional%==yes     punish_RES_pos
$ifi %regional%==yes     punish_RES_neg
$ifi %regional%==yes     punish_NUC_pos
$ifi %regional%==yes     punish_NUC_neg

$if %solar_grid_parity% == "yes" V_solar_value(I_reg,TWh,T)
;
