********************************************************************
***      Definition of  model                                    ***
***                                                              ***
********************************************************************



***      Objective function      ***

system_costEQU..
                 tot_cost=E=sum((I_reg,T),disprod_cost(I_reg,T)+disaninv_cost(I_reg,T))
$if %linear_fossil_cost_supply% == "yes"         +sum(T,V_cost_supply_fuel_cost(T)/((1+Ir)**(T_num(T)-2009)))
$if %linear_biomarket_cost_supply% == "yes"            +sum(T,V_cost_supply_biomarket_cost(T)/((1+Ir)**(T_num(T)-2009)))
*$ifi %regional%=="yes"                                 +1000*(punish_RES_pos-punish_RES_neg+punish_NUC_pos-punish_NUC_neg);
$if %solar_grid_parity% == "yes"                 -sum((I_reg,T),sum(TWh,V_solar_value(I_reg,TWh,T)*Solar_deduct(I_reg,TWh,T))/((1+Ir)**(T_num(T)-2009)))
;


set
$if %linear_fossil_cost_supply% == "no"         thermal_nobio(Thermal)
$if %linear_fossil_cost_supply% == "yes"         thermal_nobio_nocs(Thermal)
         /
$if %linear_fossil_cost_supply% == "no"         B
$if %linear_fossil_cost_supply% == "no"         H
$if %linear_fossil_cost_supply% == "no"         G

         O       Oil
         P       Peat
         U       Nuclear/
;


* Generation costs
Prod_costEQU(I_reg,T)..
                 Prod_cost(I_reg,T)=G=
* var O&M costs present capacities
                 (EEH_RO(I_reg,T)+VEEH_REG(I_reg,T))*EPH_OM(I_reg,"RO","var")+
                 EEW(I_reg,T)*EPW_OM(I_reg,"onwind20","var",T)+
                 EESol(I_reg,T)*EPSol_OM("fixed_building_monoSi",I_reg,"var",T)+
                 sum((thermal,plant_type),VEETtype(I_reg,thermal,plant_type,T)*EPT_OM(I_reg,thermal,plant_type,"var"))+
                 sum(non_PV,EEO(I_reg,non_PV,T)*EPO_OM(I_reg,non_PV,"var"))+
* fuel costs present capacities excluding biomass and waste
$if %linear_fossil_cost_supply% == "yes"                 sum(thermal_nobio_nocs,sum(plant_type,VEFTtype(I_reg,thermal_nobio_nocs,plant_type,T))*Fc(I_reg,thermal_nobio_nocs,T))+
$if %linear_fossil_cost_supply% == "no"                 sum(thermal_nobio,sum(plant_type,VEFTtype(I_reg,thermal_nobio,plant_type,T))*Fc(I_reg,thermal_nobio,T))+
* fixed O&M costs present capacities
                 sum(hydro_class,Residual_P_hydroclass(I_reg,hydro_class,T)*EPH_OM(I_reg,"RO","fix"))+
                 sum((nuts2,wind)$(regions_to_nuts2(I_reg,nuts2)),Residual_wind_nuts2(nuts2,wind,T)*EPW_OM(I_reg,"onwind20","fix",T))+
                 sum(nuts2$(regions_to_nuts2(I_reg,nuts2)),residual_PV_nuts2(nuts2,T)*EPSol_OM("fixed_building_monoSi",I_reg,"fix",T))+
                 sum((thermal,plant_type,inv_year),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el",T,inv_year)*EPT_OM(I_reg,thermal,plant_type,"fix"))+
                 sum(others,Residual_P_others(I_reg,others,T)*EPO_OM(I_reg,others,"fix"))+
* O&M costs new capacities
                 sum(wind_type,VNEW(I_reg,wind_type,T)*EPW_OM(I_reg,wind_type,"var",T))+
                 sum((nuts2,wind_type)$(regions_to_nuts2(I_reg,nuts2)),VNPW(nuts2,wind_type,T)*EPW_OM(I_reg,wind_type,"fix",T))+

                 sum(solar_type,VNESol(solar_type,I_reg,T)*EPSol_OM(solar_type,I_reg,"var",T))+
                 sum((solar_sites,solar_type)$(solar_sites_to_regions(solar_sites,I_reg)),VNPSol(solar_type,solar_sites,T)*EPSol_OM(solar_type,I_reg,"fix",T))+

                 sum((Time_step,storage_systems),VNEStorageOut(storage_systems,I_reg,T,Time_step)*NEStorage_OM(storage_systems,I_reg,"var",T))+
                 sum(storage_systems,VNEStorageCap(storage_systems,I_reg,T)*NEStorage_OM(storage_systems,I_reg,"fix",T))+

                 (VNEH_RO(I_reg,T)+VNEH_REG(I_reg,T))*EPH_OM(I_reg,"RO","var")+
                 sum(hydro_class,VNPH(I_reg,hydro_class,T)*EPH_OM(I_reg,"RO","fix"))+
                 sum((thermal,plant_type),VNETtype(I_reg,thermal,plant_type,T)*EPT_OM(I_reg,thermal,plant_type,"var"))+
                 sum((thermal,plant_type),VNPTtype(I_reg,thermal,plant_type,T)*EPT_OM(I_reg,thermal,plant_type,"fix"))+
                 sum(non_PV,VNEO(I_reg,non_PV,T)*EPO_OM(I_reg,non_PV,"var"))+
                 sum(non_PV,VNPO(I_reg,non_PV,T)*EPO_OM(I_reg,non_PV,"fix"))+
                 sum(geothermal,VNEGEO(I_reg,geothermal,T)*NPGEO_OM(I_reg,geothermal,"var"))+
                 sum(geothermal,VNPGEO(I_reg,geothermal,T)*NPGEO_OM(I_reg,geothermal,"fix"))+
                 sum((CCS,plant_type),VNECCStype(I_reg,CCS,plant_type,T)*NPCCS_OM(I_reg,CCS,plant_type,"var"))+
                 sum((CCS,plant_type),VNPCCStype(I_reg,CCS,plant_type,T)*NPCCS_OM(I_reg,CCS,plant_type,"fix"))+
*fuel costs new investments excluding biomass and waste
$if %linear_fossil_cost_supply% == "yes"                 sum((thermal_nobio_nocs,plant_type),VNFTtype(I_reg,thermal_nobio_nocs,plant_type,T)*Fc(I_reg,thermal_nobio_nocs,T))+
$if %linear_fossil_cost_supply% == "no"                 sum((thermal_nobio,plant_type),VNFTtype(I_reg,thermal_nobio,plant_type,T)*Fc(I_reg,thermal_nobio,T))+

$if %linear_fossil_cost_supply% == "no"                 sum(CCS_fuels$(fuel_num(CCS_fuels) ne fuel_num("W")),VNFCCS(I_reg,CCS_fuels,T)*Fc(I_reg,CCS_fuels,T))+
*peak gas fuel costs
$if %linear_fossil_cost_supply% == "no"                  VNFPgas(I_reg,T)*Fc(I_reg,"G",T)+
*fuel costs for biomass and waste technologies
                 sum(bio_class,VBio_nation(I_reg,bio_class,T)*Fc_national_bio(I_reg,bio_class))+
$if %linear_biomarket_cost_supply% == "no"                                  VBio_market(I_reg,T)*Fc(I_reg,"W",T)+
                 sum(waste_class,Vwaste_nation(I_reg,waste_class,T)*Fc_national_waste(I_reg,waste_class))+
*fuel costs in B,H and G if cost supply is applied
*given separate down below for entire I_reg

*CO2 transportation and storage cost
                 sum((CCS,plant_type),VNFCCStype(I_reg,CCS,plant_type,T)*CCS_store_EF(I_reg,CCS))*(CO2_store_cost(I_reg,"transport")+CO2_store_cost(I_reg,"storage"))

;

disprod_costEQU(I_reg,T)..
                 disprod_cost(I_reg,T)=G=Prod_cost(I_reg,T)/((1+Ir)**(T_num(T)-2009));

*** Annualities calculated for TL and not for depreciation time
aninv_costEQU(I_reg,T)..
                 aninv_cost(I_reg,T)=G=
*wind
                 sum((nuts2,wind_type,year)$(regions_to_nuts2(I_reg,nuts2) and T_num(year) gt T_num(T-EPW_TL(nuts2)) and T_num(year) le T_num(T)),Inv_VNPW(nuts2,wind_type,year)*NPW_Ic(nuts2,wind_type,"plant",year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+EPW_TL(nuts2)),(1/(1+Ir)**(TL_num(TL_year)))))+
*Solar  (changed technical life to be based on solar_type not nuts2 regions, and changed from wind to solar technical life)
                 sum((solar_sites,solar_type,year)$(solar_sites_to_regions(solar_sites,I_reg) and T_num(year) gt T_num(T-EPSol_TL(solar_type)) and T_num(year) le T_num(T)),Inv_VNPSol(solar_type,solar_sites,year)*NPSol_Ic(solar_type,solar_sites,"plant",year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+EPSol_TL(solar_type)),(1/(1+Ir)**(TL_num(TL_year)))))+
*hydro
                 sum((hydro_class,year)$(T_num(year) gt T_num(T-EPH_TL(I_reg,hydro_class)) and T_num(year) le T_num(T)),Inv_VNPH(I_reg,hydro_class,year)*NPH_Ic(I_reg,hydro_class,"plant",year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+EPH_TL(I_reg,hydro_class)),(1/(1+Ir)**(TL_num(TL_year)))))+

*thermal
                 sum((thermal,plant_type,year)$(T_num(year) gt T_num(T-EPT_TL(I_reg,thermal,plant_type)) and T_num(year) le T_num(T)),
                 Inv_VNPTtype(I_reg,thermal,plant_type,year)*NPT_Ic(I_reg,thermal,plant_type,"plant",year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+EPT_TL(I_reg,thermal,plant_type)),(1/(1+Ir)**(TL_num(TL_year)))))+

*peak gas
                 sum(year$(T_num(year) gt T_num(T-TL_peakgas(I_reg)) and T_num(year) le T_num(T)),
                 Inv_VNPPgas(I_reg,year)*NPPgas_Ic(I_reg,"plant",year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+TL_peakgas(I_reg)),(1/(1+Ir)**(TL_num(TL_year)))))+

*others
                 sum((non_PV,year)$(T_num(year) gt T_num(T-NPO_TL(I_reg,non_PV)) and T_num(year) le T_num(T)),Inv_VNPO(I_reg,non_PV,year)*NPO_Ic(I_reg,non_PV,"plant",year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+NPO_TL(I_reg,non_PV)),(1/(1+Ir)**(TL_num(TL_year)))))+

*geothermal
                 sum((geothermal,year)$(T_num(year) gt T_num(T-NPGEO_TL(I_reg,geothermal)) and T_num(year) le T_num(T)),Inv_VNPGEO(I_reg,geothermal,year)*NPGEO_Ic(I_reg,geothermal,"plant",year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+NPGEO_TL(I_reg,geothermal)),(1/(1+Ir)**(TL_num(TL_year)))))+

*CCS
                 sum((CCS,plant_type,year)$(T_num(year) gt T_num(T-NPCCS_TL(I_reg,CCS,plant_type)) and T_num(year) le T_num(T)),
                 Inv_VNPCCStype(I_reg,CCS,plant_type,year)*NPCCS_Ic(I_reg,CCS,plant_type,"plant",year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+NPCCS_TL(I_reg,CCS,plant_type)),(1/(1+Ir)**(TL_num(TL_year)))))+
*interconnectors
                 sum((import_reg,year)$(T_num(year) gt T_num(T-NP_trade_TL) and T_num(year) le T_num(T)),
                 Inv_NP_trade(I_reg,import_reg,year)*NP_trade_Ic(I_reg,import_reg,year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+NP_trade_TL),(1/(1+Ir)**(TL_num(TL_year)))))+
* Storage
                 sum((storage_systems,year)$(T_num(year) gt T_num(T-EPStorage_TL(storage_systems)) and T_num(year) le T_num(T)),
                 Inv_VNEStorage(storage_systems,I_reg,year)*NEStorage_Ic(storage_systems,I_reg,year)/
                 sum(TL_year$(TL_num(TL_year) ge TL_num("x-1") and TL_num(TL_year) lt TL_num("x-1")+EPStorage_TL(storage_systems)),(1/(1+Ir)**(TL_num(TL_year)))))
;

disaninv_costEQU(I_reg,T)..
                 disaninv_cost(I_reg,T)=G=aninv_cost(I_reg,T)/((1+Ir)**(T_num(T)-2009));

*** Tot generation ***
genEQU2(I_reg,T,Time_step)..
                 gen_region(I_reg,T,Time_step)=E=
                 sum((thermal,plant_type,tenyear_period),VEETtype1(I_reg,thermal,plant_type,T,tenyear_period,Time_step))+
                 EEH1_RO(I_reg,T,Time_step)+VEEH1_REG(I_reg,T,Time_step)+
                 EEW1(I_reg,T,Time_step)+sum(wind_type,VNEW1(I_reg,wind_type,T,Time_step))+
                 EESol1(I_reg,T,Time_step)+sum(solar_type,VNESol1(solar_type,I_reg,T,Time_step))+
                 VNEH1_RO(I_reg,T,Time_step)+VNEH1_REG(I_reg,T,Time_step)+
                 sum((thermal,plant_type,fiveyear_period),VNETtype1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step))+
                 sum(fiveyear_period,VNEPgas1(I_reg,T,fiveyear_period,Time_step))+
                 sum(non_PV,EEO1(I_reg,non_PV,T,Time_step))+sum(non_PV,VNEO1(I_reg,non_PV,T,Time_step))+
                 sum(geothermal,VNEGEO(I_reg,geothermal,T))*Time_step_length(Time_step)/8.76+
                 sum((CCS,plant_type,fiveyear_period),VNECCStype1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step))+
                 sum(storage_systems, storageEfficiency(storage_systems)*VNEStorageOut(storage_systems,I_reg,T,Time_step) - VNEStorageIn(storage_systems,I_reg,T,Time_step));

genEQU22(I_reg,T,Time_step)..
                 demand_timestep(I_reg,T,Time_step)=L=gen_region(I_reg,T,Time_step)+EE_import(I_reg,T,Time_step)-EE_export(I_reg,T,Time_step)
                 +NE_import(I_reg,T,Time_step)-NE_export(I_reg,T,Time_step);

genEQU1(T)..
                 gen(T)=L=sum((I_reg,Time_step),gen_region(I_reg,T,Time_step));

tot_RESEQU(T)..
                 tot_RES(T)=E=sum((I_reg,plant_type),VEETtype(I_reg,"W",plant_type,T))+
                 sum(I_reg,EEH_RO(I_reg,T)+VEEH_REG(I_reg,T))+sum(I_reg,EEW(I_reg,T))+sum(I_reg,EESol(I_reg,T))+
                 sum((I_reg,wind_type),VNEW(I_reg,wind_type,T))+sum((I_reg,solar_type),VNESol(solar_type,I_reg,T))+
                 sum(I_reg,VNEH_REG(I_reg,T)+VNEH_RO(I_reg,T))+sum((I_reg,plant_type),VNETtype(I_reg,"W",plant_type,T))+
                 sum((I_reg,non_PV),EEO(I_reg,non_PV,T))+sum((I_reg,non_PV),VNEO(I_reg,non_PV,T))+
                 sum((I_reg,CCS_bio,plant_type),bio_fraction(CCS_bio)*VNECCStype(I_reg,CCS_bio,plant_type,T));

StorageBalanceEQU(storage_systems,I_reg,T,Time_step)$(mod(ord(Time_step),4) <> 1)..
                 VNEStorageLevel(storage_systems,I_reg,T,Time_step) =E= VNEStorageLevel(storage_systems,I_reg,T,Time_step-1) +
                         VNEStorageIn(storage_systems,I_reg,T,Time_step) - VNEStorageOut(storage_systems,I_reg,T,Time_step);

StorageBalanceBoundaryEQU(storage_systems,I_reg,T,Time_step)$(mod(ord(Time_step),4) = 1)..
                 VNEStorageLevel(storage_systems,I_reg,T,Time_step) =E= VNEStorageLevel(storage_systems,I_reg,T,Time_step+3) +
                         VNEStorageIn(storage_systems,I_reg,T,Time_step) - VNEStorageOut(storage_systems,I_reg,T,Time_step);

StorageLimitEQU(storage_systems,I_reg,T,Time_step)$(mod(ord(Time_step),4) <> 0)..
                 VNEStorageLevel(storage_systems,I_reg,T,Time_step) =L= VNEStorageCap(storage_systems,I_reg,T)*Time_step_length(Time_step+1)*1000/12;

StorageLimitBoundaryEQU(storage_systems,I_reg,T,Time_step)$(mod(ord(Time_step),4) = 0)..
                 VNEStorageLevel(storage_systems,I_reg,T,Time_step) =L= VNEStorageCap(storage_systems,I_reg,T)*Time_step_length(Time_step-3)*1000/12;

ThermalStorageInEQU(I_reg,T,Time_step)..
                 VNEStorageIn('TES',I_reg,T,Time_step) =L= VNESol1('tracking_CSP',I_reg,T,Time_step);

ThermalStorageOutEQU(I_reg,T,Time_step)..
                 VNEStorageOut('TES',I_reg,T,Time_step) =L= sum(solar_sites$solar_sites_to_regions(solar_sites,I_reg),VNPSol('tracking_CSP',solar_sites,T)*Time_step_length(Time_step));

*tot_P_VRES_IregEQU(I_reg,T)..
*                 lim_VRES(I_reg,T)+sum(import_reg,EPCON(I_reg,import_reg)+NP_trade(I_reg,import_reg,T))=G=
*                 sum((nuts2,wind_type)$regions_to_nuts2(I_reg,nuts2),VNPW(nuts2,wind_type,T))+
*                 sum((nuts2,solar_type)$regions_to_nuts2(I_reg,nuts2), VNPSol(nuts2,solar_type,T))
*;


$ifi %regional%==yes $goto regionalRES
tot_RES_IregEQU(I_reg,T)..
                 tot_RES_Ireg(I_reg,T)=E=sum((plant_type),VEETtype(I_reg,"W",plant_type,T))+
                 EEH_RO(I_reg,T)+VEEH_REG(I_reg,T)+EEW(I_reg,T)+EESol(I_reg,T)+
                 sum(wind_type,VNEW(I_reg,wind_type,T))+sum(solar_type,VNESol(solar_type,I_reg,T))+
                 VNEH_REG(I_reg,T)+VNEH_RO(I_reg,T)+sum(plant_type,VNETtype(I_reg,"W",plant_type,T))+
                 sum(non_PV,EEO(I_reg,non_PV,T))+sum(non_PV,VNEO(I_reg,non_PV,T))+
                 sum((CCS_bio,plant_type),bio_fraction(CCS_bio)*VNECCStype(I_reg,CCS_bio,plant_type,T));


$goto all_solar
$label regionalRES
tot_RES_IregEQU(dbcountry,T)..
                 sum(I_reg$country_to_EPODreg(dbcountry,I_reg),tot_RES_Ireg(I_reg,T))=E=sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum((plant_type),VEETtype(I_reg,"W",plant_type,T))+
                 EEH_RO(I_reg,T)+VEEH_REG(I_reg,T)+EEW(I_reg,T)+EESol(I_reg,T)+
                 sum(wind_type,VNEW(I_reg,wind_type,T))+sum(solar_type,VNESol(I_reg,solar_type,T))+
                 VNEH_REG(I_reg,T)+VNEH_RO(I_reg,T)+sum(plant_type,VNETtype(I_reg,"W",plant_type,T))+
                 sum(non_PV,EEO(I_reg,non_PV,T))+sum(non_PV,VNEO(I_reg,non_PV,T)));

$label all_solar

tot_solar_area_centralEQU(solar_sites,T)..
                 solar_pot_centralized(solar_sites) =G=
                         sum(solar_type$(not building_solar_type(solar_type)),
                                 VNPSol(solar_type,solar_sites,T)/solar_cap_intensity(solar_type));

tot_solar_area_buildingEQU(solar_sites,T)..
                 solar_pot_buildings(solar_sites) =G=
                         sum(building_solar_type,
                                 VNPSol(building_solar_type,solar_sites,T)/solar_cap_intensity(building_solar_type));
*tot_solarEQU(I_reg,T)..
*                 tot_solar(I_reg,T)=E=EESol(I_reg,T)+sum(solar_type,VNESol(solar_type,I_reg,T));
**** Increased value for residential own consumed electrcity
$if %solar_grid_parity% == "yes" solar_value_EQU(I_reg,T)..
$if %solar_grid_parity% == "yes"                 sum(TWh,V_solar_value(I_reg,TWh,T))=L=EESol(I_reg,T)+sum(building_solar_type,VNESol(building_solar_type,I_reg,T))
$if %solar_grid_parity% == "yes"                 ;

$ontext
$ifi %regional%==yes $goto regionalsolar
tot_solar_IregEQU(I_reg,T)..
                 tot_solar_Ireg(I_reg,T)=E=EESol(I_reg,T)+sum(solar_type,VNESol(solar_type,I_reg,T));
$goto fuel_cons
$label regionalsolar
tot_solar_IregEQU(dbcountry,T)..
                 sum(I_reg$country_to_EPODreg(dbcountry,I_reg),tot_solar_Ireg(I_reg,T))=E=sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum(solar_type,VNESol(I_reg,solar_type,T)));

$label fuel_cons
$offtext

*** Fuel consumption ***
$ifi %regional%==yes $goto regionalfuels
bio_fuelEQU(I_reg,T)..
                 sum(bio_class,VBio_nation(I_reg,bio_class,T))+VBio_market(I_reg,T)=E=sum(plant_type,VEFTtype(I_reg,"W",plant_type,T)+
                 VNFTtype(I_reg,"W",plant_type,T))+VNFCCS(I_reg,"W",T);

waste_fuelEQU(I_reg,T)..
                 sum(waste_class,Vwaste_nation(I_reg,waste_class,T))=E=sum(plant_type,VEFTtype(I_reg,"WA",plant_type,T)+
                 VNFTtype(I_reg,"WA",plant_type,T));
$ifi %national%==yes $goto nationalfuels
$label regionalfuels
bio_fuelEQU(dbcountry,T)..
                 sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum(bio_class,VBio_nation(I_reg,bio_class,T))+VBio_market(I_reg,T))=E=
                 sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum(plant_type,VEFTtype(I_reg,"W",plant_type,T)+VNFTtype(I_reg,"W",plant_type,T))+VNFCCS(I_reg,"W",T));

waste_fuelEQU(dbcountry,T)..
                 sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum(waste_class,Vwaste_nation(I_reg,waste_class,T)))=E=
                 sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum(plant_type,VEFTtype(I_reg,"WA",plant_type,T)+VNFTtype(I_reg,"WA",plant_type,T)));

$label nationalfuels

lignite_fuelEQU(I_reg,T)..
                 Lignite_fuel(I_reg,T)=E=sum(plant_type,VEFTtype(I_reg,"B",plant_type,T)+
                 VNFTtype(I_reg,"B",plant_type,T))+VNFCCS(I_reg,"B",T);


$if %linear_biomarket_cost_supply% == "yes" cost_supply_bioEQU(T)..
$if %linear_biomarket_cost_supply% == "yes"                 sum(TWh,V_cost_supply_biomarket(TWh,T))=E=sum(I_reg,VBio_market(I_reg,T));



*$ontext
$if %linear_fossil_cost_supply% == "yes" cost_supply_fuelEQU1(T)..
$if %linear_fossil_cost_supply% == "yes"                 sum(TWh,V_cost_supply_fuel("B",TWh,T))=G=sum(I_reg,sum(plant_type,VEFTtype(I_reg,"B",plant_type,T)+
$if %linear_fossil_cost_supply% == "yes"                 VNFTtype(I_reg,"B",plant_type,T))+VNFCCS(I_reg,"B",T));
$if %linear_fossil_cost_supply% == "yes" cost_supply_fuelEQU2(T)..
$if %linear_fossil_cost_supply% == "yes"                 sum(TWh,V_cost_supply_fuel("H",TWh,T))=G=sum(I_reg,sum(plant_type,VEFTtype(I_reg,"H",plant_type,T)+
$if %linear_fossil_cost_supply% == "yes"                 VNFTtype(I_reg,"H",plant_type,T))+VNFCCS(I_reg,"H",T));
$if %linear_fossil_cost_supply% == "yes" cost_supply_fuelEQU3(T)..
$if %linear_fossil_cost_supply% == "yes"                 sum(TWh,V_cost_supply_fuel("G",TWh,T))=G=sum(I_reg,sum(plant_type,VEFTtype(I_reg,"G",plant_type,T)+
$if %linear_fossil_cost_supply% == "yes"                 VNFTtype(I_reg,"G",plant_type,T))+VNFCCS(I_reg,"G",T)+VNFPgas(I_reg,T));

*$offtext

*** Summing up total fuel costs for I_reg (cf above in prod_costEQU)
$if %linear_fossil_cost_supply% == "yes" cost_supply_fuelEQU(T)..
$if %linear_fossil_cost_supply% == "yes"                 V_cost_supply_fuel_cost(T)=G=sum(cost_supply,sum(TWh,V_cost_supply_fuel(cost_supply,TWh,T)*Fc_linear_cost_supply_fossil(cost_supply,TWh)));

$if %linear_biomarket_cost_supply% == "yes" cost_supply_biomarketEQU(T)..
$if %linear_biomarket_cost_supply% == "yes"                    V_cost_supply_biomarket_cost(T)=G=sum(TWh,V_cost_supply_biomarket(TWh,T)*Fc_linear_cost_supply_biomarket(TWh));

*cost_supply_fuelEQU1.m(cost_supply,T));



*$ontext
*$if %linear_fossil_cost_supply% == "yes" Price_cost_supply_fuelEQU(cost_supply,T)..
*$if %linear_fossil_cost_supply% == "yes"                 V_price_cost_supply(cost_supply,T)=G=sum(TWh,V_cost_supply_fuel(cost_supply,TWh,T))*linear_cost_parameters(cost_supply,"k_cost")+linear_cost_parameters(cost_supply,"m_cost");
*$offtext

*** Equations coupled to boundary conditions ***
$ifi %regional%==yes $goto regionalnuclear
totP_nuclear_IregEQU(I_reg,T)..
         totP_nuclear_Ireg(I_reg,T)=E=sum(tenyear_period,Residual_P_thermal_10(I_reg,"U","Condens","capacity_el",T,tenyear_period))+VNPTtype(I_reg,"U","Condens",T);
$goto totE_hydro
$label regionalnuclear
totP_nuclear_dbcountryEQU(dbcountry,T)..
         totP_nuclear_dbcountry(dbcountry,T)=E=sum(I_reg$country_to_EPODreg(dbcountry,I_reg),sum(tenyear_period,Residual_P_thermal_10(I_reg,"U","Condens","capacity_el",T,tenyear_period))+VNPTtype(I_reg,"U","Condens",T));

$label totE_hydro

totE_hydro_ROEQU(I_reg,T)..
                 hydro_prod_max(I_reg,"run_riv",T)=G=EEH_RO(I_reg,T)+VNEH_RO(I_reg,T);

totE_hydro_REGEQU(I_reg,T)..
                 hydro_prod_max(I_reg,"reg",T)=G=VEEH_REG(I_reg,T)+VNEH_REG(I_reg,T);


totE_BP_EQU(I_reg,T)..
                 BP_el(I_reg,T)=E=sum((thermal,B_P),VEETtype(I_reg,thermal,B_P,T)+
                 VNETtype(I_reg,thermal,B_P,T));

totH_CHP_EQU(I_reg,T,Time_step)..
                 totH_CHP(I_reg,T,Time_step)=L=sum((thermal,C_HP,tenyear_period),VEHTtype1(I_reg,thermal,C_HP,T,tenyear_period,Time_step))+
                 sum((thermal,C_HP,fiveyear_period),VNHTtype1(I_reg,thermal,C_HP,T,fiveyear_period,Time_step));
$ifthen %capacity_constraint%==on
system_capEQU(T)..
                 sum(I_reg,system_max_load(I_reg,T))=L=
                 sum(I_reg,
                 sum((nuts2,wind)$(regions_to_nuts2(I_reg,nuts2)),Residual_wind_nuts2(nuts2,wind,T)*cap_factor_wind_exist(nuts2))+
                 sum((nuts2,wind_type)$(regions_to_nuts2(I_reg,nuts2)),VNPW(nuts2,wind_type,T)*cap_factor_wind_new(nuts2,wind_type))+

                 sum((solar_type,solar_sites)$(solar_sites_to_regions(solar_sites,I_reg)),VNPSol(solar_type,solar_sites,T)*cap_factor_solar_new(solar_type,solar_sites))+
                 sum(nuts2$(regions_to_nuts2(I_reg,nuts2)),residual_PV_nuts2(nuts2,T)*cap_factor_solar_exist("fixed_building_monoSi",nuts2))+

                 (residual_P_hydroclass(I_reg,"run_riv",T)+VNPH(I_reg,"run_riv",T))*cap_factor_hydro(I_reg,"run_riv")+
                 (residual_P_hydroclass(I_reg,"reg",T)+VNPH(I_reg,"reg",T))*cap_factor_hydro(I_reg,"reg")+
                 sum((thermal,plant_type),(sum(inv_year,Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el",T,inv_year))+
                         VNPTtype(I_reg,thermal,plant_type,T))*cap_factor_thermal(I_reg,thermal,plant_type))+
                 (VNPPgas(I_reg,T)*cap_factor_Pgas(I_reg))+
                 sum((CCS,plant_type),VNPCCStype(I_reg,CCS,plant_type,T)*cap_factor_CCS(I_reg,CCS,plant_type))+
                 sum(non_PV,Residual_P_others(I_reg,non_PV,T)*cap_factor_others(I_reg,non_PV))+
                 sum(non_PV,VNPO(I_reg,non_PV,T)*cap_factor_others(I_reg,non_PV))+
                 sum(geothermal,VNPGEO(I_reg,geothermal,T)*cap_factor_geothermal(I_reg,geothermal))
                 +
                 sum(export_reg,NP_trade(export_reg,I_reg,T)*cap_factor_intercon(I_reg))
                 );

system_capEQU1(I_reg,T)..
*$ifi %national%==yes                 (system_max_load(I_reg,T)/demand(I_reg,T))*sum(time_step,gen_region(I_reg,T,Time_step))=L=
*$ifi %regional%==yes
                 system_max_load(I_reg,T)=L=

                 (
                 sum(exp_region,EPCON(exp_region,I_reg)*cap_factor_intercon(I_reg))+
                 sum((nuts2,wind)$(regions_to_nuts2(I_reg,nuts2)),Residual_wind_nuts2(nuts2,wind,T)*cap_factor_wind_exist(nuts2))+
                 sum((nuts2,wind_type)$(regions_to_nuts2(I_reg,nuts2)),VNPW(nuts2,wind_type,T)*cap_factor_wind_new(nuts2,wind_type))+

                 sum((solar_type,solar_sites)$(solar_sites_to_regions(solar_sites,I_reg)),VNPSol(solar_type,solar_sites,T)*cap_factor_solar_new(solar_type,solar_sites))+
                 sum(nuts2$(regions_to_nuts2(I_reg,nuts2)),residual_PV_nuts2(nuts2,T)*cap_factor_solar_exist("fixed_building_monoSi",nuts2))+

                 (residual_P_hydroclass(I_reg,"run_riv",T)+VNPH(I_reg,"run_riv",T))*cap_factor_hydro(I_reg,"run_riv")+
                 (residual_P_hydroclass(I_reg,"reg",T)+VNPH(I_reg,"reg",T))*cap_factor_hydro(I_reg,"reg")+
                 sum((thermal,plant_type),(sum(inv_year,Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el",T,inv_year))+
                         VNPTtype(I_reg,thermal,plant_type,T))*cap_factor_thermal(I_reg,thermal,plant_type))+
                 (VNPPgas(I_reg,T)*cap_factor_Pgas(I_reg))+
                 sum((CCS,plant_type),VNPCCStype(I_reg,CCS,plant_type,T)*cap_factor_CCS(I_reg,CCS,plant_type))+
                 sum(non_PV,Residual_P_others(I_reg,non_PV,T)*cap_factor_others(I_reg,non_PV))+
                 sum(non_PV,VNPO(I_reg,non_PV,T)*cap_factor_others(I_reg,non_PV))+
                 sum(geothermal,VNPGEO(I_reg,geothermal,T)*cap_factor_geothermal(I_reg,geothermal))
                 +
                 sum(export_reg,NP_trade(export_reg,I_reg,T)*cap_factor_intercon(I_reg))
                 );
$endif

VCO2EQU1(T)..
                 VCO2(T)=E=sum((I_reg,C_emitting,plant_type),
                 VEFTtype(I_reg,C_emitting,plant_type,T)*3.6/1000*C_intensity(I_reg,C_emitting)*44/12)+
                 sum((I_reg,C_emitting,plant_type),
                 VNFTtype(I_reg,C_emitting,plant_type,T)*3.6/1000*C_intensity(I_reg,C_emitting)*44/12)+
                 sum(I_reg,VNFPgas(I_reg,T)*3.6/1000*C_intensity(I_reg,"G")*44/12)+
                 sum((I_reg,CCS,plant_type),VNFCCStype(I_reg,CCS,plant_type,T)*CCS_EF(I_reg,CCS));


model ELIN /all/;
ELIN.scaleopt=1;
*$include 2_scale_model

option lp = CPLEX;
option iterlim = 10000000;
option reslim = 3000000;

*** include if CPLEX optfile in force
ELIN.OptFile=1;

ELIN.savepoint=1;


solve ELIN using LP minimizing tot_cost;

