********************************************************************
***      Structure equations                                     ***
***                                                              ***
********************************************************************

*** Generation in present capacities ***
* Thermal
Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period)=sum(inv_year$(Num_inv_year(inv_year) ge first_year10(tenyear_period)
                         and Num_inv_year(inv_year) le last_year10(tenyear_period)),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_el",T,inv_year));
Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_heat",T,tenyear_period)=sum(inv_year$(Num_inv_year(inv_year) ge first_year10(tenyear_period)
                         and Num_inv_year(inv_year) le last_year10(tenyear_period)),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_heat",T,inv_year));
Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_boiler",T,tenyear_period)=sum(inv_year$(Num_inv_year(inv_year) ge first_year10(tenyear_period)
                         and Num_inv_year(inv_year) le last_year10(tenyear_period)),Residual_P_thermal(I_reg,thermal,plant_type,"capacity_boiler",T,inv_year));

VEET_EQU1(I_reg,thermal,plant_type,T,tenyear_period,Time_step)$(Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period) gt 0)..
                 VEETtype1(I_reg,thermal,plant_type,T,tenyear_period,Time_step)=L=Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period)*Time_step_length(Time_step);

VEET_EQU11(I_reg,thermal,plant_type,T)..
                 sum((tenyear_period,Time_step),VEETtype1(I_reg,thermal,plant_type,T,tenyear_period,Time_step))=L=sum((tenyear_period,Time_step),Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period)*EPT_LF(I_reg,thermal,plant_type)*Time_step_length(Time_step));

VEHT_EQU1(I_reg,thermal,C_HP,T,tenyear_period,Time_step)$(Residual_P_thermal_10(I_reg,thermal,C_HP,"capacity_el",T,tenyear_period) gt 0)..
                 VEHTtype1(I_reg,thermal,C_HP,T,tenyear_period,Time_step)=E=Residual_P_thermal_10(I_reg,thermal,C_HP,"capacity_heat",T,tenyear_period)/Residual_P_thermal_10(I_reg,thermal,C_HP,"capacity_el",T,tenyear_period)*VEETtype1(I_reg,thermal,C_HP,T,tenyear_period,Time_step);

VEET_EQU(I_reg,thermal,plant_type,T)$(sum(tenyear_period,Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period)) gt 0)..
                 VEETtype(I_reg,thermal,plant_type,T)=E=sum((tenyear_period,Time_step),VEETtype1(I_reg,thermal,plant_type,T,tenyear_period,Time_step));


VEHT_EQU(I_reg,thermal,C_HP,T)$(sum(tenyear_period,Residual_P_thermal_10(I_reg,thermal,C_HP,"capacity_el",T,tenyear_period)) gt 0)..
                 VEHTtype(I_reg,thermal,C_HP,T)=E=sum((tenyear_period,Time_step),VEHTtype1(I_reg,thermal,C_HP,T,tenyear_period,Time_step));


*Wind

EEW1_nuts2(nuts2,T,Time_step)=sum(wind,residual_wind_nuts2(nuts2,wind,T)*LFW_nuts2(nuts2,Time_step));
EEW1(I_reg,T,Time_step)=sum(nuts2$regions_to_nuts2(I_reg,nuts2),EEW1_nuts2(nuts2,T,Time_step));
EEW(I_reg,T)=sum(Time_step,EEW1(I_reg,T,Time_step));

*Solar PV
* Average LFS over sites in a NUTS2 region if any sites
EESol1_nuts2(nuts2,T,Time_step) = 0;
EESol1_nuts2(nuts2,T,Time_step)$(sum(solar_sites$solar_sites_to_nuts2(solar_sites,nuts2),1) > 0) =
         residual_PV_nuts2(nuts2,T)*sum(solar_sites$solar_sites_to_nuts2(solar_sites,nuts2),LFS("fixed_building_monoSi",solar_sites,Time_step))/sum(solar_sites$solar_sites_to_nuts2(solar_sites,nuts2),1);
SET nuts_wo_sites(nuts2);
nuts_wo_sites(nuts2)$(sum(solar_sites$solar_sites_to_nuts2(solar_sites,nuts2),1) eq 0) = yes;
execute_unload 'nuts_wo_sites.gdx', nuts_wo_sites;
EESol1(I_reg,T,Time_step)=sum(nuts2$regions_to_nuts2(I_reg,nuts2),EESol1_nuts2(nuts2,T,Time_step));
EESol(I_reg,T)=sum(Time_step,EESol1(I_reg,T,Time_step));


$ontext
EEW1(I_reg,wind_class,T,Time_step)=Residual_P_windclass(I_reg,wind_class,T)*LFW(I_reg,wind_class,Time_step);
EEW(I_reg,wind_class,T)=sum(Time_step,EEW1(I_reg,wind_class,T,Time_step));
$offtext

*Hydro
*EEH1_RO_EQU(I_reg,TY,Time_step)..
         EEH1_RO(I_reg,T,Time_step)=Residual_P_hydroclass(I_reg,"run_riv",T)*LFH(I_reg,Time_step);

*EEH_RO_EQU(I_reg,T)..
         EEH_RO(I_reg,T)=sum(Time_step,EEH1_RO(I_reg,T,Time_step));

VEEH_REG_EQU1(I_reg,T,Time_step)..
         VEEH1_REG(I_reg,T,Time_step)=L=Residual_P_hydroclass(I_reg,"reg",T)*Time_step_length(Time_step);
VEEH_REG_EQU(I_reg,T)..
         VEEH_REG(I_reg,T)=E=sum(Time_step,VEEH1_REG(I_reg,T,Time_step));

*Others
EEO1(I_reg,non_PV,T,Time_step)=Residual_P_others(I_reg,non_PV,T)*LFO(I_reg,non_PV,Time_step);
EEO(I_reg,non_PV,T)=sum(time_step,EEO1(I_reg,non_PV,T,Time_step));




*import export
EE_importEQU11(I_reg,export_reg,T,Time_step)$(valid_EP_trade(I_reg,export_reg))..
                 EE_import11(I_reg,export_reg,T,Time_step)=L=EPCON(export_reg,I_reg)*time_step_length(Time_step);

EE_importEQU1(I_reg,T,Time_step)..
                 EE_import(I_reg,T,Time_step)=E=sum(export_reg,EE_import11(I_reg,export_reg,T,Time_step));

EE_exportEQU11(I_reg,import_reg,T,Time_step)$(valid_EP_trade(I_reg,import_reg))..
                 EE_export11(I_reg,import_reg,T,Time_step)=L=EPCON(I_reg,import_reg)*time_step_length(Time_step);

EE_exportEQU1(I_reg,T,Time_step)..
                 EE_export(I_reg,T,Time_step)=E=sum(import_reg,EE_export11(I_reg,import_reg,T,Time_step));

trade_balanceEEEQU(import_reg,export_reg,T,Time_step)$(valid_EP_trade(export_reg,import_reg))..
                 EE_import11(import_reg,export_reg,T,Time_step)=E=0.9995*EE_export11(export_reg,import_reg,T,Time_step);


*** New investments ***
*Thermal
VNPTtype_EQU1(I_reg,thermal,plant_type,T,year)$(T_num(T) ge T_num(year)
                 and T_num(T) lt T_num(year)+EPT_TL(I_reg,thermal,plant_type)
                 and T_num(year) le T_num(T)
                 and valid_thermal(I_reg,thermal,plant_type))..
                 VNPTtype1(I_reg,thermal,plant_type,T,year)=E=
                 Inv_VNPTtype(I_reg,thermal,plant_type,year);

VNPTtype_EQU11(I_reg,thermal,plant_type,T,fiveyear_period)$(valid_thermal(I_reg,thermal,plant_type))..
                 VNPTtype_5year(I_reg,thermal,plant_type,T,fiveyear_period)=E=
                 sum(year$(T_num(year) ge first_year5(fiveyear_period) and T_num(year) le last_year5(fiveyear_period)),
                 VNPTtype1(I_reg,thermal,plant_type,T,year));

VNPTtype_EQU(I_reg,thermal,plant_type,T)$(valid_thermal(I_reg,thermal,plant_type))..
                 VNPTtype(I_reg,thermal,plant_type,T)=E=sum(year,VNPTtype1(I_reg,thermal,plant_type,T,year));

*** Peak gas technologies
VNPPgas_EQU1(I_reg,T,year)$(T_num(T) ge T_num(year)
                 and T_num(T) lt T_num(year)+TL_peakgas(I_reg)
                 and T_num(year) le T_num(T))..
                 VNPPgas1(I_reg,T,year)=E=
                 Inv_VNPPgas(I_reg,year);

VNPPgas_EQU11(I_reg,T,fiveyear_period)..
                 VNPPgas_5year(I_reg,T,fiveyear_period)=E=
                 sum(year$(T_num(year) ge first_year5(fiveyear_period) and T_num(year) le last_year5(fiveyear_period)),
                 VNPPgas1(I_reg,T,year));

VNPPgas_EQU(I_reg,T)..
                 VNPPgas(I_reg,T)=E=sum(year,VNPPgas1(I_reg,T,year));


*Wind
VNPW_EQU(nuts2,wind_type,T)$(valid_wind_type(nuts2,wind_type))..
                 VNPW(nuts2,wind_type,T)=E=sum(year$(T_num(year) gt T_num(T-EPW_TL(nuts2)) and T_num(year) le T_num(T)),
                 Inv_VNPW(nuts2,wind_type,year));

*Hydro
VNPH_EQU(I_reg,hydro_class,T)..
                 VNPH(I_reg,hydro_class,T)=E=sum(year$(T_num(year) gt T_num(T-EPH_TL(I_reg,hydro_class)) and T_num(year) le T_num(T)),
                 Inv_VNPH(I_reg,hydro_class,year));

*CCS
VNPCCStype_EQU1(I_reg,CCS,plant_type,T,year)$(valid_CCS(I_reg,CCS,plant_type)
                 and T_num(T) ge 2020
                 and T_num(year) ge 2020
                 and T_num(T) ge T_num(year)
                 and T_num(T) lt T_num(year)+NPCCS_TL(I_reg,CCS,plant_type)
                 and T_num(year) le T_num(T))..
                 VNPCCStype1(I_reg,CCS,plant_type,T,year)=E=
                 Inv_VNPCCStype(I_reg,CCS,plant_type,year);

VNPCCStype_EQU11(I_reg,CCS,plant_type,T,fiveyear_period)$(valid_CCS(I_reg,CCS,plant_type)
                 and T_num(T) ge 2020
                 and first_year5(fiveyear_period) ge 2020)..
                 VNPCCStype_5year(I_reg,CCS,plant_type,T,fiveyear_period)=E=
                 sum(year$(T_num(year) ge first_year5(fiveyear_period) and T_num(year) le last_year5(fiveyear_period)),
                 VNPCCStype1(I_reg,CCS,plant_type,T,year));

VNPCCStype_EQU(I_reg,CCS,plant_type,T)..
                 VNPCCStype(I_reg,CCS,plant_type,T)=E=sum(year,VNPCCStype1(I_reg,CCS,plant_type,T,year));
*Solar
VNPSol_EQU(solar_type,solar_sites,T)$valid_solar_sites(solar_sites)..
                 VNPSol(solar_type,solar_sites,T)=E=sum(year$(T_num(year) gt T_num(T-EPSol_TL(solar_type)) and T_num(year) le T_num(T)),
                 Inv_VNPSol(solar_type,solar_sites,year));

*VNPSol_EQU2(I_reg,T)..
*                 VNPSol_tot_Ireg(I_reg,T)=E=sum((nuts2,solar_type)$country_to_nuts2(I_reg,nuts2),VNPSol(nuts2,Solar_type,T))+sum(nuts2$country_to_nuts2(I_reg,nuts2),residual_PV_nuts2(nuts2,T));
*Others
VNPO_EQU(I_reg,non_PV,T)..
                 VNPO(I_reg,non_PV,T)=E=sum(year$(T_num(year) gt T_num(T-NPO_TL(I_reg,non_PV)) and T_num(year) le T_num(T)),
                 Inv_VNPO(I_reg,non_PV,year));

*Geothermal
VNPGEO_EQU(I_reg,geothermal,T)..
                 VNPGEO(I_reg,geothermal,T)=E=sum(year$(T_num(year) gt T_num(T-NPGEO_TL(I_reg,geothermal)) and T_num(year) le T_num(T)),
                 Inv_VNPGEO(I_reg,geothermal,year));

*** New Interconnectors ***
NP_trade_EQU1(export_reg,import_reg,T)..
                 NP_trade(export_reg,import_reg,T)=E=sum(year$(T_num(year) gt T_num(T-NP_trade_TL) and T_num(year) le T_num(T)),
                 Inv_NP_trade(export_reg,import_reg,year));

NP_trade_EQU2(export_reg,import_reg,year)..
                 Inv_NP_trade(export_reg,import_reg,year)=E=Inv_NP_trade(import_reg,export_reg,year);


$oneolcom
*** Genaration new investments ***
*Thermal
VNETtype_EQU1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)$(valid_thermal(I_reg,thermal,plant_type) and T_num(T) ge first_year5(fiveyear_period))..
                 VNETtype1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)=L=VNPTtype_5year(I_reg,thermal,plant_type,T,fiveyear_period)*Time_step_length(Time_step);

VNETtype_EQU111(I_reg,Base_load,CON,T)$(valid_thermal(I_reg,Base_load,CON))..
                 sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_1"))=E=sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_2"));
VNETtype_EQU112(I_reg,Base_load,CON,T)$(valid_thermal(I_reg,Base_load,CON))..
                 sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_3"))=E=sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_4"));
VNETtype_EQU113(I_reg,Base_load,CON,T)$(valid_thermal(I_reg,Base_load,CON))..
                 sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_5"))=E=sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_6"));
VNETtype_EQU114(I_reg,Base_load,CON,T)$(valid_thermal(I_reg,Base_load,CON))..
                 sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_7"))=E=sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_8"));
VNETtype_EQU115(I_reg,Base_load,CON,T)$(valid_thermal(I_reg,Base_load,CON))..
                 sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_9"))=E=sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_10"));
VNETtype_EQU116(I_reg,Base_load,CON,T)$(valid_thermal(I_reg,Base_load,CON))..
                 sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_11"))=E=sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_12"));
VNETtype_EQU117(I_reg,Base_load,CON,T)$(valid_thermal(I_reg,Base_load,CON))..
                 sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_13"))=E=sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_14"));
VNETtype_EQU118(I_reg,Base_load,CON,T)$(valid_thermal(I_reg,Base_load,CON))..
                 sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_15"))=E=sum(fiveyear_period,VNETtype1(I_reg,Base_load,CON,T,fiveyear_period,"Step_16"));

VNETtype_EQU11(I_reg,thermal,plant_type,T)$(valid_thermal(I_reg,thermal,plant_type))..
                 sum((fiveyear_period,Time_step),VNETtype1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step))=L=sum((fiveyear_period,Time_step),VNPTtype_5year(I_reg,thermal,plant_type,T,fiveyear_period)*EPT_LF(I_reg,thermal,plant_type)*Time_step_length(Time_step));


VNHTtype_EQU1(I_reg,thermal,C_HP,T,fiveyear_period,Time_step)$(valid_thermal(I_reg,thermal,C_HP) and T_num(T) ge first_year5(fiveyear_period))..
                 VNHTtype1(I_reg,thermal,C_HP,T,fiveyear_period,Time_step)=E=VNETtype1(I_reg,thermal,C_HP,T,fiveyear_period,Time_step)/EPT_alfa_5year(thermal,C_HP,fiveyear_period);

VNETtype_EQU(I_reg,thermal,plant_type,T)..
                 VNETtype(I_reg,thermal,plant_type,T)=E=sum((fiveyear_period,Time_step),VNETtype1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step));

VNHTtype_EQU(I_reg,thermal,C_HP,T)..
                 VNHTtype(I_reg,thermal,C_HP,T)=E=sum((fiveyear_period,Time_step),VNHTtype1(I_reg,thermal,C_HP,T,fiveyear_period,Time_step));


*** Peak gas
VNEPgas_EQU1(I_reg,T,fiveyear_period,Time_step)$(T_num(T) ge first_year5(fiveyear_period))..
                 VNEPgas1(I_reg,T,fiveyear_period,Time_step)=L=VNPPgas_5year(I_reg,T,fiveyear_period)*Time_step_length(Time_step);

VNEPgas_EQU11(I_reg,T)..
                 sum((fiveyear_period,Time_step),VNEPgas1(I_reg,T,fiveyear_period,Time_step))=L=sum((fiveyear_period,Time_step),VNPPgas_5year(I_reg,T,fiveyear_period)*LF_peakgas(I_reg)*Time_step_length(Time_step));

VNEPgas_EQU(I_reg,T)..
                 VNEPgas(I_reg,T)=E=sum((fiveyear_period,Time_step),VNEPgas1(I_reg,T,fiveyear_period,Time_step));

*Wind
LFW(nuts2,wind_type,Time_step)$(not valid_wind_type(nuts2,wind_type))=0;
VNEW1_nuts2.up(nuts2,wind_type,T,Time_step)$(not valid_wind_type(nuts2,wind_type))=0;

VNEW_nuts_EQU1(nuts2,wind_type,T,Time_step)$(valid_wind_type(nuts2,wind_type))..
                 VNEW1_nuts2(nuts2,wind_type,T,Time_step)=L=VNPW(nuts2,wind_type,T)*LFW(nuts2,wind_type,Time_step);

VNEW_EQU1(I_reg,wind_type,T,Time_step)..
                 VNEW1(I_reg,wind_type,T,Time_step)=E=sum(nuts2$(regions_to_nuts2(I_reg,nuts2)),VNEW1_nuts2(nuts2,wind_type,T,Time_step));

VNEW_EQU(I_reg,wind_type,T)..
                 VNEW(I_reg,wind_type,T)=E=sum(Time_step,VNEW1(I_reg,wind_type,T,Time_step));

*Solar
* change to solar_sites from nuts2 and sum over sites_to_regions
VNESol_sites_EQU1(solar_type,solar_sites,T,Time_step)$valid_solar_sites(solar_sites)..
                 VNESol1_sites(solar_type,solar_sites,T,Time_step)=L=VNPSol(solar_type,solar_sites,T)*LFS(solar_type,solar_sites,Time_step);

VNESol_EQU1(solar_type,I_reg,T,Time_step)..
                 VNESol1(solar_type,I_reg,T,Time_step)=E=sum(solar_sites$(solar_sites_to_regions(solar_sites,I_reg)),VNESol1_sites(solar_type,solar_sites,T,Time_step));

VNESol_EQU(solar_type,I_reg,T)..
                 VNESol(solar_type,I_reg,T)=E=sum(Time_step,VNESol1(solar_type,I_reg,T,Time_step));

*Hydro
VNEH_RO_EQU1(I_reg,T,Time_step)..
                 VNEH1_RO(I_reg,T,Time_step)=E=VNPH(I_reg,"run_riv",T)*LFH(I_reg,Time_step);
VNEH_RO_EQU(I_reg,T)..
                 VNEH_RO(I_reg,T)=E=sum(Time_step,VNEH1_RO(I_reg,T,Time_step));

VNEH_REG_EQU1(I_reg,T,Time_step)..
         VNEH1_REG(I_reg,T,Time_step)=L=VNPH(I_reg,"reg",T)*Time_step_length(Time_step);
VNEH_REG_EQU(I_reg,T)..
         VNEH_REG(I_reg,T)=E=sum(Time_step,VNEH1_REG(I_reg,T,Time_step));

*CCS
VNECCStype_EQU1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)$(valid_CCS(I_reg,CCS,plant_type)
                 and T_num(T) ge 2020
                 and T_num(T) ge first_year5(fiveyear_period))..
                 VNECCStype1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)=L=VNPCCStype_5year(I_reg,CCS,plant_type,T,fiveyear_period)*Time_step_length(Time_step);

VNECCStype_EQU111(I_reg,CCS,CON,T)$(valid_CCS(I_reg,CCS,CON)
                 and T_num(T) ge 2020)..
                 sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_1"))=E=sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_2"));
VNECCStype_EQU112(I_reg,CCS,CON,T)$(valid_CCS(I_reg,CCS,CON)
                 and T_num(T) ge 2020)..
                 sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_3"))=E=sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_4"));
VNECCStype_EQU113(I_reg,CCS,CON,T)$(valid_CCS(I_reg,CCS,CON)
                 and T_num(T) ge 2020)..
                 sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_5"))=E=sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_6"));
VNECCStype_EQU114(I_reg,CCS,CON,T)$(valid_CCS(I_reg,CCS,CON)
                 and T_num(T) ge 2020)..
                 sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_7"))=E=sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_8"));
VNECCStype_EQU115(I_reg,CCS,CON,T)$(valid_CCS(I_reg,CCS,CON)
                 and T_num(T) ge 2020)..
                 sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_9"))=E=sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_10"));
VNECCStype_EQU116(I_reg,CCS,CON,T)$(valid_CCS(I_reg,CCS,CON)
                 and T_num(T) ge 2020)..
                 sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_11"))=E=sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_12"));
VNECCStype_EQU117(I_reg,CCS,CON,T)$(valid_CCS(I_reg,CCS,CON)
                 and T_num(T) ge 2020)..
                 sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_13"))=E=sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_14"));
VNECCStype_EQU118(I_reg,CCS,CON,T)$(valid_CCS(I_reg,CCS,CON)
                 and T_num(T) ge 2020)..
                 sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_15"))=E=sum(fiveyear_period,VNECCStype1(I_reg,CCS,CON,T,fiveyear_period,"Step_16"));

VNECCStype_EQU11(I_reg,CCS,plant_type,T)$(valid_CCS(I_reg,CCS,plant_type))..
                 sum((fiveyear_period,Time_step),VNECCStype1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step))=L=sum((fiveyear_period,Time_step),VNPCCStype_5year(I_reg,CCS,plant_type,T,fiveyear_period)*NPCCS_LF(I_reg,CCS,plant_type)*Time_step_length(Time_step));


VNECCStype_EQU(I_reg,CCS,plant_type,T)$(valid_CCS(I_reg,CCS,plant_type)
                 and T_num(T) ge 2020)..
                 VNECCStype(I_reg,CCS,plant_type,T)=E=sum((fiveyear_period,Time_step),VNECCStype1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step));

*Others
VNEO_EQU1(I_reg,non_PV,T,Time_step)..
                 VNEO1(I_reg,non_PV,T,Time_step)=E=VNPO(I_reg,non_PV,T)*LFO(I_reg,non_PV,Time_step);

VNEO_EQU(I_reg,non_PV,T)..
                 VNEO(I_reg,non_PV,T)=E=sum(Time_step,VNEO1(I_reg,non_PV,T,Time_step));

*Geothermal
VNEGEO_EQU(I_reg,geothermal,T)..
                 VNEGEO(I_reg,geothermal,T)=L=VNPGEO(I_reg,geothermal,T)*NPGEO_LF(I_reg,geothermal);

*** New interconnectors ***

NE_importEQU11(I_reg,export_reg,T,Time_step)$(valid_NP_trade(I_reg,export_reg))..
                 NE_import11(I_reg,export_reg,T,Time_step)=L=NP_trade(export_reg,I_reg,T)*time_step_length(Time_step);
NE_importEQU1(I_reg,T,Time_step)..
                 NE_import(I_reg,T,Time_step)=E=sum(export_reg,NE_import11(I_reg,export_reg,T,Time_step));

NE_exportEQU11(I_reg,import_reg,T,Time_step)$(valid_NP_trade(I_reg,import_reg))..
                 NE_export11(I_reg,import_reg,T,Time_step)=L=NP_trade(I_reg,import_reg,T)*time_step_length(Time_step);
NE_exportEQU1(I_reg,T,Time_step)..
                 NE_export(I_reg,T,Time_step)=E=sum(import_reg,NE_export11(I_reg,import_reg,T,Time_step));

trade_balanceNEEQU(import_reg,export_reg,T,Time_step)$(valid_NP_trade(import_reg,export_reg))..
                 NE_import11(import_reg,export_reg,T,Time_step)=E=0.9995*NE_export11(export_reg,import_reg,T,Time_step);


*** Fuel Consumption ***
*Thermal
VEFT_EQU1(I_reg,thermal,plant_type,T,tenyear_period,Time_step)$(Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period) gt 0)..
                 VEFTtype1(I_reg,thermal,plant_type,T,tenyear_period,Time_step)=E=Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_boiler",T,tenyear_period)/Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period)*VEETtype1(I_reg,thermal,plant_type,T,tenyear_period,Time_step);

VEFT_EQU(I_reg,thermal,plant_type,T)$(sum(tenyear_period,Residual_P_thermal_10(I_reg,thermal,plant_type,"capacity_el",T,tenyear_period)) gt 0)..
                 VEFTtype(I_reg,thermal,plant_type,T)=E=sum((tenyear_period,Time_step),VEFTtype1(I_reg,thermal,plant_type,T,tenyear_period,Time_step));

VNFTtype_EQU1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)$(valid_thermal(I_reg,thermal,plant_type) and T_num(T) ge first_year5(fiveyear_period))..
                 VNFTtype1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)=E=VNETtype1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step)/
                 eta_el_5year(thermal,plant_type,fiveyear_period);

VNFTtype_EQU(I_reg,thermal,plant_type,T)..
                 VNFTtype(I_reg,thermal,plant_type,T)=E=sum((fiveyear_period,Time_step),VNFTtype1(I_reg,thermal,plant_type,T,fiveyear_period,Time_step));
***peak gas
VNFPgas_EQU1(I_reg,T,fiveyear_period,Time_step)$(T_num(T) ge first_year5(fiveyear_period))..
                 VNFPgas1(I_reg,T,fiveyear_period,Time_step)=E=VNEPgas1(I_reg,T,fiveyear_period,Time_step)/
                 eta_el_5year_Pgas(fiveyear_period);

VNFPgas_EQU(I_reg,T)..
                 VNFPgas(I_reg,T)=E=sum((fiveyear_period,Time_step),VNFPgas1(I_reg,T,fiveyear_period,Time_step));


*CCS
*Energy in used fuels CCS
VNFCCS_EQU1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)$(valid_CCS(I_reg,CCS,plant_type) and T_num(T) ge first_year5(fiveyear_period))..
                 VNFCCStype1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)=E=VNECCStype1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step)/
                 eta_elCCS_5year(CCS,plant_type,fiveyear_period);

VNFCCS_EQU(I_reg,CCS,plant_type,T)..
                 VNFCCStype(I_reg,CCS,plant_type,T)=E=sum((fiveyear_period,Time_step),VNFCCStype1(I_reg,CCS,plant_type,T,fiveyear_period,Time_step));

*Fuel use in CCS
VNFCCS_EQUx1(I_reg,CCS_fuels,T)..
                 VNFCCS(I_reg,"B",T)=E=sum(plant_type,VNFCCStype(I_reg,"BCCS",plant_type,T)+
                 (1-bio_fraction("BWCCS"))*VNFCCStype(I_reg,"BWCCS",plant_type,T));

VNFCCS_EQUx2(I_reg,CCS_fuels,T)..
                 VNFCCS(I_reg,"H",T)=E=sum(plant_type,VNFCCStype(I_reg,"HCCS",plant_type,T)+
                 (1-bio_fraction("HWCCS"))*VNFCCStype(I_reg,"HWCCS",plant_type,T));

VNFCCS_EQUx3(I_reg,CCS_fuels,T)..
                 VNFCCS(I_reg,"G",T)=E=sum(plant_type,VNFCCStype(I_reg,"GCCS",plant_type,T));

VNFCCS_EQUx4(I_reg,CCS_fuels,T)..
                 VNFCCS(I_reg,"W",T)=E=sum(plant_type,bio_fraction("BWCCS")*VNFCCStype(I_reg,"BWCCS",plant_type,T)+
                 bio_fraction("HWCCS")*VNFCCStype(I_reg,"HWCCS",plant_type,T));

* Cumulative storage investments
VNEStorageEQU(storage_systems,I_reg,T)..
                 VNEStorageCap(storage_systems,I_reg,T)=E=sum(year$(T_num(year) gt T_num(T-EPStorage_TL(storage_systems)) and T_num(year) le T_num(T)),
                 Inv_VNEStorage(storage_systems,I_reg,year));



