$setglobal national "%path%\Report\National\output\"


set
         time_out(T)
         /2010*2050/
;


parameter
Par_Gen_out_region(out_prop_gen,T)
Par_cap_out_region(out_prop,T)
Par_emissions_out_region(em_prop,T)
*Par_gencost_region(Tech,T)
*Par_runcost_region(Tech,T)
Par_margcost_region(marg_prop,T)
Par_heat_region(heat_prop,T)
Par_fuel_region(thermal,T)
tot_gen_out(tot,time_out)
;

variable
Gen_out_region(out_prop_gen,T)
Cap_out_region(out_prop,T)
Emissions_out_region(em_prop,T)
*Gencost_out_region(Tech,T)
*Runcost_out_region(Tech,T)
Margcost_out_region(marg_prop,T)
Heat_out_region(heat_prop,T)
Fuel_out_region(thermal,T)
V_tot_gen_out(tot,time_out)
artificial
;

Equation
artificialEQU

MS_GENEQU(out_prop_gen,T)
MS_CAPEQU(out_prop,T)
MS_EMISSIONEQU(em_prop,T)

*MS_GENCOSTEQU(Tech,T)
*MS_RUNCOSTEQU(Tech,T)
MS_MARGCOSTEQU(marg_prop,T)
MS_HEATEQU(heat_prop,T)
MS_FUELEQU(thermal,T)

MS_outEQU(tot,time_out)
;

MS_GENEQU(out_prop_gen,T)..
         Gen_out_region(out_prop_gen,T)=E=Par_Gen_out_region(out_prop_gen,T);
MS_CAPEQU(out_prop,T)..
         Cap_out_region(out_prop,T)=E=Par_cap_out_region(out_prop,T);
MS_EMISSIONEQU(em_prop,T)..
         Emissions_out_region(em_prop,T)=E=Par_emissions_out_region(em_prop,T);
*MS_GENCOSTEQU(Tech,T)..
*         Gencost_out_region(Tech,T)=E=Par_gencost_region(Tech,T);
*MS_RUNCOSTEQU(Tech,T)..
*        Runcost_out_region(Tech,T)=E=Par_runcost_region(Tech,T);
MS_MARGCOSTEQU(marg_prop,T)..
         Margcost_out_region(marg_prop,T)=E=Par_margcost_region(marg_prop,T);
MS_HEATEQU(heat_prop,T)..
         Heat_out_region(heat_prop,T)=E=Par_heat_region(heat_prop,T);
MS_FUELEQU(thermal,T)..
         Fuel_out_region(thermal,T)=E=Par_fuel_region(thermal,T);

MS_outEQU(tot,time_out)..
         V_tot_gen_out(tot,time_out)=E=tot_gen_out(tot,time_out);

artificialEQU..
         artificial=G=0;

model artificial_modell /
MS_GENEQU,
MS_CAPEQU,
MS_EMISSIONEQU,
*MS_GENCOSTEQU,
*MS_RUNCOSTEQU,
MS_MARGCOSTEQU,
MS_HEATEQU,
MS_FUELEQU,
MS_outEQU,
artificialEQU
/
;

loop(I_reg,
         Par_Gen_out_region(out_prop_gen,T)=Var_Pnew_gen_regions.l(I_reg,out_prop_gen,T);
         Par_cap_out_region(out_prop,T)=Var_Pnew_cap_regions.l(I_reg,out_prop,T);
         Par_emissions_out_region(em_prop,T)=Var_emissions_regions.l(I_reg,em_prop,T);
*         Par_gencost_region(Tech,T)=Var_gen_cost_regions.l(I_reg,Tech,T);
*         Par_runcost_region(Tech,T)=Var_run_cost_regions.l(I_reg,Tech,T);
         Par_margcost_region(marg_prop,T)=Var_marg_cost_regions.l(I_reg,marg_prop,T);
         Par_heat_region(heat_prop,T)=Var_heat_regions.l(I_reg,heat_prop,T);
         Par_fuel_region(thermal,T)=totF.l(I_reg,thermal,T);
         tot_gen_out(tot,time_out)=Par_Gen_out_region(tot,time_out);

*Austria
         if(country_num(I_reg) eq country_num("Austria"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Austria.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Austria.gdx o=%national%out_Austria.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Austria.gdx o=%national%out_Austria.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Austria.gdx o=%national%out_Austria.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Austria.gdx o=%national%out_Austria.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Austria.gdx o=%national%out_Austria.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Austria.gdx o=%national%out_Austria.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Austria.gdx o=%national%out_Austria.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Austria.gdx o=%national%out_Austria.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Austria.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Austria!a1 cdim=1";
         )
         ;
*Belgium
         if(country_num(I_reg) eq country_num("Belgium"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Belgium.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Belgium.gdx o=%national%out_Belgium.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Belgium.gdx o=%national%out_Belgium.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Belgium.gdx o=%national%out_Belgium.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                execute "Gdxxrw %national%out_Belgium.gdx o=%national%out_Belgium.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Belgium.gdx o=%national%out_Belgium.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Belgium.gdx o=%national%out_Belgium.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Belgium.gdx o=%national%out_Belgium.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Belgium.gdx o=%national%out_Belgium.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Belgium.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Belgium!a1 cdim=1";
         )
         ;
*Bulgaria
         if(country_num(I_reg) eq country_num("Bulgaria"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Bulgaria.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Bulgaria.gdx o=%national%out_Bulgaria.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Bulgaria.gdx o=%national%out_Bulgaria.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Bulgaria.gdx o=%national%out_Bulgaria.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Bulgaria.gdx o=%national%out_Bulgaria.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Bulgaria.gdx o=%national%out_Bulgaria.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Bulgaria.gdx o=%national%out_Bulgaria.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Bulgaria.gdx o=%national%out_Bulgaria.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Bulgaria.gdx o=%national%out_Bulgaria.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Bulgaria.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Bulgaria!a1 cdim=1";
         )
         ;
*Cyprus
         if(country_num(I_reg) eq country_num("Cyprus"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Cyprus.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Cyprus.gdx o=%national%out_Cyprus.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Cyprus.gdx o=%national%out_Cyprus.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Cyprus.gdx o=%national%out_Cyprus.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Cyprus.gdx o=%national%out_Cyprus.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Cyprus.gdx o=%national%out_Cyprus.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Cyprus.gdx o=%national%out_Cyprus.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Cyprus.gdx o=%national%out_Cyprus.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Cyprus.gdx o=%national%out_Cyprus.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Cyprus.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Cyprus!a1 cdim=1";
         )
         ;
*Czech_Republic
         if(country_num(I_reg) eq country_num("Czech_Republic"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Czech_Republic.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Czech_Republic.gdx o=%national%out_Czech_Republic.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Czech_Republic.gdx o=%national%out_Czech_Republic.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Czech_Republic.gdx o=%national%out_Czech_Republic.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Czech_Republic.gdx o=%national%out_Czech_Republic.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Czech_Republic.gdx o=%national%out_Czech_Republic.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Czech_Republic.gdx o=%national%out_Czech_Republic.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Czech_Republic.gdx o=%national%out_Czech_Republic.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Czech_Republic.gdx o=%national%out_Czech_Republic.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Czech_Republic.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Czech_Republic!a1 cdim=1";
         )
         ;
*Denmark
         if(country_num(I_reg) eq country_num("Denmark"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Denmark.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Denmark.gdx o=%national%out_Denmark.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Denmark.gdx o=%national%out_Denmark.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Denmark.gdx o=%national%out_Denmark.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Denmark.gdx o=%national%out_Denmark.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Denmark.gdx o=%national%out_Denmark.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Denmark.gdx o=%national%out_Denmark.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Denmark.gdx o=%national%out_Denmark.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Denmark.gdx o=%national%out_Denmark.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Denmark.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Denmark!a1 cdim=1";
         )
         ;
*Estonia
         if(country_num(I_reg) eq country_num("Estonia"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Estonia.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Estonia.gdx o=%national%out_Estonia.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Estonia.gdx o=%national%out_Estonia.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Estonia.gdx o=%national%out_Estonia.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Estonia.gdx o=%national%out_Estonia.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Estonia.gdx o=%national%out_Estonia.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Estonia.gdx o=%national%out_Estonia.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Estonia.gdx o=%national%out_Estonia.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Estonia.gdx o=%national%out_Estonia.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Estonia.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Estonia!a1 cdim=1";
         )
         ;
*Finland
         if(country_num(I_reg) eq country_num("Finland"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Finland.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Finland.gdx o=%national%out_Finland.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Finland.gdx o=%national%out_Finland.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Finland.gdx o=%national%out_Finland.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Finland.gdx o=%national%out_Finland.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Finland.gdx o=%national%out_Finland.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Finland.gdx o=%national%out_Finland.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Finland.gdx o=%national%out_Finland.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Finland.gdx o=%national%out_Finland.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Finland.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Finland!a1 cdim=1";
         )
         ;
*France
         if(country_num(I_reg) eq country_num("France"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_France.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_France.gdx o=%national%out_France.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_France.gdx o=%national%out_France.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_France.gdx o=%national%out_France.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_France.gdx o=%national%out_France.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_France.gdx o=%national%out_France.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_France.gdx o=%national%out_France.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_France.gdx o=%national%out_France.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_France.gdx o=%national%out_France.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_France.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=France!a1 cdim=1";
         )
         ;
*Germany
         if(country_num(I_reg) eq country_num("Germany"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Germany.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Germany.gdx o=%national%out_Germany.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Germany.gdx o=%national%out_Germany.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Germany.gdx o=%national%out_Germany.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Germany.gdx o=%national%out_Germany.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Germany.gdx o=%national%out_Germany.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Germany.gdx o=%national%out_Germany.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Germany.gdx o=%national%out_Germany.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Germany.gdx o=%national%out_Germany.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Germany.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Germany!a1 cdim=1";
         )
         ;
*Greece
         if(country_num(I_reg) eq country_num("Greece"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Greece.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Greece.gdx o=%national%out_Greece.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Greece.gdx o=%national%out_Greece.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Greece.gdx o=%national%out_Greece.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Greece.gdx o=%national%out_Greece.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Greece.gdx o=%national%out_Greece.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Greece.gdx o=%national%out_Greece.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Greece.gdx o=%national%out_Greece.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Greece.gdx o=%national%out_Greece.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Greece.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Greece!a1 cdim=1";
         )
         ;
*Hungary
         if(country_num(I_reg) eq country_num("Hungary"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Hungary.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Hungary.gdx o=%national%out_Hungary.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Hungary.gdx o=%national%out_Hungary.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Hungary.gdx o=%national%out_Hungary.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Hungary.gdx o=%national%out_Hungary.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Hungary.gdx o=%national%out_Hungary.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Hungary.gdx o=%national%out_Hungary.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Hungary.gdx o=%national%out_Hungary.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Hungary.gdx o=%national%out_Hungary.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Hungary.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Hungary!a1 cdim=1";
         )
         ;
*Ireland
         if(country_num(I_reg) eq country_num("Ireland"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Ireland.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Ireland.gdx o=%national%out_Ireland.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Ireland.gdx o=%national%out_Ireland.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Ireland.gdx o=%national%out_Ireland.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Ireland.gdx o=%national%out_Ireland.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Ireland.gdx o=%national%out_Ireland.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Ireland.gdx o=%national%out_Ireland.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Ireland.gdx o=%national%out_Ireland.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Ireland.gdx o=%national%out_Ireland.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Ireland.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Ireland!a1 cdim=1";
         )
         ;
*Italy
         if(country_num(I_reg) eq country_num("Italy"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Italy.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Italy.gdx o=%national%out_Italy.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Italy.gdx o=%national%out_Italy.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Italy.gdx o=%national%out_Italy.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Italy.gdx o=%national%out_Italy.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Italy.gdx o=%national%out_Italy.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Italy.gdx o=%national%out_Italy.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Italy.gdx o=%national%out_Italy.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Italy.gdx o=%national%out_Italy.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Italy.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Italy!a1 cdim=1";
         )
         ;
*Latvia
         if(country_num(I_reg) eq country_num("Latvia"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Latvia.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Latvia.gdx o=%national%out_Latvia.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Latvia.gdx o=%national%out_Latvia.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Latvia.gdx o=%national%out_Latvia.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Latvia.gdx o=%national%out_Latvia.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Latvia.gdx o=%national%out_Latvia.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Latvia.gdx o=%national%out_Latvia.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Latvia.gdx o=%national%out_Latvia.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Latvia.gdx o=%national%out_Latvia.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Latvia.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Latvia!a1 cdim=1";
         )
         ;
*Lithuania
         if(country_num(I_reg) eq country_num("Lithuania"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Lithuania.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Lithuania.gdx o=%national%out_Lithuania.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Lithuania.gdx o=%national%out_Lithuania.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Lithuania.gdx o=%national%out_Lithuania.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                execute "Gdxxrw %national%out_Lithuania.gdx o=%national%out_Lithuania.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Lithuania.gdx o=%national%out_Lithuania.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Lithuania.gdx o=%national%out_Lithuania.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Lithuania.gdx o=%national%out_Lithuania.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Lithuania.gdx o=%national%out_Lithuania.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Lithuania.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Lithuania!a1 cdim=1";
         )
         ;
*Luxembourg
         if(country_num(I_reg) eq country_num("Luxembourg"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Luxembourg.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Luxembourg.gdx o=%national%out_Luxembourg.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Luxembourg.gdx o=%national%out_Luxembourg.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Luxembourg.gdx o=%national%out_Luxembourg.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Luxembourg.gdx o=%national%out_Luxembourg.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Luxembourg.gdx o=%national%out_Luxembourg.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Luxembourg.gdx o=%national%out_Luxembourg.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Luxembourg.gdx o=%national%out_Luxembourg.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Luxembourg.gdx o=%national%out_Luxembourg.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Luxembourg.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Luxembourg!a1 cdim=1";
         )
         ;
*Malta
         if(country_num(I_reg) eq country_num("Malta"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Malta.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Malta.gdx o=%national%out_Malta.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Malta.gdx o=%national%out_Malta.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Malta.gdx o=%national%out_Malta.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Malta.gdx o=%national%out_Malta.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Malta.gdx o=%national%out_Malta.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Malta.gdx o=%national%out_Malta.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Malta.gdx o=%national%out_Malta.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Malta.gdx o=%national%out_Malta.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Malta.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Malta!a1 cdim=1";
         )
         ;
*Netherlands
         if(country_num(I_reg) eq country_num("Netherlands"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Netherlands.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Netherlands.gdx o=%national%out_Netherlands.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Netherlands.gdx o=%national%out_Netherlands.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Netherlands.gdx o=%national%out_Netherlands.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Netherlands.gdx o=%national%out_Netherlands.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Netherlands.gdx o=%national%out_Netherlands.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Netherlands.gdx o=%national%out_Netherlands.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Netherlands.gdx o=%national%out_Netherlands.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Netherlands.gdx o=%national%out_Netherlands.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Netherlands.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Netherlands!a1 cdim=1";
         )
         ;
*Norway
         if(country_num(I_reg) eq country_num("Norway"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Norway.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Norway.gdx o=%national%out_Norway.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Norway.gdx o=%national%out_Norway.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Norway.gdx o=%national%out_Norway.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Norway.gdx o=%national%out_Norway.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Norway.gdx o=%national%out_Norway.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Norway.gdx o=%national%out_Norway.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Norway.gdx o=%national%out_Norway.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Norway.gdx o=%national%out_Norway.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Norway.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Norway!a1 cdim=1";
         )
         ;
*Poland
         if(country_num(I_reg) eq country_num("Poland"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Poland.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Poland.gdx o=%national%out_Poland.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Poland.gdx o=%national%out_Poland.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Poland.gdx o=%national%out_Poland.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Poland.gdx o=%national%out_Poland.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Poland.gdx o=%national%out_Poland.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Poland.gdx o=%national%out_Poland.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Poland.gdx o=%national%out_Poland.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Poland.gdx o=%national%out_Poland.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Poland.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Poland!a1 cdim=1";
         )
         ;
*Portugal
         if(country_num(I_reg) eq country_num("Portugal"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Portugal.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Portugal.gdx o=%national%out_Portugal.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Portugal.gdx o=%national%out_Portugal.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Portugal.gdx o=%national%out_Portugal.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Portugal.gdx o=%national%out_Portugal.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Portugal.gdx o=%national%out_Portugal.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Portugal.gdx o=%national%out_Portugal.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Portugal.gdx o=%national%out_Portugal.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Portugal.gdx o=%national%out_Portugal.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Portugal.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Portugal!a1 cdim=1";
         )
         ;
*Romania
         if(country_num(I_reg) eq country_num("Romania"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Romania.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Romania.gdx o=%national%out_Romania.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Romania.gdx o=%national%out_Romania.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Romania.gdx o=%national%out_Romania.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Romania.gdx o=%national%out_Romania.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Romania.gdx o=%national%out_Romania.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Romania.gdx o=%national%out_Romania.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Romania.gdx o=%national%out_Romania.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Romania.gdx o=%national%out_Romania.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Romania.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Romania!a1 cdim=1";
         )
         ;
*Slovakia
         if(country_num(I_reg) eq country_num("Slovakia"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Slovakia.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Slovakia.gdx o=%national%out_Slovakia.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovakia.gdx o=%national%out_Slovakia.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovakia.gdx o=%national%out_Slovakia.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Slovakia.gdx o=%national%out_Slovakia.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Slovakia.gdx o=%national%out_Slovakia.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovakia.gdx o=%national%out_Slovakia.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovakia.gdx o=%national%out_Slovakia.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovakia.gdx o=%national%out_Slovakia.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovakia.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Slovakia!a1 cdim=1";
         )
         ;
*Slovenia
         if(country_num(I_reg) eq country_num("Slovenia"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Slovenia.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Slovenia.gdx o=%national%out_Slovenia.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovenia.gdx o=%national%out_Slovenia.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovenia.gdx o=%national%out_Slovenia.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Slovenia.gdx o=%national%out_Slovenia.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Slovenia.gdx o=%national%out_Slovenia.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovenia.gdx o=%national%out_Slovenia.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovenia.gdx o=%national%out_Slovenia.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovenia.gdx o=%national%out_Slovenia.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Slovenia.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Slovenia!a1 cdim=1";
         )
         ;
*Spain
         if(country_num(I_reg) eq country_num("Spain"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Spain.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Spain.gdx o=%national%out_Spain.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Spain.gdx o=%national%out_Spain.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Spain.gdx o=%national%out_Spain.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Spain.gdx o=%national%out_Spain.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Spain.gdx o=%national%out_Spain.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Spain.gdx o=%national%out_Spain.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Spain.gdx o=%national%out_Spain.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Spain.gdx o=%national%out_Spain.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Spain.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Spain!a1 cdim=1";
         )
         ;
*Sweden
         if(country_num(I_reg) eq country_num("Sweden"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_Sweden.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Sweden.gdx o=%national%out_Sweden.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Sweden.gdx o=%national%out_Sweden.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Sweden.gdx o=%national%out_Sweden.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Sweden.gdx o=%national%out_Sweden.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Sweden.gdx o=%national%out_Sweden.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Sweden.gdx o=%national%out_Sweden.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Sweden.gdx o=%national%out_Sweden.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Sweden.gdx o=%national%out_Sweden.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Sweden.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Sweden!a1 cdim=1";
         )
         ;
*Switzerland
         if(country_num(I_reg) eq country_num("Switzerland"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_switzerland.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_Switzerland.gdx o=%national%out_Switzerland.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_Switzerland.gdx o=%national%out_Switzerland.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_Switzerland.gdx o=%national%out_Switzerland.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Switzerland.gdx o=%national%out_Switzerland.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_Switzerland.gdx o=%national%out_Switzerland.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_Switzerland.gdx o=%national%out_Switzerland.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_Switzerland.gdx o=%national%out_Switzerland.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_Switzerland.gdx o=%national%out_Switzerland.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_Switzerland.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=Switzerland!a1 cdim=1";
         )
         ;
*UK
         if(country_num(I_reg) eq country_num("UK"),
                 solve artificial_modell using LP minimizing artificial;
                 execute_unload '%national%out_UK.gdx'
                 Gen_out_region,
                 Cap_out_region,
                 Emissions_out_region,
*                 Gencost_out_region,
*                 Runcost_out_region,
                 Margcost_out_region,
                 Heat_out_region,
                 Fuel_out_region,
                 V_tot_gen_out
                 ;
                 execute "Gdxxrw %national%out_UK.gdx o=%national%out_UK.xls squeeze=0 var=Gen_out_region rng=gen!a1 cdim=1";
                 execute "Gdxxrw %national%out_UK.gdx o=%national%out_UK.xls squeeze=0 var=Cap_out_region rng=cap!a1 cdim=1";
                 execute "Gdxxrw %national%out_UK.gdx o=%national%out_UK.xls squeeze=0 var=Emissions_out_region rng=emissions!a1 cdim=1";
*                 execute "Gdxxrw %national%out_UK.gdx o=%national%out_UK.xls squeeze=0 var=Gencost_out_region rng=gen_cost!a1 cdim=1";
*                 execute "Gdxxrw %national%out_UK.gdx o=%national%out_UK.xls squeeze=0 var=Runcost_out_region rng=run_cost!a1 cdim=1";
                 execute "Gdxxrw %national%out_UK.gdx o=%national%out_UK.xls squeeze=0 var=Margcost_out_region rng=Shadow!a1 cdim=1";
                 execute "Gdxxrw %national%out_UK.gdx o=%national%out_UK.xls squeeze=0 var=Heat_out_region rng=Heat!a1 cdim=1";
                 execute "Gdxxrw %national%out_UK.gdx o=%national%out_UK.xls squeeze=0 var=Fuel_out_region rng=Fuel!a1 cdim=1";
                 execute "Gdxxrw %national%out_UK.gdx o=%out_path%out_pathways_regions_%Commit_date%_%Scenario%.xlsx squeeze=0 var=V_tot_gen_out rng=UK!a1 cdim=1";
         )
         ;

)
;
