execute 'cp s2.g00 "%out_path%s2.g00"';

Parameter
         mc_el_weighted_avg(I_reg,T)             Demand-weighted average marginal electricity cost for each model year [EURpMWh]
         mc_el_time_step(I_reg,T,Time_step)      Marginal electricity cost for each year and time step [EURpMWh]
         mc_co2(T)                               Marginal CO2 abatement cost [EURptCO2 (hopefully)]
         eta_el_Pgas(T)                          Electrical efficiency of peak gas plants for all model years
;

mc_el_time_step(I_reg,T,Time_step) = -genEQU22.m(I_reg,T,Time_step)*((1+Ir)**(T_num(T)-2009));
mc_el_weighted_avg(I_reg,T) = -(sum(Time_step,genEQU22.m(I_reg,T,Time_step)*demand_timestep(I_reg,T,Time_step))/sum(Time_step,demand_timestep(I_reg,T,Time_step)))*((1+Ir)**(T_num(T)-2009));
mc_co2(T) = VCO2EQU1.m(T)*((1+Ir)**(T_num(T)-2009));
eta_el_Pgas(T) = eta_el("G","condens",T)-0.25;


execute_unload '%out_path%ELIN_gdx_output.gdx'
mc_el_weighted_avg,
mc_el_time_step,
mc_co2,
Fc_linear_cost_supply_fossil,
Fc_linear_cost_supply_biomarket,
eta_el,
eta_elCCS,
eta_el_Pgas,
NPW_Ic,
EPW_OM,
NPSol_Ic,
EPSol_OM,
NEStorage_Ic,
cap_factor_thermal,
cap_factor_Pgas,
cap_factor_CCS,
cap_factor_wind_exist,
cap_factor_wind_new,
cap_factor_solar_exist,
cap_factor_solar_new,
cap_factor_hydro,
cap_factor_geothermal,
cap_factor_others,
solar_sites_to_regions,
solar_pot_buildings,
solar_pot_centralized,
upper_lim_wind,
tot_solar_area_centralEQU,
tot_solar_area_buildingEQU,
tot_cost,
Prod_cost,
aninv_cost,
gen_region,
tot_RES,
system_max_load,
*system_capEQU1,
VCO2,
VCO2EQU1,
VNEStorageLevel,
VNEStorageIn,
VNEStorageOut,
VNEStorageCap,
VNPTtype,
VNPPgas,
VNPCCStype,
VNPW,
VNPSol,
VNPH,
VNPGEO,
VNPO,
VEETtype,
VNETtype,
VNEPgas,
VNECCStype,
EEW,
VNEW,
EESol,
VNESol,
EEH_RO,
VEEH_REG,
VNEH_RO,
VNEH_REG,
VNEGEO,
EEO,
VNEO,
EE_import,
NE_import,
EE_export,
NE_export,
NP_trade,
VEHTtype,
VNHTtype,
VEFTtype,
VNFTtype,
VNFPgas,
VNFCCStype;

execute_unload '%out_path%cost_supply.gdx'
cost_supply;
execute_unload '%out_path%TWh.gdx'
TWh;
execute_unload '%out_path%thermal.gdx'
thermal;
execute_unload '%out_path%plant_type.gdx'
plant_type;
execute_unload '%out_path%T.gdx'
T;
execute_unload '%out_path%CCS.gdx'
CCS;
execute_unload '%out_path%nuts2.gdx'
nuts2;
execute_unload '%out_path%I_reg.gdx'
I_reg;
*execute_unload '%out_path%year.gdx'
*year;
execute_unload '%out_path%wind_type.gdx'
wind_type;
execute_unload '%out_path%inv_prop.gdx'
inv_prop;
execute_unload '%out_path%OM_prop.gdx'
OM_prop;
execute_unload '%out_path%solar_type.gdx'
solar_type;
execute_unload '%out_path%solar_sites.gdx'
solar_sites;
execute_unload '%out_path%storage_systems.gdx'
storage_systems;
execute_unload '%out_path%hydro_class.gdx'
hydro_class;
execute_unload '%out_path%geothermal.gdx'
geothermal;
execute_unload '%out_path%others.gdx'
others;
execute_unload '%out_path%regions.gdx'
regions;
execute_unload '%out_path%Time_step.gdx'
Time_step;
execute_unload '%out_path%non_PV.gdx'
non_PV;
*execute_unload '%out_path%export_reg.gdx'
*export_reg;
*execute_unload '%out_path%import_reg.gdx'
*import_reg;
*execute_unload '%out_path%C_HP.gdx'
*C_HP;


*Fc_linear_cost_supply_fossil(cost_supply,TWh)% cost supply curves of coal (hard, lignite) & gas
*Fc_linear_cost_supply_biomarket(TWh)         % biomass supply curve

*eta_el(thermal,plant_type,T)                 % efficiency of conventional thermal plants (incl. nuclear)
*eta_elCCS(CCS,plant_type,T)                  % efficiency of CCS plants

*NPW_Ic(nuts2,wind_type,inv_prop,year)        % investment cost of wind with predetermined learning
*NPW_Ic(nuts2,onwind,'plant',year)            % investment cost of onshore wind with predetermined learning
*NPW_Ic(nuts2,"offwind",'plant',year)         % investment cost of offshore wind with predetermined learning
*EPW_OM(I_reg,wind_type,OM_prop,year)         % O&M cost of wind with predetermined learning
*EPW_OM(I_reg,onwind,'fix',year)              % fixed O&M cost of onshore wind with predetermined learning
*EPW_OM(I_reg,'offwind','fix',year)           % fixed O&M cost of offshore wind with predetermined learning

*NPSol_Ic(solar_type,solar_sites,'plant',year)% investment cost of solar plants (incl. CSP) with predetermined learning
*EPSol_OM(solar_type,I_reg,'fix',year)        % fixed O&M cost of solar plants (incl. CSP) with predetermined learning

*NEStorage_Ic(storage_systems,I_reg,year)     % investment cost of storage with predetermined learning

*cap_factor_thermal(I_reg,thermal,plant_type) % capacity factor of conventional thermal plants (incl. nuclear)
*cap_factor_Pgas(I_reg)                       % capacity factor of peak gas plants
*cap_factor_CCS(I_reg,CCS,plant_type)         % capacity factor of CCS
*cap_factor_wind_exist(nuts2)                 % capacity factor of preexisting wind plants
*cap_factor_wind_new(nuts2,wind_type)         % capacity factor of new wind plants
*cap_factor_solar_exist(solar_type,nuts2)     % capacity factor of preexisting solar plants
*cap_factor_solar_new(solar_type,solar_sites) % capacity factor of new solar plants
*cap_factor_hydro(I_reg,hydro_class)          % capacity factor of hydro power
*cap_factor_geothermal(I_reg,geothermal)      % capacity factor of geothermal
*cap_factor_others(I_reg,others)              % capacity factor of others

*solar_sites_to_regions(solar_sites,regions)  % solar sites to regions mapping
*solar_pot_buildings(solar_sites)             % solar PV potential area on buildings (i.e. urban built areas)
*solar_pot_centralized(solar_sites)           % solar utility scale potential area (incl. CSP)
*upper_lim_wind(nuts2,wind_type,T)            % limit on wind power per nuts2 region

* total installed area of utility solar plants (incl. CSP)
*tot_solar_area_centralEQU(solar_sites,T)
* total installed area of building solar PV plants
*tot_solar_area_buildingEQU(solar_sites,T)

*tot_cost                                     % main optimization var: total discounted cost of generation
*Prod_cost(I_reg,T)                           % annual production cost
*aninv_cost(I_reg,T)                          % annual investment cost
*gen_region(I_reg,T,Time_step)                % total energy generation
*tot_RES(T)                                   % total renewables generation

*system_max_load(I_reg,T)                     % adjusted max load
*system_capEQU1(I_reg,T)                      % capacity constraint equ

*VCO2(T)                                      % total CO2 emissions
*VCO2EQU1(T)                                  % CO2 emissions equ

*VNEStorageLevel(storage_systems,I_reg,T,Time_step)  % energy (electric equivalent) level stored in storage
*VNEStorageIn(storage_systems,I_reg,T,Time_step)     % energy (electric equivalent) in to storage at every time step
*VNEStorageOut(storage_systems,I_reg,T,Time_step)    % energy (electric equivalent) out of storage at every time step
*VNEStorageCap(storage_systems,I_reg,T)              % total installed new storage investments

*VNPTtype(I_reg,thermal,plant_type,T)         % total installed capacity of new conventional thermal plants
*VNPPgas(I_reg,T)                             % total installed capacity of new peaking gas plants
*VNPCCStype(I_reg,CCS,plant_type,T)           % total installed capacity of new CCS
*VNPW(nuts2,wind_type,T)                      % total installed capacity of new wind plants
*VNPSol(solar_type,solar_sites,T)             % total installed capacity of new solar plants
*VNPH(I_reg,hydro_class,T)                    % total installed capacity of new hydro
*VNPGEO(I_reg,geothermal,T)                   % total installed capacity of new geothermal
*VNPO(I_reg,non_PV,T)                         % total installed capacity of new other plants

*VEETtype(I_reg,thermal,plant_type,T)         % generation (electric energy) from preexisting conventional thermal plants
*VNETtype(I_reg,thermal,plant_type,T)        % generation (electric energy) from new conventional thermal plants
*VNEPgas(I_reg,T)                             % generation (electric energy) from new peaking gas plants
*VNECCStype(I_reg,CCS,plant_type,T)           % generation (electric energy) from new CCS plants
*EEW(I_reg,T)                                 % generation (electric energy) from preexisting wind plants
*VNEW(I_reg,wind_type,T)                      % generation (electric energy) from new wind plants
*EESol(I_reg,T)                               % generation (electric energy) from preexisting solar PV plants
*VNESol(solar_type,I_reg,T)                   % generation (electric energy) from new solar plants (incl. CSP)
*EEH_RO(I_reg,T)                              % generation (electric energy) from preexisting run-of-river hydro plants
*VEEH_REG(I_reg,T)                            % generation (electric energy) from preexisting regulated hydro plants
*VNEH_RO(I_reg,T)                             % generation (electric energy) from new run-of-river hydro plants
*VNEH_REG(I_reg,T))                           % generation (electric energy) from new regulated hydro plants
*VNEGEO(I_reg,geothermal,T)                   % generation (electric energy) from new geothermal plants
*EEO(I_reg,non_PV,T)                          % generation (electric energy) from preexisting other plants
*VNEO(I_reg,non_PV,T)                         % generation (electric energy) from new other plants

*EE_import(I_reg,T,Time_step)                 % energy imported via existing transmission
*NE_import(I_reg,T,Time_step)                 % energy imported via new transmission
*EE_export(I_reg,T,Time_step)                 % energy exported via existing transmission
*NE_export(I_reg,T,Time_step)                 % energy exported via new transmission
*NP_trade(export_reg,import_reg,T)            % total installed new transmission capacity

*VEHTtype(I_reg,thermal,C_HP,T)               % generation (thermal energy) from preexisting CHP conventional thermal plants
*VNHTtype(I_reg,thermal,C_HP,T)               % generation (thermal energy) from new CHP conventional thermal plants

*VEFTtype(I_reg,thermal,plant_type,T)         % fuel consumption in preexisting conventional thermal plants
*VNFTtype(I_reg,thermal,plant_type,T)         % fuel consumption in new conventional thermal plants
*VNFPgas(I_reg,T)                             % fuel consumption in new peak gas plants
*VNFCCStype(I_reg,CCS,plant_type,T)           % fuel consumption in new CCS plants
