$setglobal regional_out "%out_path%regional\"

sets
         NE(I_reg)
         /Denmark
         Finland
         Norway
         Sweden/

         WE(I_reg)
         /Austria
         Belgium
         France
         Germany
         Ireland
         Luxembourg
         Netherlands
         Switzerland
         UK/

         EE(I_reg)
         /Bulgaria
         Czech_Republic
         Estonia
         Hungary
         Latvia
         Lithuania
         Poland
         Romania
         Slovakia/

         SE(I_reg)
         /Greece
         Cyprus
         Italy
         Malta
         Portugal
         Slovenia
         Spain/
;

Parameters
Par_marg_cost_NE(marg_prop,T)
Par_marg_cost_WE(marg_prop,T)
Par_marg_cost_EE(marg_prop,T)
Par_marg_cost_SE(marg_prop,T)
;
Par_marg_cost_NE("Marginal_el",T)=sum((NE,Time_step),Par_marg_cost(NE,"Marginal_el",T)*gen_region.l(NE,T,Time_step))/sum((NE,Time_step),gen_region.l(NE,T,Time_step));
Par_marg_cost_WE("Marginal_el",T)=sum((WE,Time_step),Par_marg_cost(WE,"Marginal_el",T)*gen_region.l(WE,T,Time_step))/sum((WE,Time_step),gen_region.l(WE,T,Time_step));
Par_marg_cost_EE("Marginal_el",T)=sum((EE,Time_step),Par_marg_cost(EE,"Marginal_el",T)*gen_region.l(EE,T,Time_step))/sum((EE,Time_step),gen_region.l(EE,T,Time_step));
Par_marg_cost_SE("Marginal_el",T)=sum((SE,Time_step),Par_marg_cost(SE,"Marginal_el",T)*gen_region.l(SE,T,Time_step))/sum((SE,Time_step),gen_region.l(SE,T,Time_step));

Par_marg_cost_NE("Marginal_CO2",T)=-VCO2.m(T)*((1+Ir)**(T_num(T)-2010));
Par_marg_cost_WE("Marginal_CO2",T)=-VCO2.m(T)*((1+Ir)**(T_num(T)-2010));
Par_marg_cost_EE("Marginal_CO2",T)=-VCO2.m(T)*((1+Ir)**(T_num(T)-2010));
Par_marg_cost_SE("Marginal_CO2",T)=-VCO2.m(T)*((1+Ir)**(T_num(T)-2010));

Par_marg_cost_NE("Marginal_CHP",T)=smax(NE,sum(Time_step,-totH_CHP_EQU.m(NE,T,Time_step)/card(Time_step))*((1+Ir)**(T_num(T)-2010)));
Par_marg_cost_WE("Marginal_CHP",T)=smax(WE,sum(Time_step,-totH_CHP_EQU.m(WE,T,Time_step)/card(Time_step))*((1+Ir)**(T_num(T)-2010)));
Par_marg_cost_EE("Marginal_CHP",T)=smax(EE,sum(Time_step,-totH_CHP_EQU.m(EE,T,Time_step)/card(Time_step))*((1+Ir)**(T_num(T)-2010)));
Par_marg_cost_SE("Marginal_CHP",T)=smax(SE,sum(Time_step,-totH_CHP_EQU.m(SE,T,Time_step)/card(Time_step))*((1+Ir)**(T_num(T)-2010)));

Par_marg_cost_NE("Marginal_cap",T)=smax(NE,Par_marg_cost(NE,"Marginal_cap",T));
Par_marg_cost_WE("Marginal_cap",T)=smax(WE,Par_marg_cost(WE,"Marginal_cap",T));
Par_marg_cost_EE("Marginal_cap",T)=smax(EE,Par_marg_cost(EE,"Marginal_cap",T));
Par_marg_cost_SE("Marginal_cap",T)=smax(SE,Par_marg_cost(SE,"Marginal_cap",T));

Par_marg_cost_NE("Marginal_RES",T)=tot_RES.m(T)*((1+Ir)**(T_num(T)-2010));
Par_marg_cost_WE("Marginal_RES",T)=tot_RES.m(T)*((1+Ir)**(T_num(T)-2010));
Par_marg_cost_EE("Marginal_RES",T)=tot_RES.m(T)*((1+Ir)**(T_num(T)-2010));
Par_marg_cost_SE("Marginal_RES",T)=tot_RES.m(T)*((1+Ir)**(T_num(T)-2010));


Variables
Var_Pnew_gen_NE(out_prop_gen,T)
Var_Pnew_gen_WE(out_prop_gen,T)
Var_Pnew_gen_EE(out_prop_gen,T)
Var_Pnew_gen_SE(out_prop_gen,T)

Var_Pnew_cap_NE(out_prop,T)
Var_Pnew_cap_WE(out_prop,T)
Var_Pnew_cap_EE(out_prop,T)
Var_Pnew_cap_SE(out_prop,T)

Var_emissions_NE(em_prop,T)
Var_emissions_WE(em_prop,T)
Var_emissions_EE(em_prop,T)
Var_emissions_SE(em_prop,T)

Var_marg_cost_NE(marg_prop,T)
Var_marg_cost_WE(marg_prop,T)
Var_marg_cost_EE(marg_prop,T)
Var_marg_cost_SE(marg_prop,T)

totF_NE(thermal,T)
totF_WE(thermal,T)
totF_EE(thermal,T)
totF_SE(thermal,T)

TRAMS
;

Equations
Var_Pnew_gen_NE_EQU(out_prop_gen,T)
Var_Pnew_gen_WE_EQU(out_prop_gen,T)
Var_Pnew_gen_EE_EQU(out_prop_gen,T)
Var_Pnew_gen_SE_EQU(out_prop_gen,T)

Var_Pnew_cap_NE_EQU(out_prop,T)
Var_Pnew_cap_WE_EQU(out_prop,T)
Var_Pnew_cap_EE_EQU(out_prop,T)
Var_Pnew_cap_SE_EQU(out_prop,T)

Var_emissions_NE_EQU(em_prop,T)
Var_emissions_WE_EQU(em_prop,T)
Var_emissions_EE_EQU(em_prop,T)
Var_emissions_SE_EQU(em_prop,T)

Var_marg_cost_NE_EQU(marg_prop,T)
Var_marg_cost_WE_EQU(marg_prop,T)
Var_marg_cost_EE_EQU(marg_prop,T)
Var_marg_cost_SE_EQU(marg_prop,T)

totF_NE_EQU(thermal,T)
totF_WE_EQU(thermal,T)
totF_EE_EQU(thermal,T)
totF_SE_EQU(thermal,T)

TRAMS_EQU
;

Var_Pnew_gen_NE_EQU(out_prop_gen,T)..    Var_Pnew_gen_NE(out_prop_gen,T)=E=sum(NE,Par_Pnew_gen(NE,out_prop_gen,T));
Var_Pnew_gen_WE_EQU(out_prop_gen,T)..    Var_Pnew_gen_WE(out_prop_gen,T)=E=sum(WE,Par_Pnew_gen(WE,out_prop_gen,T));
Var_Pnew_gen_EE_EQU(out_prop_gen,T)..    Var_Pnew_gen_EE(out_prop_gen,T)=E=sum(EE,Par_Pnew_gen(EE,out_prop_gen,T));
Var_Pnew_gen_SE_EQU(out_prop_gen,T)..    Var_Pnew_gen_SE(out_prop_gen,T)=E=sum(SE,Par_Pnew_gen(SE,out_prop_gen,T));

Var_Pnew_cap_NE_EQU(out_prop,T)..    Var_Pnew_cap_NE(out_prop,T)=E=sum(NE,Par_Pnew_cap(NE,out_prop,T));
Var_Pnew_cap_WE_EQU(out_prop,T)..    Var_Pnew_cap_WE(out_prop,T)=E=sum(WE,Par_Pnew_cap(WE,out_prop,T));
Var_Pnew_cap_EE_EQU(out_prop,T)..    Var_Pnew_cap_EE(out_prop,T)=E=sum(EE,Par_Pnew_cap(EE,out_prop,T));
Var_Pnew_cap_SE_EQU(out_prop,T)..    Var_Pnew_cap_SE(out_prop,T)=E=sum(SE,Par_Pnew_cap(SE,out_prop,T));

Var_emissions_NE_EQU(em_prop,T)..        Var_emissions_NE(em_prop,T)=E=sum(NE,Par_emissions_regions(NE,em_prop,T));
Var_emissions_WE_EQU(em_prop,T)..        Var_emissions_WE(em_prop,T)=E=sum(WE,Par_emissions_regions(WE,em_prop,T));
Var_emissions_EE_EQU(em_prop,T)..        Var_emissions_EE(em_prop,T)=E=sum(EE,Par_emissions_regions(EE,em_prop,T));
Var_emissions_SE_EQU(em_prop,T)..        Var_emissions_SE(em_prop,T)=E=sum(SE,Par_emissions_regions(SE,em_prop,T));

Var_marg_cost_NE_EQU(marg_prop,T)..      Var_marg_cost_NE(marg_prop,T)=E=Par_marg_cost_NE(marg_prop,T);
Var_marg_cost_WE_EQU(marg_prop,T)..      Var_marg_cost_WE(marg_prop,T)=E=Par_marg_cost_WE(marg_prop,T);
Var_marg_cost_EE_EQU(marg_prop,T)..      Var_marg_cost_EE(marg_prop,T)=E=Par_marg_cost_EE(marg_prop,T);
Var_marg_cost_SE_EQU(marg_prop,T)..      Var_marg_cost_SE(marg_prop,T)=E=Par_marg_cost_SE(marg_prop,T);

totF_NE_EQU(thermal,T)..                 totF_NE(thermal,T)=E=sum(NE,totF.l(NE,thermal,T));
totF_WE_EQU(thermal,T)..                 totF_WE(thermal,T)=E=sum(WE,totF.l(WE,thermal,T));
totF_EE_EQU(thermal,T)..                 totF_EE(thermal,T)=E=sum(EE,totF.l(EE,thermal,T));
totF_SE_EQU(thermal,T)..                 totF_SE(thermal,T)=E=sum(SE,totF.l(SE,thermal,T));

TRAMS_EQU..      TRAMS=G=0;

model regout /
Var_Pnew_gen_NE_EQU,
Var_Pnew_gen_WE_EQU,
Var_Pnew_gen_EE_EQU,
Var_Pnew_gen_SE_EQU,

Var_Pnew_cap_NE_EQU,
Var_Pnew_cap_WE_EQU,
Var_Pnew_cap_EE_EQU,
Var_Pnew_cap_SE_EQU,

Var_emissions_NE_EQU,
Var_emissions_WE_EQU,
Var_emissions_EE_EQU,
Var_emissions_SE_EQU,

Var_marg_cost_NE_EQU,
Var_marg_cost_WE_EQU,
Var_marg_cost_EE_EQU,
Var_marg_cost_SE_EQU,

totF_NE_EQU,
totF_WE_EQU,
totF_EE_EQU,
totF_SE_EQU,

TRAMS_EQU
/
;
Solve regout using LP minimizing TRAMS;

execute_unload '%regional_out%regout.gdx'
Var_Pnew_gen_NE,
Var_Pnew_gen_WE,
Var_Pnew_gen_EE,
Var_Pnew_gen_SE,

Var_Pnew_cap_NE,
Var_Pnew_cap_WE,
Var_Pnew_cap_EE,
Var_Pnew_cap_SE,

Var_emissions_NE,
Var_emissions_WE,
Var_emissions_EE,
Var_emissions_SE,

Var_marg_cost_NE,
Var_marg_cost_WE,
Var_marg_cost_EE,
Var_marg_cost_SE,

totF_NE,
totF_WE,
totF_EE,
totF_SE
;


execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_NE.xls squeeze=0 var=Var_Pnew_gen_NE rng=gen!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_NE.xls squeeze=0 var=Var_Pnew_cap_NE rng=cap!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_NE.xls squeeze=0 var=Var_emissions_NE rng=emissions!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_NE.xls squeeze=0 var=Var_marg_cost_NE rng=Shadow!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_NE.xls squeeze=0 var=totF_NE rng=Fuel!a1 cdim=1";

execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_WE.xls squeeze=0 var=Var_Pnew_gen_WE rng=gen!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_WE.xls squeeze=0 var=Var_Pnew_cap_WE rng=cap!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_WE.xls squeeze=0 var=Var_emissions_WE rng=emissions!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_WE.xls squeeze=0 var=Var_marg_cost_WE rng=Shadow!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_WE.xls squeeze=0 var=totF_WE rng=Fuel!a1 cdim=1";

execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_EE.xls squeeze=0 var=Var_Pnew_gen_EE rng=gen!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_EE.xls squeeze=0 var=Var_Pnew_cap_EE rng=cap!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_EE.xls squeeze=0 var=Var_emissions_EE rng=emissions!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_EE.xls squeeze=0 var=Var_marg_cost_EE rng=Shadow!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_EE.xls squeeze=0 var=totF_EE rng=Fuel!a1 cdim=1";

execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_SE.xls squeeze=0 var=Var_Pnew_gen_SE rng=gen!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_SE.xls squeeze=0 var=Var_Pnew_cap_SE rng=cap!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_SE.xls squeeze=0 var=Var_emissions_SE rng=emissions!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_SE.xls squeeze=0 var=Var_marg_cost_SE rng=Shadow!a1 cdim=1";
execute "Gdxxrw %regional_out%regout.gdx o=%regional_out%output_SE.xls squeeze=0 var=totF_SE rng=Fuel!a1 cdim=1";
