Parameters
residual_sites_thermal_eval(input_no,I_reg,nuts2,thermal,plant_type,modelled_status,T)
residual_sites_wind_eval(input_no,I_reg,nuts2,wind,modelled_status,T)
residual_sites_hydro_eval(input_no,I_reg,nuts2,hydro,modelled_status,T)

wind_park_size(wind)
new_wind_park_size(wind_type)
new_size_thermal(thermal,plant_type)
new_size_CCS(CCS,plant_type)
;
scalar
new_size_peak_gas
;

wind_park_size("WON")=0.05;
wind_park_size("WOFF")=0.1;
new_wind_park_size(onwind)=0.05;
new_wind_park_size("offwind")=0.1;


new_size_thermal("B",plant_type)=1;
new_size_thermal("H",plant_type)=0.6;
new_size_thermal("G",plant_type)=0.3;
new_size_thermal("O",plant_type)=0.3;
new_size_thermal("P",plant_type)=0.04;
new_size_thermal("W",plant_type)=0.04;
new_size_thermal("W","Condens")=0.1;
new_size_thermal("U",plant_type)=1.2;

new_size_peak_gas=0.05;

new_size_CCS("BCCS",plant_type)=1;
new_size_CCS("HCCS",plant_type)=0.6;
new_size_CCS("GCCS",plant_type)=0.3;
new_size_CCS("BWCCS",plant_type)=1;
new_size_CCS("HWCCS",plant_type)=0.6;

Variables
residual_sites_thermaltype(I_reg,thermal,plant_type,T)
residual_sites_thermal(I_reg,thermal,T)
residual_sites_wind(I_reg,wind,T)
residual_sites_RO(I_reg,T)
residual_sites_REG(I_reg,T)

new_sites_thermaltype(I_reg,thermal,plant_type,T)
new_sites_thermal(I_reg,thermal,T)
new_sites_CCS(I_reg,CCS,T)
new_sites_wind(I_reg,wind_class,T)
new_sites_RO(I_reg,T)
new_sites_REG(I_reg,T)

tot_sites_thermaltype(I_reg,thermal,plant_type,T)
tot_sites_thermal(I_reg,thermal,T)
tot_sites_wind(I_reg,wind_class,T)
tot_sites_RO(I_reg,T)
tot_sites_REG(I_reg,T)

bogus2
;

Equations
res_thermalEQU1(I_reg,thermal,plant_type,T)
res_thermalEQU2(I_reg,thermal,T)
res_windEQU(I_reg,wind,T)
res_hydroROEQU(I_reg,T)
res_hydroREGEQU(I_reg,T)

new_thermalEQU1(I_reg,thermal,plant_type,T)
new_thermalEQU2(I_reg,thermal,T)
new_CCSEQU(I_reg,CCS,T)
new_windEQU(I_reg,wind_class,T)
new_hydroROEQU(I_reg,T)
new_hydroREGEQU(I_reg,T)

tot_thermalEQU1(I_reg,thermal,plant_type,T)
tot_thermalEQU2(I_reg,thermal,T)
tot_windEQU1(I_reg,T)
tot_windEQU2(I_reg,T)
tot_windEQU3(I_reg,T)
tot_hydroROEQU(I_reg,T)
tot_hydroREGEQU(I_reg,T)

bogus2EQU
;




residual_sites_wind_eval(input_no,I_reg,nuts2,wind,modelled_status,T)$(Db_in(input_no,"location_no") eq country_num(I_reg)
         and Db_in(input_no,"fuel_no") eq fuel_num(wind)
         and Db_in(input_no,"status_db") eq status_num(modelled_status)
         and Db_in(input_no,"decommission") gt T_num(T)
         and Db_in(input_no,"commission") gt T_num(T)-tech_life(wind)
         and Db_in(input_no,"commission") le T_num(T))=1;

residual_sites_wind_eval(input_no,I_reg,nuts2,wind,modelled_status,"2010")$(Db_in(input_no,"location_no") eq country_num(I_reg)
         and Db_in(input_no,"fuel_no") eq fuel_num(wind)
         and Db_in(input_no,"status_db") eq status_num(modelled_status)
*         and Db_in(input_no,"decommission") gt T_num(T)
*         and Db_in(input_no,"commission") gt T_num(T)-tech_life(wind)
*         and Db_in(input_no,"commission") le T_num(T)
         )=1;

residual_sites_hydro_eval(input_no,I_reg,nuts2,hydro,modelled_status,T)$(Db_in(input_no,"location_no") eq country_num(I_reg)
         and Db_in(input_no,"fuel_no") eq fuel_num(hydro)
         and Db_in(input_no,"status_db") eq status_num(modelled_status)
         and Db_in(input_no,"decommission") gt T_num(T)
         and Db_in(input_no,"commission") gt T_num(T)-tech_life(hydro)
         and Db_in(input_no,"commission") le T_num(T))=1;

residual_sites_hydro_eval(input_no,I_reg,nuts2,hydro,modelled_status,"2010")$(Db_in(input_no,"location_no") eq country_num(I_reg)
         and Db_in(input_no,"fuel_no") eq fuel_num(hydro)
         and Db_in(input_no,"status_db") eq status_num(modelled_status)
*         and Db_in(input_no,"decommission") gt T_num(T)
*         and Db_in(input_no,"commission") gt T_num(T)-tech_life(hydro)
*         and Db_in(input_no,"commission") le T_num(T)
         )=1;

residual_sites_thermal_eval(input_no,I_reg,nuts2,thermal,plant_type,modelled_status,T)$(Db_in(input_no,"location_no") eq country_num(I_reg)
         and Db_in(input_no,"fuel_no") eq fuel_num(thermal)
         and Db_in(input_no,"status_db") eq status_num(modelled_status)
         and Db_in(input_no,"plant_type_db") eq plant_type_num(plant_type)
         and Db_in(input_no,"decommission") gt T_num(T)
         and Db_in(input_no,"commission") gt T_num(T)-tech_life(thermal)
         and Db_in(input_no,"commission") le T_num(T))=1;

residual_sites_thermal_eval(input_no,I_reg,nuts2,thermal,plant_type,modelled_status,"2010")$(Db_in(input_no,"location_no") eq country_num(I_reg)
         and Db_in(input_no,"fuel_no") eq fuel_num(thermal)
         and Db_in(input_no,"status_db") eq status_num(modelled_status)
         and Db_in(input_no,"plant_type_db") eq plant_type_num(plant_type)
*         and Db_in(input_no,"decommission") gt T_num(T)
*         and Db_in(input_no,"commission") gt T_num(T)-tech_life(thermal)
*         and Db_in(input_no,"commission") le T_num(T)
         )=1;

res_thermalEQU1(I_reg,thermal,plant_type,T)..
         residual_sites_thermaltype(I_reg,thermal,plant_type,T)=E=sum((input_no,nuts2,modelled_status),residual_sites_thermal_eval(input_no,I_reg,nuts2,thermal,plant_type,modelled_status,T));

res_thermalEQU2(I_reg,thermal,T)..
         residual_sites_thermal(I_reg,thermal,T)=E=sum((input_no,nuts2,plant_type,modelled_status),residual_sites_thermal_eval(input_no,I_reg,nuts2,thermal,plant_type,modelled_status,T));

res_windEQU(I_reg,wind,T)..
         residual_sites_wind(I_reg,wind,T)=E=sum((input_no,nuts2,modelled_status)$(Residual_P_wind_eval(input_no,I_reg,wind,modelled_status,T) gt wind_park_size(wind)),
                                         residual_sites_wind_eval(input_no,I_reg,nuts2,wind,modelled_status,T));
res_hydroROEQU(I_reg,T)..
         residual_sites_RO(I_reg,T)$((hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")) gt 0)=E=sum((input_no,modelled_status),(hydro_prod(I_reg,"run_riv")/(hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")))*residual_sites_hydro_eval(input_no,I_reg,nuts2,"RO",modelled_status,T));

res_hydroREGEQU(I_reg,T)..
         residual_sites_REG(I_reg,T)$((hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")) gt 0)=E=sum((input_no,modelled_status),(hydro_prod(I_reg,"reg")/(hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")))*residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,T));

new_thermalEQU1(I_reg,thermal,plant_type,T)..
         new_sites_thermaltype(I_reg,thermal,plant_type,T)=E=VNPTtype.l(I_reg,thermal,plant_type,T)/new_size_thermal(thermal,plant_type);

new_thermalEQU2(I_reg,thermal,T)..
         new_sites_thermal(I_reg,thermal,T)=E=sum(plant_type,VNPTtype.l(I_reg,thermal,plant_type,T)/new_size_thermal(thermal,plant_type));

new_CCSEQU(I_reg,CCS,T)..
         new_sites_CCS(I_reg,CCS,T)=E=sum(plant_type,VNPCCStype.l(I_reg,CCS,plant_type,T)/new_size_CCS(CCS,plant_type));

new_windEQU(I_reg,wind_class,T)..
         new_sites_wind(I_reg,wind_class,T)=E=VNPW.l(I_reg,wind_class,T)/new_wind_park_size(wind_class);

new_hydroROEQU(I_reg,T)..
         new_sites_RO(I_reg,T)$((hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")) gt 0)=E=sum((input_no,modelled_status),(hydro_prod(I_reg,"run_riv")/(hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")))*(residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,"2003")-residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,T)));
new_hydroREGEQU(I_reg,T)..
         new_sites_REG(I_reg,T)$((hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")) gt 0)=E=sum((input_no,modelled_status),(hydro_prod(I_reg,"reg")/(hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")))*(residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,"2003")-residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,T)));

tot_thermalEQU1(I_reg,thermal,plant_type,T)..
         tot_sites_thermaltype(I_reg,thermal,plant_type,T)=E=sum((input_no,modelled_status),residual_sites_thermal_eval(input_no,I_reg,thermal,plant_type,modelled_status,T))+VNPTtype.l(I_reg,thermal,plant_type,T)/new_size_thermal(thermal,plant_type);

tot_thermalEQU2(I_reg,thermal,T)..
         tot_sites_thermal(I_reg,thermal,T)=E=sum((input_no,plant_type,modelled_status),residual_sites_thermal_eval(input_no,I_reg,thermal,plant_type,modelled_status,T))+sum(plant_type,VNPTtype.l(I_reg,thermal,plant_type,T)/new_size_thermal(thermal,plant_type));

tot_windEQU1(I_reg,T)..
         tot_sites_wind(I_reg,"low",T)=E=sum((input_no,modelled_status)$(Residual_P_wind_eval(input_no,I_reg,"WON",modelled_status,T) gt wind_park_size("WON")),
                                         residual_sites_wind_eval(input_no,I_reg,"WON",modelled_status,T)/2)+VNPW.l(I_reg,"low",T)/new_wind_park_size("low");
tot_windEQU2(I_reg,T)..
         tot_sites_wind(I_reg,"up",T)=E=sum((input_no,modelled_status)$(Residual_P_wind_eval(input_no,I_reg,"WON",modelled_status,T) gt wind_park_size("WON")),
                                         residual_sites_wind_eval(input_no,I_reg,"WON",modelled_status,T)/2)+VNPW.l(I_reg,"up",T)/new_wind_park_size("up");
tot_windEQU3(I_reg,T)..
         tot_sites_wind(I_reg,"off",T)=E=sum((input_no,modelled_status)$(Residual_P_wind_eval(input_no,I_reg,"WOFF",modelled_status,T) gt wind_park_size("WOFF")),
                                         residual_sites_wind_eval(input_no,I_reg,"WOFF",modelled_status,T))+VNPW.l(I_reg,"off",T)/new_wind_park_size("off");
tot_hydroROEQU(I_reg,T)..
         tot_sites_RO(I_reg,T)$((hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")) gt 0)=E=sum((input_no,modelled_status),(hydro_prod(I_reg,"run_riv")/(hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")))*residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,T))+
                                 sum((input_no,modelled_status),(hydro_prod(I_reg,"run_riv")/(hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")))*(residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,"2003")-residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,T)));
tot_hydroREGEQU(I_reg,T)..
         tot_sites_REG(I_reg,T)$((hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")) gt 0)=E=sum((input_no,modelled_status),(hydro_prod(I_reg,"reg")/(hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")))*residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,T))+
                                 sum((input_no,modelled_status),(hydro_prod(I_reg,"reg")/(hydro_prod(I_reg,"run_riv")+hydro_prod(I_reg,"reg")))*(residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,"2003")-residual_sites_hydro_eval(input_no,I_reg,"RO",modelled_status,T)));


bogus2EQU.. bogus2=G=0;

model bogus_sites /
res_thermalEQU1
res_thermalEQU2
res_windEQU
res_hydroROEQU
res_hydroREGEQU

new_thermalEQU1
new_thermalEQU2
new_CCSEQU
new_windEQU
new_hydroROEQU
new_hydroREGEQU

tot_thermalEQU1
tot_thermalEQU2
tot_windEQU1
tot_windEQU2
tot_windEQU3
tot_hydroROEQU
tot_hydroREGEQU

bogus2EQU
/
;

Solve bogus_sites using LP minimizing bogus2;

execute_unload 'sites.gdx'
residual_sites_thermaltype
residual_sites_thermal
residual_sites_wind
residual_sites_RO
residual_sites_REG

new_sites_thermaltype
new_sites_thermal
new_sites_CCS
new_sites_wind
new_sites_RO
new_sites_REG

tot_sites_thermaltype
tot_sites_thermal
tot_sites_wind
tot_sites_RO
tot_sites_REG

;

execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=residual_sites_thermaltype rng=res_thermaltype!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=residual_sites_thermal rng=res_thermal!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=residual_sites_wind rng=res_wind!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=residual_sites_RO rng=res_hydro_RO!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=residual_sites_REG rng=res_hydro_REG!a1 cdim=1";

execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=new_sites_thermaltype rng=new_thermaltype!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=new_sites_thermal rng=new_thermal!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=new_sites_CCS rng=new_CCS!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=new_sites_wind rng=new_wind!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=new_sites_RO rng=new_hydro_RO!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=new_sites_REG rng=new_hydro_REG!a1 cdim=1";

execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=tot_sites_thermaltype rng=tot_thermaltype!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=tot_sites_thermal rng=tot_thermal!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=tot_sites_wind rng=tot_wind!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=tot_sites_RO rng=tot_hydro_RO!a1 cdim=1";
execute "Gdxxrw sites.gdx o=sites.xls squeeze=0 var=tot_sites_REG rng=tot_hydro_REG!a1 cdim=1";

