*******************************************************
*** Exchange parameters in modelling exchange study ***
*******************************************************


Sets
         inv_no fictive plant number of new investments
         /inv1*inv50000/

         output_no plant number in output db
         /out1*out100000/


;
scalar
GW_to_MW
;
GW_to_MW=1000;


Parameters

inv_cap_no(inv_no)
inv_cap_count
inv_cap_count_thermal(I_reg,thermal,plant_type,T)
inv_cap_count_wind(I_reg,wind_type,T)
inv_cap_count_hydro(I_reg,hydro_class,T)
inv_cap_count_others(I_reg,others,T)
inv_cap_count_CCS(I_reg,CCS,plant_type,T)
inv_cap_count_geothermal(I_reg,geothermal,T)

cap_count_thermal_nuts(I_reg,nuts2,thermal,plant_type,T)

cap_count_thermal(I_reg,thermal,plant_type,T)
cap_count_therm2(I_reg)
cap_count_therm3(I_reg,thermal)
cap_count_wind(I_reg)
cap_count_wind2(I_reg,wind_type)
cap_count_wind3(I_reg,wind_type,T)
cap_count_hydro(I_reg)
cap_count_hydro2(I_reg,hydro_class)
cap_count_hydro3(I_reg,hydro_class,T)
cap_count_others(I_reg)
cap_count_others2(I_reg,others)
cap_count_others3(I_reg,others,T)
cap_count_CCS(I_reg)
cap_count_CCS2(I_reg,CCS)
cap_count_CCS3(I_reg,CCS,T)
cap_count_geothermal(I_reg)
cap_count_geothermal2(I_reg,T)

tot_cap_count_thermal
tot_cap_count_wind
tot_cap_count_hydro
tot_cap_count_others
tot_cap_count_CCS
tot_cap_count_geothermal

cum_cap_count_thermal(I_reg,thermal,plant_type,T)
cum_cap_count_therm2(I_reg)
cum_cap_count_therm3(I_reg,thermal)
cum_cap_count_therm4(I_reg,thermal,plant_type)
cum_cap_count_therm5(I_reg,thermal,plant_type,T)
cum_cap_count_therm6(I_reg,nuts2,thermal,plant_type,T)
cum_cap_count_wind(I_reg)
cum_cap_count_wind2(I_reg,wind_type)
cum_cap_count_wind3(I_reg,wind_type,T)
cum_cap_count_hydro(I_reg)
cum_cap_count_hydro2(I_reg,hydro_class)
cum_cap_count_hydro3(I_reg,hydro_class,T)
cum_cap_count_others(I_reg)
cum_cap_count_others2(I_reg,others)
cum_cap_count_others3(I_reg,others,T)
cum_cap_count_CCS(I_reg)
cum_cap_count_CCS2(I_reg,CCS)
cum_cap_count_CCS3(I_reg,CCS,T)
cum_cap_count_geothermal(I_reg)
cum_cap_count_geothermal2(I_reg,T)

wind_park_size(wind)
new_wind_park_size(wind_type)
new_size_thermal(thermal,plant_type)
new_size_CCS(CCS,plant_type)
new_size_geothermal(geothermal)
new_size_others(others)

new_cap_in(inv_no,db_prop)
*new_cap_out(inv_no,db_prop)

*new_cap_2003(inv_no,db_prop)
*new_cap_2030(inv_no,db_prop)
fuel_num_wind_exist(wind)
fuel_num_wind(wind_type)
fuel_num_hydro(hydro_class)

centre_point(nuts2,geography)

;

Centre_point(nuts2,"latitude")=123;
Centre_point(nuts2,"longitude")=456;
Centre_point(nuts2,"nutsnumber")=nutsnumber(nuts2);

wind_park_size("WON")=0.05;
wind_park_size("WOFF")=0.1;
new_wind_park_size(onwind)=0.05;
new_wind_park_size("offwind")=0.1;

fuel_num_wind_exist("WON")=90;
fuel_num_wind_exist("WOFF")=900;
fuel_num_wind("onwind10")=91;
fuel_num_wind("onwind125")=92;
fuel_num_wind("onwind15")=93;
fuel_num_wind("onwind175")=94;
fuel_num_wind("onwind20")=95;
fuel_num_wind("onwind15")=96;
fuel_num_wind("onwind30")=97;
fuel_num_wind("onwind35")=98;
fuel_num_wind("offwind")=910;

fuel_num_hydro("run_riv")=101;
fuel_num_hydro("reg")=102;

new_size_thermal("B",plant_type)=1;
new_size_thermal("H",plant_type)=0.6;
new_size_thermal("G",plant_type)=0.3;
new_size_thermal("O",plant_type)=0.3;
new_size_thermal("P",plant_type)=0.04;
new_size_thermal("W",plant_type)=0.04;
new_size_thermal("W","Condens")=0.1;
new_size_thermal("WA",plant_type)=0.04;
new_size_thermal("WA","Condens")=0.1;
new_size_thermal("U",plant_type)=1.2;

new_size_CCS("BCCS",plant_type)=1;
new_size_CCS("HCCS",plant_type)=0.6;
new_size_CCS("GCCS",plant_type)=0.3;
new_size_CCS("BWCCS",plant_type)=1;
new_size_CCS("HWCCS",plant_type)=0.6;

new_size_geothermal(geothermal)=0.1;

new_size_others("PV")=0.01;
new_size_others("STH")=0.05;
new_size_others("T")=0.01;
new_size_others("Wv")=0.01;
new_size_others("small_hydro")=0.001;



inv_cap_count_thermal(I_reg,thermal,plant_type,T)=inv_VNPTtype.l(I_reg,thermal,plant_type,T)/new_size_thermal(thermal,plant_type);
inv_cap_count_wind(I_reg,wind_type,T)=sum(nuts2$(country_to_nuts2(I_reg,nuts2)),inv_VNPW.l(nuts2,wind_type,T))/new_wind_park_size(wind_type);
inv_cap_count_hydro(I_reg,"run_riv",T)$(Inv_VNPH.l(I_reg,"run_riv",T) gt 0)=1;
inv_cap_count_hydro(I_reg,"reg",T)$(Inv_VNPH.l(I_reg,"reg",T) gt 0)=1;
inv_cap_count_others(I_reg,others,T)=inv_VNPO.l(I_reg,others,T)/new_size_others(others);
inv_cap_count_CCS(I_reg,CCS,plant_type,T)=inv_VNPCCStype.l(I_reg,CCS,plant_type,T)/new_size_CCS(CCS,plant_type);
inv_cap_count_geothermal(I_reg,geothermal,T)=inv_VNPGEO.l(I_reg,geothermal,T)/new_size_geothermal(geothermal);

*$ontext
alias (nuts2,nuts);

cap_count_thermal_nuts(I_reg,nuts2,thermal,plant_type,T)$(country_to_nuts2(I_reg,nuts2) and sum(nuts$country_to_nuts2(I_reg,nuts),totsites_res_P_thermal(nuts,thermal,plant_type)) gt 0)=
         (totsites_res_P_thermal(nuts2,thermal,plant_type)/sum(nuts$country_to_nuts2(I_reg,nuts),totsites_res_P_thermal(nuts,thermal,plant_type)))*Ceil(inv_cap_count_thermal(I_reg,thermal,plant_type,T));

display cap_count_thermal_nuts;

cap_count_thermal(I_reg,thermal,plant_type,T)=Ceil(inv_cap_count_thermal(I_reg,thermal,plant_type,T));
cap_count_therm2(I_reg)=sum((thermal,plant_type,T),cap_count_thermal(I_reg,thermal,plant_type,T));
cap_count_therm3(I_reg,thermal)=sum((plant_type,T),cap_count_thermal(I_reg,thermal,plant_type,T));

cap_count_wind(I_reg)=sum((wind_type,T),Ceil(inv_cap_count_wind(I_reg,wind_type,T)));
cap_count_wind2(I_reg,wind_type)=sum(T,Ceil(inv_cap_count_wind(I_reg,wind_type,T)));
cap_count_wind3(I_reg,wind_type,T)=Ceil(inv_cap_count_wind(I_reg,wind_type,T));

cap_count_hydro(I_reg)=sum((hydro_class,T),Ceil(inv_cap_count_hydro(I_reg,hydro_class,T)));
cap_count_hydro2(I_reg,hydro_class)=sum(T,Ceil(inv_cap_count_hydro(I_reg,hydro_class,T)));
cap_count_hydro3(I_reg,hydro_class,T)=Ceil(inv_cap_count_hydro(I_reg,hydro_class,T));

cap_count_others(I_reg)=sum((others,T),Ceil(inv_cap_count_others(I_reg,others,T)));
cap_count_others2(I_reg,others)=sum(T,Ceil(inv_cap_count_others(I_reg,others,T)));
cap_count_others3(I_reg,others,T)=Ceil(inv_cap_count_others(I_reg,others,T));

cap_count_CCS(I_reg)=sum((CCS,plant_type,T),Ceil(inv_cap_count_CCS(I_reg,CCS,plant_type,T)));
cap_count_CCS2(I_reg,CCS)=sum((plant_type,T),Ceil(inv_cap_count_CCS(I_reg,CCS,plant_type,T)));
cap_count_CCS3(I_reg,CCS,T)=sum(plant_type,Ceil(inv_cap_count_CCS(I_reg,CCS,plant_type,T)));

cap_count_geothermal(I_reg)=sum((geothermal,T),Ceil(inv_cap_count_geothermal(I_reg,geothermal,T)));
cap_count_geothermal2(I_reg,T)=sum(geothermal,Ceil(inv_cap_count_geothermal(I_reg,geothermal,T)));
*$offtext

tot_cap_count_thermal=sum((I_reg,thermal,plant_type,T),cap_count_thermal(I_reg,thermal,plant_type,T));
tot_cap_count_wind=sum(I_reg,cap_count_wind(I_reg));
tot_cap_count_hydro=sum(I_reg,cap_count_hydro(I_reg));
tot_cap_count_others=sum(I_reg,cap_count_others(I_reg));
tot_cap_count_CCS=sum(I_reg,cap_count_CCS(I_reg));
tot_cap_count_geothermal=sum(I_reg,cap_count_geothermal(I_reg));

cum_cap_count_thermal(I_reg,thermal,plant_type,T)=0;
cum_cap_count_therm2(I_reg)=0;
cum_cap_count_therm3(I_reg,thermal)=0;
cum_cap_count_therm4(I_reg,thermal,plant_type)=0;
cum_cap_count_therm5(I_reg,thermal,plant_type,T)=0;
cum_cap_count_therm6(I_reg,nuts2,thermal,plant_type,T)=0;
cum_cap_count_wind(I_reg)=0;
cum_cap_count_wind2(I_reg,wind_type)=0;
cum_cap_count_wind3(I_reg,wind_type,T)=0;
cum_cap_count_hydro(I_reg)=0;
cum_cap_count_hydro2(I_reg,hydro_class)=0;
cum_cap_count_hydro3(I_reg,hydro_class,T)=0;
cum_cap_count_others(I_reg)=0;
cum_cap_count_others2(I_reg,others)=0;
cum_cap_count_others3(I_reg,others,T)=0;
cum_cap_count_CCS(I_reg)=0;
cum_cap_count_CCS2(I_reg,CCS)=0;
cum_cap_count_CCS3(I_reg,CCS,T)=0;
cum_cap_count_geothermal(I_reg)=0;
cum_cap_count_geothermal2(I_reg,T)=0;


loop(I_reg,

         cum_cap_count_thermal(I_reg,thermal,plant_type,T)=cum_cap_count_thermal(I_reg-1,thermal,plant_type,T)+cap_count_thermal(I_reg,thermal,plant_type,T);
         cum_cap_count_therm2(I_reg)=sum((thermal,plant_type,T),cum_cap_count_thermal(I_reg,thermal,plant_type,T));
         cum_cap_count_wind(I_reg)=cum_cap_count_wind(I_reg-1)+cap_count_wind(I_reg);
         cum_cap_count_hydro(I_reg)=cum_cap_count_hydro(I_reg-1)+cap_count_hydro(I_reg);
         cum_cap_count_others(I_reg)=cum_cap_count_others(I_reg-1)+cap_count_others(I_reg);
         cum_cap_count_CCS(I_reg)=cum_cap_count_CCS(I_reg-1)+cap_count_CCS(I_reg);
         cum_cap_count_geothermal(I_reg)=cum_cap_count_geothermal(I_reg-1)+cap_count_geothermal(I_reg);

*** Thermal ***

         new_cap_in(inv_no,"location_no")$(ord(inv_no) gt cum_cap_count_therm2(I_reg-1)
         and ord(inv_no) le cum_cap_count_therm2(I_reg))
         =reg_num(I_reg);

         loop(thermal,

                 cum_cap_count_therm3(I_reg,thermal)=cum_cap_count_therm3(I_reg,thermal-1)+sum((plant_type,T),cap_count_thermal(I_reg,thermal,plant_type,T));

                 new_cap_in(inv_no,"fuel_no")$(ord(inv_no) gt cum_cap_count_therm3(I_reg,thermal-1)+cum_cap_count_therm2(I_reg-1)
                 and ord(inv_no) le cum_cap_count_therm3(I_reg,thermal)+cum_cap_count_therm2(I_reg-1))
                 =fuel_num(thermal);

                 loop(plant_type,

                         cum_cap_count_therm4(I_reg,thermal,plant_type)=cum_cap_count_therm4(I_reg,thermal,plant_type-1)+sum(T,cap_count_thermal(I_reg,thermal,plant_type,T));

                         new_cap_in(inv_no,"plant_type_db")$(ord(inv_no) gt cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                         and ord(inv_no) le cum_cap_count_therm4(I_reg,thermal,plant_type)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                         =plant_type_num(plant_type);

                         loop(T,

                                 cum_cap_count_therm5(I_reg,thermal,plant_type,T)=cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cap_count_thermal(I_reg,thermal,plant_type,T);

                                 new_cap_in(inv_no,"commission")$(ord(inv_no) gt cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                                 and ord(inv_no) le cum_cap_count_therm5(I_reg,thermal,plant_type,T)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                                 =T_num(T);

                                 new_cap_in(inv_no,"decommission")$(ord(inv_no) gt cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                                 and ord(inv_no) le cum_cap_count_therm5(I_reg,thermal,plant_type,T)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                                 =T_num(T)+tech_life(thermal);

                                 new_cap_in(inv_no,"capacity_el")$(ord(inv_no) gt cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                                 and ord(inv_no) le cum_cap_count_therm5(I_reg,thermal,plant_type,T)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                                 =inv_VNPTtype.l(I_reg,thermal,plant_type,T)*GW_to_MW/cap_count_thermal(I_reg,thermal,plant_type,T);

                                 new_cap_in(inv_no,"capacity_heat")$(new_cap_in(inv_no,"plant_type_db") eq plant_type_num("CHP") and ord(inv_no) gt cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                                 and ord(inv_no) le cum_cap_count_therm5(I_reg,thermal,plant_type,T)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                                 =(inv_VNPTtype.l(I_reg,thermal,plant_type,T)*GW_to_MW/cap_count_thermal(I_reg,thermal,plant_type,T))/EPT_alfa(thermal,"CHP",T);

                                 new_cap_in(inv_no,"capacity_boiler")$(ord(inv_no) gt cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                                 and ord(inv_no) le cum_cap_count_therm5(I_reg,thermal,plant_type,T)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                                 =(inv_VNPTtype.l(I_reg,thermal,plant_type,T)*GW_to_MW/cap_count_thermal(I_reg,thermal,plant_type,T))/(eta_T_factors(thermal,plant_type,'a')*(1-exp(-(eta_T_factors(thermal,plant_type,'b')*
                                 (new_cap_in(inv_no,"commission")-eta_T_factors(thermal,plant_type,'c'))**eta_T_factors(thermal,plant_type,'d')))));

                                 new_cap_in(inv_no,"eta_el")$(ord(inv_no) gt cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                                 and ord(inv_no) le cum_cap_count_therm5(I_reg,thermal,plant_type,T)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                                 =(eta_T_factors(thermal,plant_type,'a')*(1-exp(-(eta_T_factors(thermal,plant_type,'b')*
                                 (new_cap_in(inv_no,"commission")-eta_T_factors(thermal,plant_type,'c'))**eta_T_factors(thermal,plant_type,'d')))));

                                 new_cap_in(inv_no,"eta_tot")$((new_cap_in(inv_no,"plant_type_db") eq plant_type_num("CHP") or new_cap_in(inv_no,"plant_type_db") eq plant_type_num("BP")) and ord(inv_no) gt cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                                 and ord(inv_no) le cum_cap_count_therm5(I_reg,thermal,plant_type,T)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                                 =(eta_T_factors(thermal,"BP",'a')*(1-exp(-(eta_T_factors(thermal,"BP",'b')*
                                 (new_cap_in(inv_no,"commission")-eta_T_factors(thermal,"BP",'c'))**eta_T_factors(thermal,"BP",'d')))));

                                 new_cap_in(inv_no,"status_db")$(ord(inv_no) gt cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                                 and ord(inv_no) le cum_cap_count_therm5(I_reg,thermal,plant_type,T)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                                 =8;
*$ontext
                                 loop(nuts2$country_to_nuts2(I_reg,nuts2),

                                         cum_cap_count_therm6(I_reg,nuts2,thermal,plant_type,T)=cum_cap_count_therm6(I_reg,nuts2-1,thermal,plant_type,T)+cap_count_thermal_nuts(I_reg,nuts2,thermal,plant_type,T);

                                         new_cap_in(inv_no,geography)$(ord(inv_no) gt cum_cap_count_therm6(I_reg,nuts2-1,thermal,plant_type,T)+cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1)
                                         and ord(inv_no) le cum_cap_count_therm6(I_reg,nuts2,thermal,plant_type,T)+cum_cap_count_therm5(I_reg,thermal,plant_type,T-1)+cum_cap_count_therm4(I_reg,thermal,plant_type-1)+cum_cap_count_therm2(I_reg-1)+cum_cap_count_therm3(I_reg,thermal-1))
                                         =centre_point(nuts2,geography);
                                 );
*$offtext
                         );

                 );
         );


*** Wind ***

         new_cap_in(inv_no,"location_no")$(ord(inv_no) gt cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal
         and ord(inv_no) le cum_cap_count_wind(I_reg)+tot_cap_count_thermal)
         =reg_num(I_reg);

         loop(wind_type,

                 cum_cap_count_wind2(I_reg,wind_type)=cum_cap_count_wind2(I_reg,wind_type-1)+cap_count_wind2(I_reg,wind_type);

                 new_cap_in(inv_no,"fuel_no")$(ord(inv_no) gt cum_cap_count_wind2(I_reg,wind_type-1)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal
                 and ord(inv_no) le cum_cap_count_wind2(I_reg,wind_type)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal)
                 =fuel_num_wind(wind_type);

                 loop(T,

                         cum_cap_count_wind3(I_reg,wind_type,T)=cum_cap_count_wind3(I_reg,wind_type,T-1)+cap_count_wind3(I_reg,wind_type,T);

                         new_cap_in(inv_no,"commission")$(ord(inv_no) gt cum_cap_count_wind3(I_reg,wind_type,T-1)+cum_cap_count_wind2(I_reg,wind_type-1)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal
                         and ord(inv_no) le cum_cap_count_wind3(I_reg,wind_type,T)+cum_cap_count_wind2(I_reg,wind_type-1)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal)
                         =T_num(T);

                         new_cap_in(inv_no,"status_db")$(ord(inv_no) gt cum_cap_count_wind3(I_reg,wind_type,T-1)+cum_cap_count_wind2(I_reg,wind_type-1)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal
                         and ord(inv_no) le cum_cap_count_wind3(I_reg,wind_type,T)+cum_cap_count_wind2(I_reg,wind_type-1)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal)
                         =8;

                         loop(nuts2$country_to_nuts2(I_reg,nuts2),
                                  new_cap_in(inv_no,"decommission")$(ord(inv_no) gt cum_cap_count_wind3(I_reg,wind_type,T-1)+cum_cap_count_wind2(I_reg,wind_type-1)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal
                                  and ord(inv_no) le cum_cap_count_wind3(I_reg,wind_type,T)+cum_cap_count_wind2(I_reg,wind_type-1)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal)
                                  =T_num(T)+EPW_TL(nuts2);

                                  new_cap_in(inv_no,"capacity_el")$(ord(inv_no) gt cum_cap_count_wind3(I_reg,wind_type,T-1)+cum_cap_count_wind2(I_reg,wind_type-1)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal
                                  and ord(inv_no) le cum_cap_count_wind3(I_reg,wind_type,T)+cum_cap_count_wind2(I_reg,wind_type-1)+cum_cap_count_wind(I_reg-1)+tot_cap_count_thermal)
                                  =inv_VNPW.l(nuts2,wind_type,T)*GW_to_MW/cap_count_wind3(I_reg,wind_type,T);
                         );
                 );
         );

*** Hydro RO ***

         new_cap_in(inv_no,"location_no")$(ord(inv_no) gt cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
         and ord(inv_no) le cum_cap_count_hydro(I_reg)+tot_cap_count_thermal+tot_cap_count_wind)
         =reg_num(I_reg);

         loop(hydro_class,

                 cum_cap_count_hydro2(I_reg,hydro_class)=cum_cap_count_hydro2(I_reg,hydro_class-1)+cap_count_hydro2(I_reg,hydro_class);

                 new_cap_in(inv_no,"fuel_no")$(ord(inv_no) gt cum_cap_count_hydro2(I_reg,hydro_class-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
                 and ord(inv_no) le cum_cap_count_hydro2(I_reg,hydro_class)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind)
                 =fuel_num_hydro(hydro_class);

                 loop(T,

                         cum_cap_count_hydro3(I_reg,hydro_class,T)=cum_cap_count_hydro3(I_reg,hydro_class,T-1)+cap_count_hydro3(I_reg,hydro_class,T);

                         new_cap_in(inv_no,"commission")$(ord(inv_no) gt cum_cap_count_hydro3(I_reg,hydro_class,T-1)+cum_cap_count_hydro2(I_reg,hydro_class-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
                         and ord(inv_no) le cum_cap_count_hydro3(I_reg,hydro_class,T)+cum_cap_count_hydro2(I_reg,hydro_class-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind)
                         =T_num(T);

                         new_cap_in(inv_no,"decommission")$(ord(inv_no) gt cum_cap_count_hydro3(I_reg,hydro_class,T-1)+cum_cap_count_hydro2(I_reg,hydro_class-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
                         and ord(inv_no) le cum_cap_count_hydro3(I_reg,hydro_class,T)+cum_cap_count_hydro2(I_reg,hydro_class-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind)
                         =T_num(T)+EPH_TL(I_reg,hydro_class);

                         new_cap_in(inv_no,"capacity_el")$(ord(inv_no) gt cum_cap_count_hydro3(I_reg,hydro_class,T-1)+cum_cap_count_hydro2(I_reg,hydro_class-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
                         and ord(inv_no) le cum_cap_count_hydro3(I_reg,hydro_class,T)+cum_cap_count_hydro2(I_reg,hydro_class-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind)
                         =inv_VNPH.l(I_reg,hydro_class,T)*GW_to_MW/cap_count_hydro3(I_reg,hydro_class,T);

                         new_cap_in(inv_no,"status_db")$(ord(inv_no) gt cum_cap_count_hydro3(I_reg,hydro_class,T-1)+cum_cap_count_hydro2(I_reg,hydro_class-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
                         and ord(inv_no) le cum_cap_count_hydro3(I_reg,hydro_class,T)+cum_cap_count_hydro2(I_reg,hydro_class-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind)
                         =8;

                 );
         );
*Original hydro
$ontext
         new_cap_in(inv_no,"location_no")$(ord(inv_no) gt cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
         and ord(inv_no) le cum_cap_count_hydro(I_reg)+tot_cap_count_thermal+tot_cap_count_wind)
         =reg_num(I_reg);

         loop(T,

                  cum_cap_count_hydro2(I_reg,T)=cum_cap_count_hydro2(I_reg,T-1)+cap_count_hydro2(I_reg,T);

                  new_cap_in(inv_no,"commission")$(ord(inv_no) gt cum_cap_count_hydro2(I_reg,T-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
                  and ord(inv_no) le cum_cap_count_hydro2(I_reg,T)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind)
                  =T_num(T);

                  new_cap_in(inv_no,"decommission")$(ord(inv_no) gt cum_cap_count_hydro2(I_reg,T-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
                  and ord(inv_no) le cum_cap_count_hydro2(I_reg,T)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind)
                  =T_num(T)+tech_life("RO");

                  new_cap_in(inv_no,"capacity_el")$(ord(inv_no) gt cum_cap_count_hydro2(I_reg,T-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
                  and ord(inv_no) le cum_cap_count_hydro2(I_reg,T)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind)
                  =inv_VNPH.l(I_reg,"RO",T)/cap_count_hydro2(I_reg,T);

                  new_cap_in(inv_no,"status_db")$(ord(inv_no) gt cum_cap_count_hydro2(I_reg,T-1)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind
                  and ord(inv_no) le cum_cap_count_hydro2(I_reg,T)+cum_cap_count_hydro(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind)
                  =8;

         );
$offtext
*** Others ***

         new_cap_in(inv_no,"location_no")$(ord(inv_no) gt cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro
         and ord(inv_no) le cum_cap_count_others(I_reg)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro)
         =reg_num(I_reg);

         loop(others,

                 cum_cap_count_others2(I_reg,others)=cum_cap_count_others2(I_reg,others-1)+cap_count_others2(I_reg,others);

                 new_cap_in(inv_no,"fuel_no")$(ord(inv_no) gt cum_cap_count_others2(I_reg,others-1)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro
                 and ord(inv_no) le cum_cap_count_others2(I_reg,others)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro)
                 =fuel_num(others);

                 loop(T,

                         cum_cap_count_others3(I_reg,others,T)=cum_cap_count_others3(I_reg,others,T-1)+cap_count_others3(I_reg,others,T);

                         new_cap_in(inv_no,"commission")$(ord(inv_no) gt cum_cap_count_others3(I_reg,others,T-1)+cum_cap_count_others2(I_reg,others-1)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro
                         and ord(inv_no) le cum_cap_count_others3(I_reg,others,T)+cum_cap_count_others2(I_reg,others-1)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro)
                         =T_num(T);

                         new_cap_in(inv_no,"decommission")$(ord(inv_no) gt cum_cap_count_others3(I_reg,others,T-1)+cum_cap_count_others2(I_reg,others-1)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro
                         and ord(inv_no) le cum_cap_count_others3(I_reg,others,T)+cum_cap_count_others2(I_reg,others-1)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro)
                         =T_num(T)+tech_life(others);

                         new_cap_in(inv_no,"capacity_el")$(ord(inv_no) gt cum_cap_count_others3(I_reg,others,T-1)+cum_cap_count_others2(I_reg,others-1)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro
                         and ord(inv_no) le cum_cap_count_others3(I_reg,others,T)+cum_cap_count_others2(I_reg,others-1)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro)
                         =inv_VNPO.l(I_reg,others,T)*GW_to_MW/cap_count_others3(I_reg,others,T);

                         new_cap_in(inv_no,"status_db")$(ord(inv_no) gt cum_cap_count_others3(I_reg,others,T-1)+cum_cap_count_others2(I_reg,others-1)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro
                         and ord(inv_no) le cum_cap_count_others3(I_reg,others,T)+cum_cap_count_others2(I_reg,others-1)+cum_cap_count_others(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro)
                         =8;

                 );
         );

*** CCS ***

         new_cap_in(inv_no,"location_no")$(ord(inv_no) gt cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others
         and ord(inv_no) le cum_cap_count_CCS(I_reg)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others)
         =reg_num(I_reg);

         loop(CCS,

                 cum_cap_count_CCS2(I_reg,CCS)=cum_cap_count_CCS2(I_reg,CCS-1)+cap_count_CCS2(I_reg,CCS);

                 new_cap_in(inv_no,"fuel_no")$(ord(inv_no) gt cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others
                 and ord(inv_no) le cum_cap_count_CCS2(I_reg,CCS)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others)
                 =fuel_num(CCS);

                 new_cap_in(inv_no,"plant_type_db")$(ord(inv_no) gt cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others
                 and ord(inv_no) le cum_cap_count_CCS2(I_reg,CCS)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others)
                 =plant_type_num("Condens");

                 loop(T,

                         cum_cap_count_CCS3(I_reg,CCS,T)=cum_cap_count_CCS3(I_reg,CCS,T-1)+cap_count_CCS3(I_reg,CCS,T);

                         new_cap_in(inv_no,"commission")$(ord(inv_no) gt cum_cap_count_CCS3(I_reg,CCS,T-1)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others
                         and ord(inv_no) le cum_cap_count_CCS3(I_reg,CCS,T)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others)
                         =T_num(T);

                         new_cap_in(inv_no,"decommission")$(ord(inv_no) gt cum_cap_count_CCS3(I_reg,CCS,T-1)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others
                         and ord(inv_no) le cum_cap_count_CCS3(I_reg,CCS,T)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others)
                         =T_num(T)+tech_life(CCS);

                         new_cap_in(inv_no,"capacity_el")$(ord(inv_no) gt cum_cap_count_CCS3(I_reg,CCS,T-1)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others
                         and ord(inv_no) le cum_cap_count_CCS3(I_reg,CCS,T)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others)
                         =inv_VNPCCStype.l(I_reg,CCS,"Condens",T)*GW_to_MW/cap_count_CCS3(I_reg,CCS,T);

                         new_cap_in(inv_no,"capacity_boiler")$(ord(inv_no) gt cum_cap_count_CCS3(I_reg,CCS,T-1)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others
                         and ord(inv_no) le cum_cap_count_CCS3(I_reg,CCS,T)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others)
                         =(inv_VNPCCStype.l(I_reg,CCS,"Condens",T)*GW_to_MW/cap_count_CCS3(I_reg,CCS,T))/(eta_CCS_factors(CCS,"Condens",'a')*(1-exp(-(eta_CCS_factors(CCS,"Condens",'b')*
                         (new_cap_in(inv_no,"commission")-eta_CCS_factors(CCS,"Condens",'c'))**eta_CCS_factors(CCS,"Condens",'d')))));

                         new_cap_in(inv_no,"eta_el")$(ord(inv_no) gt cum_cap_count_CCS3(I_reg,CCS,T-1)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others
                         and ord(inv_no) le cum_cap_count_CCS3(I_reg,CCS,T)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others)
                         =(eta_CCS_factors(CCS,"Condens",'a')*(1-exp(-(eta_CCS_factors(CCS,"Condens",'b')*
                         (new_cap_in(inv_no,"commission")-eta_CCS_factors(CCS,"Condens",'c'))**eta_CCS_factors(CCS,"Condens",'d')))));

                         new_cap_in(inv_no,"status_db")$(ord(inv_no) gt cum_cap_count_CCS3(I_reg,CCS,T-1)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others
                         and ord(inv_no) le cum_cap_count_CCS3(I_reg,CCS,T)+cum_cap_count_CCS2(I_reg,CCS-1)+cum_cap_count_CCS(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others)
                         =8;

                 );
         );

*** Goethermal ***

         new_cap_in(inv_no,"location_no")$(ord(inv_no) gt cum_cap_count_geothermal(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS
         and ord(inv_no) le cum_cap_count_geothermal(I_reg)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS)
         =reg_num(I_reg);

         loop(T,

                  cum_cap_count_geothermal2(I_reg,T)=cum_cap_count_geothermal2(I_reg,T-1)+cap_count_geothermal2(I_reg,T);

                  new_cap_in(inv_no,"commission")$(ord(inv_no) gt cum_cap_count_geothermal2(I_reg,T-1)+cum_cap_count_geothermal(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS
                  and ord(inv_no) le cum_cap_count_geothermal2(I_reg,T)+cum_cap_count_geothermal(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS)
                  =T_num(T);

                  new_cap_in(inv_no,"decommission")$(ord(inv_no) gt cum_cap_count_geothermal2(I_reg,T-1)+cum_cap_count_geothermal(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS
                  and ord(inv_no) le cum_cap_count_geothermal2(I_reg,T)+cum_cap_count_geothermal(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS)
                  =T_num(T)+NPGEO_TL(I_reg,"geo");

                  new_cap_in(inv_no,"capacity_el")$(ord(inv_no) gt cum_cap_count_geothermal2(I_reg,T-1)+cum_cap_count_geothermal(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS
                  and ord(inv_no) le cum_cap_count_geothermal2(I_reg,T)+cum_cap_count_geothermal(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS)
                  = Inv_VNPGEO.l(I_reg,"geo",T)*GW_to_MW/cap_count_geothermal2(I_reg,T);

                  new_cap_in(inv_no,"status_db")$(ord(inv_no) gt cum_cap_count_geothermal2(I_reg,T-1)+cum_cap_count_geothermal(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS
                  and ord(inv_no) le cum_cap_count_geothermal2(I_reg,T)+cum_cap_count_geothermal(I_reg-1)+tot_cap_count_thermal+tot_cap_count_wind+tot_cap_count_hydro+tot_cap_count_others+tot_cap_count_CCS)
                  =8;

         );


);

parameter
new_interconnectors(export_reg,import_reg,T)
Marginal_el_price(I_reg,T)
fuel_costs(I_reg,thermal,T)
;
new_interconnectors(export_reg,import_reg,T)=NP_trade.l(export_reg,import_reg,T)*GW_to_MW;
Marginal_el_price(I_reg,T)=-(sum(Time_step,genEQU22.m(I_reg,T,Time_step)*demand_timestep(I_reg,T,Time_step))/sum(Time_step,demand_timestep(I_reg,T,Time_step)))*((1+Ir)**(T_num(T)-2003));
fuel_costs(I_reg,thermal,T)=Fc(I_reg,thermal,T);

*alias (bio_class,biomass_class);
loop(bio_class,
*biomass_cost(I_reg,T)$(sum(biomass_class,VBio_nation.l(I_reg,biomass_class,T)) gt 0)=Fc_national_bio(I_reg,"bio_class1");
fuel_costs(I_reg,"W",T)$(VBio_nation.l(I_reg,bio_class,T) gt 0 and VBio_nation.l(I_reg,bio_class,T) lt VBio_nation.up(I_reg,bio_class,T))=Fc_national_bio(I_reg,bio_class);
fuel_costs(I_reg,"W",T)$(VBio_nation.l(I_reg,bio_class,T) eq VBio_nation.up(I_reg,bio_class,T))=Fc_national_bio(I_reg,bio_class+1);
         )
;
fuel_costs(I_reg,"W",T)$(VBio_market.l(I_reg,T) gt 0 or VBio_nation.l(I_reg,"bio_class11",T) eq VBio_nation.up(I_reg,"bio_class11",T))=Fc(I_reg,"W",T);

*** test output on EPOD format ***
sets
         epod_no
         /1*50000/

         epod_dbprop
         /comm_year
         decomm_year
         plant_elcapacity
         plant_heatcapacity
         plant_elefficiency
         plant_totefficiency
         plant_bp_chp
         plant_status
         temp_country
         temp_mainfuel
         latitude
         longitude
         nutsnumber
         /
;
parameter
EPOD_PPdb(epod_no,epod_dbprop)
;
loop(in_no,

         EPOD_PPdb(epod_no,"comm_year")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"commission");

         EPOD_PPdb(epod_no,"decomm_year")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"decommission");

         EPOD_PPdb(epod_no,"plant_elcapacity")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"capacity_el");

         EPOD_PPdb(epod_no,"plant_heatcapacity")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"capacity_heat");

         EPOD_PPdb(epod_no,"plant_elefficiency")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"eta_el");

         EPOD_PPdb(epod_no,"plant_totefficiency")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"eta_tot");

         EPOD_PPdb(epod_no,"plant_bp_chp")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"plant_type_db");

         EPOD_PPdb(epod_no,"plant_status")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"status_db");

         EPOD_PPdb(epod_no,"temp_country")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"location_no");

         EPOD_PPdb(epod_no,"temp_mainfuel")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"fuel_no");

         EPOD_PPdb(epod_no,"latitude")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"latitude");

         EPOD_PPdb(epod_no,"longitude")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"longitude");

         EPOD_PPdb(epod_no,"nutsnumber")$(ord(epod_no) eq ord(in_no))=
         DB_in_Ireg(in_no,"fuel_no");
);
loop(fill_no,


         EPOD_PPdb(epod_no,"comm_year")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"commission");

         EPOD_PPdb(epod_no,"decomm_year")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"decommission");

         EPOD_PPdb(epod_no,"plant_elcapacity")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"capacity_el");

         EPOD_PPdb(epod_no,"plant_heatcapacity")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"capacity_heat");

         EPOD_PPdb(epod_no,"plant_elefficiency")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"eta_el");

         EPOD_PPdb(epod_no,"plant_totefficiency")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"eta_tot");

         EPOD_PPdb(epod_no,"plant_bp_chp")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"plant_type_db");

         EPOD_PPdb(epod_no,"plant_status")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"status_db");

         EPOD_PPdb(epod_no,"temp_country")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"location_no");

         EPOD_PPdb(epod_no,"temp_mainfuel")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_added_Ireg(fill_no,"fuel_no");

         EPOD_PPdb(epod_no,"latitude")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_in_Ireg(fill_no,"latitude");

         EPOD_PPdb(epod_no,"longitude")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_in_Ireg(fill_no,"longitude");

         EPOD_PPdb(epod_no,"nutsnumber")$(ord(epod_no) eq (ord(fill_no)+card(in_no)))=
         DB_in_Ireg(fill_no,"fuel_no");
);

loop(inv_no,

         EPOD_PPdb(epod_no,"comm_year")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"commission");

         EPOD_PPdb(epod_no,"decomm_year")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"decommission");

         EPOD_PPdb(epod_no,"plant_elcapacity")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"capacity_el");

         EPOD_PPdb(epod_no,"plant_heatcapacity")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"capacity_heat");

         EPOD_PPdb(epod_no,"plant_elefficiency")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"eta_el");

         EPOD_PPdb(epod_no,"plant_totefficiency")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"eta_tot");

         EPOD_PPdb(epod_no,"plant_bp_chp")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"plant_type_db");

         EPOD_PPdb(epod_no,"plant_status")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"status_db");

         EPOD_PPdb(epod_no,"temp_country")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"location_no");

         EPOD_PPdb(epod_no,"temp_mainfuel")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"fuel_no");

         EPOD_PPdb(epod_no,"latitude")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"latitude");

         EPOD_PPdb(epod_no,"longitude")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"longitude");

         EPOD_PPdb(epod_no,"nutsnumber")$(ord(epod_no) eq (ord(inv_no)+card(input_no)))=
         New_cap_in(inv_no,"nutsnumber");
);


display new_cap_in,
         tot_cap_count_thermal,
         tot_cap_count_wind,
         inv_cap_count_thermal,
         inv_cap_count_wind,
         inv_cap_count_hydro,
         cap_count_thermal,
         cap_count_therm2,
         cap_count_therm3,
         cum_cap_count_thermal
         cum_cap_count_therm2,
         cum_cap_count_therm3,
         cum_cap_count_wind,
         cum_cap_count_hydro

*         res_cap_2005
*         res_cap_number_2005
*         system_2005
;

execute_unload 'Exchange_cap.gdx'
*         residual_system_2005,
*         invested_system_2005,
*         residual_system_2030,
*         invested_system_2030,
         new_cap_in,
         DB_in_Ireg,
         DB_added_Ireg,
         Demand,
         fuel_costs,
         hydro_prod,
         hydro_prod_max,
         new_interconnectors,
         Marginal_el_price,
         EPOD_PPdb
*         Var_marg_cost_Ireg

;
*$offtext
*** To EPOD ***
execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls SQ=0 par=DB_in_Ireg rng=DB_capacities!a1"
;

execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls SQ=0 par=DB_added_Ireg rng=DB_cap_added!a1"
;
execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls SQ=0 par=new_cap_in rng=Investments_by_ELIN!a1"
;
execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls SQ=0 par=EPOD_PPdb rng=EPOD_PPDB!a1"
;
execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls SQ=0 par=demand rng=Demand_ELIN!a1"
;
execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls SQ=0 par=fuel_costs rng=fuel_cost_ELIN!a1"
;

*execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls squeeze=0 var=Var_marg_cost_Ireg rng=Shadow_prices_Ireg!a1 cdim=1";
execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls squeeze=0 par=Marginal_el_price rng=El_price_countries!a1 cdim=1";

execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls squeeze=0 par=hydro_prod rng=Hydro_prod!a1 cdim=1";
execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls squeeze=0 par=hydro_prod_max rng=Hydro_prod_max!a1 cdim=1";

execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls squeeze=0 par=new_interconnectors rng=new_interconnectors!a1 cdim=1";

*execute "Gdxxrw Exchange_cap.gdx o=Exchange_cap_EPOD.xls SQ=0 Var=Var_marg_cost_Ireg rng=Marginal_costs_ELIN!a1"
*;
Parameter
El_trade_import(import_reg,export_reg,T)
El_trade_export(export_reg,import_reg,T)
;
El_trade_import(import_reg,export_reg,T)=sum(Time_step,EE_import11.l(import_reg,export_reg,T,Time_step)+NE_import11.l(import_reg,export_reg,T,Time_step));
El_trade_export(export_reg,import_reg,T)=sum(Time_step,EE_export11.l(export_reg,import_reg,T,Time_step)+NE_export11.l(export_reg,import_reg,T,Time_step));

execute_unload 'trade.gdx'
El_trade_import,
El_trade_export
;

execute "Gdxxrw trade.gdx o=trade_climatmarket1.xls squeeze=0 par=El_trade_import rng=Imports!a1 cdim=1";
execute "Gdxxrw trade.gdx o=trade_climatmarket1.xls squeeze=0 par=El_trade_export rng=Exports!a1 cdim=1";
