classdef Condenser < HeatExchanger
    %UNTITLED5 Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        StateIn
        StateOut
        Eta
    end
    
    methods
        function condenser = Condenser(eta)
            if nargin == 0
                warning('Null input constructor call: Condenser');
            elseif nargin == 1
                condenser.Eta = eta;
                condenser.StateIn = [];
                condenser.StateOut = [];
            else
                error('Not correct number of inputs. Please specify 1 input, an efficiency')
            end
        end
        %         function condenser = Condenser(stateIn)
        %             if nargin == 1
        %                 condenser.calculate(stateIn);
        %             elseif nargin == 0
        %                 condenser.StateIn = []; condenser.StateOut =[];
        %             else
        %                 error('Too many inputs. Acceptable inputs are an input state or blank')
        %             end
        %         end
        
        function heatOut = getHeat(condenser,stateIn)
            condenser.StateIn = stateIn;
            condenser.StateOut = FluidState(condenser.StateIn.FluidModel, 'pressure', condenser.StateIn.Pressure, 'saturated liquid');
            heatOut = condenser.Eta.*(condenser.StateIn.Enthalpy - condenser.StateOut.Enthalpy);
        end
        %         function eta = getEfficiency(condenser)
        %
        %         end
    end
    methods (Static)
        %used to populate the efficiency edit boxes of the gui
        function eta = getDefaultEta()
            eta = 0.90;
        end
    end
    
end

