classdef Generator < handle
    %Generator is a default generator object.  It calculates electricty
    %output based on work input and efficiency.
    
    properties (Access = public)
        PowerIn
    end
    
    properties
        PowerOut
        Eta
    end
    
    methods
        function gen = Generator(eta)
            if nargin == 1
                gen.Eta = eta;
            elseif nargin > 1
                error('Too many inputs. Please specify 1 input, an efficiency')
            else
                error('Not enough inputs. Please specify 1 input, an efficiency')
            end
        end
        
%         function calculate(generator)
%             if isempty(generator.PowerIn)
%                 error('Please specify an input power first by setting the PowerIn property')
%             else
%                 generator.PowerOut = generator.PowerIn*generator.Eta;
%             end
%         end
        function powerout = calculate(generator, powerin)
            %This is more consistent with the way other components operate.
            if nargin ~= 3
                error('Please specify 2 inputs to the generator.calculate function')
%                 generator.Eta = eta;
%             elseif nargin == 2
%             %    disp(['No generator efficiency specified, using default value of ' num2str(Generator.getDefaultEta)])
%                 generator.Eta = Generator.getDefaultEta;
%             end
%             if nargin == 1
%                 error('Please specify an input power')
            end
            generator.PowerIn = powerin;
            generator.PowerOut = generator.PowerIn * generator.Eta;
            powerout = generator.PowerOut;
        end
        
    end
    
    methods (Static)
        %used to populate the efficiency edit boxes of the gui
        function eta = getDefaultEta()
            eta = 0.95;
        end
    end
    
end