classdef Inverter < handle
    %Inverter is a default inverter object.  
    
    properties
        Eta
    end
    
    methods
        function inverter = Inverter(eta)
            if nargin == 1
                inverter.Eta = eta;
            elseif nargin > 1
                error('Too many inputs. Please specify 1 input, an efficiency')
            else
                error('Not enough inputs. Please specify 1 input, an efficiency')
            end
        end
        
        function powerout = calculate(inverter, powerin)
            %This is more consistent with the way other components operate.
            if nargin ~= 3
                error('Please specify 2 inputs to the inverter.calculate function')
            end
            inverter.PowerIn = powerin;
            inverter.PowerOut = inverter.PowerIn * inverter.Eta;
            powerout = inverter.PowerOut;
        end
        
    end
    
    methods (Static)
        %used to populate the efficiency edit boxes of the gui
        function eta = getDefaultEta()
            eta = 0.95;
        end
    end
    
end