classdef PVTSystem < CHPSystem
    
    properties
        Inverter
    end
    
    methods
        function sys = PVTSystem(pump, collector, expander, condenser, generator, fluidName, inverter, trackingAxes)
            % Call superclass constructor, CHPSystem
            sys = sys@CHPSystem(pump, collector, expander, condenser, generator, fluidName, trackingAxes);
            if nargin == 0
                warning('Null input constructor call: PVTSystem');
            elseif nargin == 8                
                if ~isa(inverter,'Inverter')
                    error('Please specify a Inverter object as the 8th input')
                else
                    sys.Inverter = inverter;
                end
            else
                error('Not correct number of inputs. Please specify 8 inputs for a PVTSystem')
            end
            
        end %end constructor
        
        % no calculateWp function currently implemented, this is something to add
        % in the future.
        
    end % end methods block
    
    methods (Access = public)
        [heatIn, heatOut, etaTherm, fractionCarnotElec] = calculate(sys, env, Thigh, Phigh, Plow);
    end
end