function [heatIn, heatOut, etaTherm, fractionCarnotElec] = calculate(sys, Thigh, Phigh, Plow)
% CtoK = 273.15;

if isempty(sys.Pump) || isempty(sys.Collector) || isempty(sys.Expander) || isempty(sys.Condenser)
    error('Before running the calculate function please make sure each component of the system exists')
end

% stateinturb = FluidState('water','pressure',Phigh,'temperature',Thigh);
stateinturb = FluidState(sys.FluidName,'pressure',Phigh,'temperature',Thigh);

% Specific values in J/kg for steady state conditions
expanderWork = sys.Expander.getWork(stateinturb,Plow);
heatOut = sys.Condenser.getHeat(sys.Expander.StateOut);
pumpWork = sys.Pump.getWork(sys.Condenser.StateOut,Phigh);
heatIn = sys.Collector.getHeat(sys.Pump.StateOut,Thigh);


% sys.SolarCollector.Eta = zeros(length(env));
% for j = 1:length(env)
%     
% %     etaC(j) = sys.SolarCollector.Eta;
% end

%generatorElec = sys.Generator.calculate(turbineWork);

etaTherm = (expanderWork - pumpWork)/heatIn;
% systemElecEta = etaTherm .* sys.Generator.Eta .* etaC;
% systemHeatEta = heatOut / heatIn .* etaC;
% fractionCarnotElec = etaTherm / (1 - (sys.Pump.StateIn.Temperature + CtoK) / (sys.Turbine.StateIn.Temperature + CtoK));
fractionCarnotElec = etaTherm / (1 - sys.Pump.StateIn.Temperature / sys.Expander.StateIn.Temperature);

%results = [systemHeatEta systemElecEta fractionCarnotElec heatIn heatOut pumpWork turbineWork generatorElec];

end
