function decl = declination(~, daynum)

% Calculates declination (angular position of sun at solar noon with
% respect to plane of equator) for a given day of the year (Jan 1 = 1).
%
% UNITS
% Input in day number, output in degrees.
%
% VECTORIZATION
% Configured for vectorized operations: all inputs and outputs can
% be vectors of multiple values.
%
% REFERENCES
% Duffie, 1991: "Solar Engineering of Thermal Processes" - p 13

decl = 23.45*sin(2*pi/365*(284 + daynum));