function getSitesFromMat(sim,envArray)
%GETSITESFROMMAT(Simulation, Environment Array) builds the Sim.EnvArray for
%all of the sites in the cell array envArray. The site structure is 
%pre-built from NREL TMY data and can be loaded to the workspace by opening
%'Environments*.mat', where * is either USA or Europe.
%This is meant to be quicker than getSites because the data has already
%been processed in a .mat file (getSites, in contrast, processes the raw
%data and thus takes much longer).

sim.EnvNames = {};
sim.EnvArray = envArray;
h = waitbar(0,'Importing Environments...');
lenEnv = length(envArray);
for i = 1:length(envArray)
    sim.EnvNames{i} = sim.EnvArray{i}.Info.name;
    waitbar(i/lenEnv,h)
end
close(h)
end
