
function [heatIn, heatOut] = calculate(sys, Thigh, Tlow, P)
% CtoK = 273.15;

if isempty(sys.Pump) || isempty(sys.Collector) || isempty(sys.HeatExchanger)
    error('Before running the calculate function please make sure each component of the system exists')
end

stateInHX = FluidState(sys.FluidName,'pressure',P,'temperature',Thigh);
stateOutHX = FluidState(sys.FluidName,'pressure',P,'temperature',Tlow);

% Specific values in J/kg for steady state conditions
heatOut = sys.HeatExchanger.getHeat(stateInHX, stateOutHX);
heatIn = sys.Collector.getHeat(sys.HeatExchanger.StateOut,Thigh);

end
