classdef TurboMachine < handle
    % TurboMachine is an abstract class inherited by classes like pump and
    % expander.
    
    properties
        StateIn;
        StateOut; 
        Eta;
    end
    
    methods
%         function turboMachine = TurboMachine(stateIn, stateOut)
%             turboMachine.StateIn = stateIn;
%             turboMachine.StateOut = stateOut;
%         end
        
        function vRatio = getVolumeRatio(turboMachine)
            vRatio = turboMachine.StateIn.Density / turboMachine.StateOut.Density;       
        end
        
        function pRatio = getPressureRatio(turboMachine)
            pRatio = turboMachine.StateOut.Pressure / turboMachine.StateIn.Pressure;
        end
        
        function W = getWork(turboMachine)
            W = turboMachine.StateOut.Enthalpy - turboMachine.StateIn.Enthalpy;
        end 
    end
        
    methods (Abstract)
        eta = getIsentropicEfficiency(turboMachine)
    end
end