function [] = PlotElinCarbonEmissions( totalCO2emissions, upperLimitCO2emissions, titleText, xLabel, yLabel)
%PLOTELINCARBONEMISSIONS plots the yearly carbon emissions resulting from
%ELIN.
%   Detailed explanation goes here

Giga = 1e9;

legendCO2upper = {'Upper limit for CO2 emissions in model'};
legendCO2 = {'CO2 emissions'};

allLegends = [legendCO2upper, legendCO2];

xData = str2double(totalCO2emissions.uels{1,1});

% Convert from Megatons (ELIN default) to tons
CO2emissions = totalCO2emissions.val.*Giga;
CO2emissionsUpper = upperLimitCO2emissions.val.*Giga;

allEmissions = [CO2emissionsUpper, CO2emissions];

% % sort columns in descending order by cost at first year.
% [~, sortedInd] = sort(allPrices(1,:),'descend');
% sortedPrices = allPrices(:,sortedInd);
% sortedLegends = allLegends(:,sortedInd);

% create the figure
fig = figure('NumberTitle','off','Name',titleText);

% plot the line on the current axis
lineEmissions = line(xData, allEmissions);

% add the axes labels
xlabel(xLabel);
ylabel(yLabel);

% create the legend
legend(lineEmissions, allLegends, 'Location','best','interpreter','none');

% save the figures to various image formats
saveas(fig,[titleText '.eps'],'epsc');
saveas(fig,[titleText '.png']);
saveas(fig,[titleText '.fig']);

end

