function [ marginalCostElWeightedAve, marginalCostElTimeStep, marginalCostCO2, costSupplyCurveFossil, costSupplyCurveBio, plantEfficiencyConventional, plantEfficiencyCCS, investmentCostWind, OMcostWind, investmentCostSolar, OMcostSolar, investmentCostStorage, capacityFactorConventional, capacityFactorPeakingGas, capacityFactorCCS, capacityFactorExistingWind, capacityFactorNewWind, capacityFactorExistingSolar, capacityFactorNewSolar, capacityFactorHydro, capacityFactorGeothermal, capacityFactorOthers, solarSitestoCountries, potentialCapacityWind, potentialAreaCentralizedSolar, potentialAreaBuildingSolar, installedAreaCentralizedSolar, installedAreaBuildingSolar, totalCost, totalProductionCost, totalInvestmentCost, electricity, electricityRenewable, adjustedMaxLoad, totalCO2emissions, upperLimitCO2emissions, storageLevel, storageIn, storageOut, capacityStorage, capacityNewConventional, capacityNewPeakingGas, capacityNewCCS, capacityNewWind, capacityNewSolar, capacityNewHydro, capacityNewGeothermal, capacityNewOther, electricityExistingConventional, electricityNewConventional, electricityNewPeakingGas, electricityNewCCS, electricityExistingWind, electricityNewWind, electricityExistingSolar, electricityNewSolar, electricityExistingRunOfRiverHydro, electricityNewRunOfRiverHydro, electricityExistingRegulatedHydro, electricityNewRegulatedHydro, electricityNewGeothermal, electricityExistingOther, electricityNewOther, importExistingTransmission, importNewTransmission, exportExistingTransmission, exportNewTransmission, capacityNewTransmission, totalHeatExistingCHP, totalHeatNewCHP, totalFuelExistingConventional, totalFuelNewConventional, totalFuelNewPeakingGas, totalFuelNewCCS ] = ReadElinGDX( inputFilename )
%ReadElinGDX Reads the gdx output files generated from ELIN
%   Detailed explanation goes here
close all;
clear;

%Sets from individual gdxfiles
fossilFuelsWithCostSupply.name = 'cost_supply';
fossilFuelsWithCostSupply.form = 'full';
fossilFuelsWithCostSupply = rgdx (fossilFuelsWithCostSupply.name, fossilFuelsWithCostSupply);

fuelSupplyRange.name = 'TWh';
fuelSupplyRange.form = 'full';
fuelSupplyRange = rgdx (fuelSupplyRange.name, fuelSupplyRange);

fuelsConventional.name = 'thermal';
fuelsConventional.form = 'full';
fuelsConventional = rgdx (fuelsConventional.name, fuelsConventional);

plantTypes.name = 'plant_type';
plantTypes.form = 'full';
plantTypes = rgdx (plantTypes.name, plantTypes);

years.name = 'T';
years.form = 'full';
years = rgdx (years.name, years);

fuelsCCS.name = 'CCS';
fuelsCCS.form = 'full';
fuelsCCS = rgdx (fuelsCCS.name, fuelsCCS);

nuts2regions.name = 'nuts2';
nuts2regions.form = 'full';
nuts2regions = rgdx (nuts2regions.name, nuts2regions);

regionsInSimulation.name = 'I_reg';
regionsInSimulation.form = 'full';
regionsInSimulation = rgdx (regionsInSimulation.name, regionsInSimulation);

windClasses.name = 'wind_type';
windClasses.form = 'full';
windClasses = rgdx (windClasses.name, windClasses);

investmentCostProperties.name = 'inv_prop';
investmentCostProperties.form = 'full';
investmentCostProperties = rgdx (investmentCostProperties.name, investmentCostProperties);

OMcostProperties.name = 'OM_prop';
OMcostProperties.form = 'full';
OMcostProperties = rgdx (OMcostProperties.name, OMcostProperties);

solarTypes.name = 'solar_type';
solarTypes.form = 'full';
solarTypes = rgdx (solarTypes.name, solarTypes);

solarSites.name = 'solar_sites';
solarSites.form = 'full';
solarSites = rgdx (solarSites.name, solarSites);

storageTypes.name = 'storage_systems';
storageTypes.form = 'full';
storageTypes = rgdx (storageTypes.name, storageTypes);

hydroTypes.name = 'hydro_class';
hydroTypes.form = 'full';
hydroTypes = rgdx (hydroTypes.name, hydroTypes);

geothermalTypes.name = 'geothermal';
geothermalTypes.form = 'full';
geothermalTypes = rgdx (geothermalTypes.name, geothermalTypes);

otherTypes.name = 'others';
otherTypes.form = 'full';
otherTypes = rgdx (otherTypes.name, otherTypes);

countries.name = 'regions';
countries.form = 'full';
countries = rgdx (countries.name, countries);

timeSteps.name = 'Time_step';
timeSteps.form = 'full';
timeSteps = rgdx (timeSteps.name, timeSteps);

otherTypesWoutPV.name = 'non_PV';
otherTypesWoutPV.form = 'full';
otherTypesWoutPV = rgdx (otherTypesWoutPV.name, otherTypesWoutPV);

% Variables, parameters, and equations from a single gdx file.
%guel = @(s,v) strcat(s,strsplit(num2str(v)));
marginalCostElWeightedAve.name = 'mc_el_weighted_avg';
marginalCostElWeightedAve.form = 'full';
marginalCostElWeightedAve.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
marginalCostElWeightedAve = rgdx(inputFilename, marginalCostElWeightedAve);

marginalCostElTimeStep.name = 'mc_el_time_step';
marginalCostElTimeStep.form = 'full';
marginalCostElTimeStep.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}, timeSteps.uels{1,1}};
marginalCostElTimeStep = rgdx(inputFilename, marginalCostElTimeStep);

marginalCostCO2.name = 'mc_co2';
marginalCostCO2.form = 'full';
marginalCostCO2.uels = {years.uels{1,1}};
marginalCostCO2 = rgdx(inputFilename, marginalCostCO2);

costSupplyCurveFossil.name = 'Fc_linear_cost_supply_fossil';
costSupplyCurveFossil.form = 'full';
%costSupplyCurveFossil.compress = false;
costSupplyCurveFossil.uels = {fossilFuelsWithCostSupply.uels{1,1}, fuelSupplyRange.uels{1,1}};
%costSupplyCurveFossil.uels = {{'B','H','G'},guel('TWh',1:5000)};
costSupplyCurveFossil = rgdx(inputFilename,costSupplyCurveFossil);

costSupplyCurveBio.name = 'Fc_linear_cost_supply_biomarket';
costSupplyCurveBio.form = 'full';
costSupplyCurveBio.uels = {fuelSupplyRange.uels{1,1}};
costSupplyCurveBio = rgdx(inputFilename, costSupplyCurveBio);

plantEfficiencyConventional.name = 'eta_el';
plantEfficiencyConventional.form = 'full';
plantEfficiencyConventional.uels = {fuelsConventional.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
plantEfficiencyConventional = rgdx(inputFilename, plantEfficiencyConventional);

plantEfficiencyCCS.name = 'eta_elCCS';
plantEfficiencyCCS.form = 'full';
plantEfficiencyCCS.uels = {fuelsCCS.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
plantEfficiencyCCS = rgdx(inputFilename, plantEfficiencyCCS);

investmentCostWind.name = 'NPW_Ic';
investmentCostWind.form = 'full';
investmentCostWind.uels = {nuts2regions.uels{1,1},windClasses.uels{1,1},investmentCostProperties.uels{1,1},years.uels{1,1}};
investmentCostWind = rgdx(inputFilename, investmentCostWind);

OMcostWind.name = 'EPW_OM';
OMcostWind.form = 'full';
OMcostWind.uels = {regionsInSimulation.uels{1,1},windClasses.uels{1,1},OMcostProperties.uels{1,1},years.uels{1,1}};
OMcostWind = rgdx(inputFilename, OMcostWind);

investmentCostSolar.name = 'NPSol_Ic';
investmentCostSolar.form = 'full';
investmentCostSolar.uels = {solarTypes.uels{1,1}, solarSites.uels{1,1}, investmentCostProperties.uels{1,1}, years.uels{1,1}};
investmentCostSolar = rgdx(inputFilename, investmentCostSolar);

OMcostSolar.name = 'EPSol_OM';
OMcostSolar.form = 'full';
OMcostSolar.uels = {solarTypes.uels{1,1}, regionsInSimulation.uels{1,1}, OMcostProperties.uels{1,1}, years.uels{1,1}};
OMcostSolar = rgdx(inputFilename, OMcostSolar);

investmentCostStorage.name = 'NEStorage_Ic';
investmentCostStorage.form = 'full';
investmentCostStorage.uels = {storageTypes.uels{1,1}, regionsInSimulation.uels{1,1}, years.uels{1,1}};
investmentCostStorage = rgdx(inputFilename, investmentCostStorage);

capacityFactorConventional.name = 'cap_factor_thermal';
capacityFactorConventional.form = 'full';
capacityFactorConventional.uels = {regionsInSimulation.uels{1,1}, fuelsConventional.uels{1,1}, plantTypes.uels{1,1}};
capacityFactorConventional = rgdx(inputFilename, capacityFactorConventional);

capacityFactorPeakingGas.name = 'cap_factor_Pgas';
capacityFactorPeakingGas.form = 'full';
capacityFactorPeakingGas.uels = {regionsInSimulation.uels{1,1}};
capacityFactorPeakingGas = rgdx(inputFilename, capacityFactorPeakingGas);

capacityFactorCCS.name = 'cap_factor_CCS';
capacityFactorCCS.form = 'full';
capacityFactorCCS.uels = {regionsInSimulation.uels{1,1}, fuelsCCS.uels{1,1}, plantTypes.uels{1,1}};
capacityFactorCCS = rgdx(inputFilename, capacityFactorCCS);

capacityFactorExistingWind.name = 'cap_factor_wind_exist';
capacityFactorExistingWind.form = 'full';
capacityFactorExistingWind.uels = {nuts2regions.uels{1,1}};
capacityFactorExistingWind = rgdx(inputFilename, capacityFactorExistingWind);

capacityFactorNewWind.name = 'cap_factor_wind_new';
capacityFactorNewWind.form = 'full';
capacityFactorNewWind.uels = {nuts2regions.uels{1,1}, windClasses.uels{1,1}};
capacityFactorNewWind = rgdx(inputFilename, capacityFactorNewWind);

capacityFactorExistingSolar.name = 'cap_factor_solar_exist';
capacityFactorExistingSolar.form = 'full';
capacityFactorExistingSolar.uels = {solarTypes.uels{1,1}, nuts2regions.uels{1,1}};
capacityFactorExistingSolar = rgdx(inputFilename, capacityFactorExistingSolar);

capacityFactorNewSolar.name = 'cap_factor_solar_new';
capacityFactorNewSolar.form = 'full';
capacityFactorNewSolar.uels = {solarTypes.uels{1,1}, solarSites.uels{1,1}};
capacityFactorNewSolar = rgdx(inputFilename, capacityFactorNewSolar);

capacityFactorHydro.name = 'cap_factor_hydro';
capacityFactorHydro.form = 'full';
capacityFactorHydro.uels = {regionsInSimulation.uels{1,1}, hydroTypes.uels{1,1}};
capacityFactorHydro = rgdx(inputFilename, capacityFactorHydro);

capacityFactorGeothermal.name = 'cap_factor_geothermal';
capacityFactorGeothermal.form = 'full';
capacityFactorGeothermal.uels = {regionsInSimulation.uels{1,1}, geothermalTypes.uels{1,1}};
capacityFactorGeothermal = rgdx(inputFilename, capacityFactorGeothermal);

capacityFactorOthers.name = 'cap_factor_others';
capacityFactorOthers.form = 'full';
capacityFactorOthers.uels = {regionsInSimulation.uels{1,1}, otherTypes.uels{1,1}};
capacityFactorOthers = rgdx(inputFilename, capacityFactorOthers);

solarSitestoCountries.name = 'solar_sites_to_regions';
solarSitestoCountries.form = 'full';
solarSitestoCountries.uels = {solarSites.uels{1,1}, countries.uels{1,1}};
solarSitestoCountries = rgdx(inputFilename, solarSitestoCountries);

potentialCapacityWind.name = 'upper_lim_wind';
potentialCapacityWind.form = 'full';
potentialCapacityWind.uels = {nuts2regions.uels{1,1}, windClasses.uels{1,1}, years.uels{1,1}};
potentialCapacityWind = rgdx(inputFilename, potentialCapacityWind);

potentialAreaCentralizedSolar.name = 'solar_pot_centralized';
potentialAreaCentralizedSolar.form = 'full';
potentialAreaCentralizedSolar.uels = {solarSites.uels{1,1}};
potentialAreaCentralizedSolar = rgdx(inputFilename, potentialAreaCentralizedSolar);

potentialAreaBuildingSolar.name = 'solar_pot_buildings';
potentialAreaBuildingSolar.form = 'full';
potentialAreaBuildingSolar.uels = {solarSites.uels{1,1}};
potentialAreaBuildingSolar = rgdx(inputFilename, potentialAreaBuildingSolar);

installedAreaCentralizedSolar.name = 'tot_solar_area_centralEQU';
installedAreaCentralizedSolar.form = 'full';
installedAreaCentralizedSolar.field = 'l';
installedAreaCentralizedSolar.uels = {solarSites.uels{1,1}, years.uels{1,1}};
installedAreaCentralizedSolar = rgdx(inputFilename, installedAreaCentralizedSolar);

installedAreaBuildingSolar.name = 'tot_solar_area_buildingEQU';
installedAreaBuildingSolar.form = 'full';
installedAreaBuildingSolar.field = 'l';
installedAreaBuildingSolar.uels = {solarSites.uels{1,1}, years.uels{1,1}};
installedAreaBuildingSolar = rgdx(inputFilename, installedAreaBuildingSolar);

totalCost.name = 'tot_cost';
totalCost.form = 'full';
totalCost = rgdx(inputFilename, totalCost);

totalProductionCost.name = 'Prod_cost';
totalProductionCost.form = 'full';
totalProductionCost.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
totalProductionCost = rgdx(inputFilename, totalProductionCost);

totalInvestmentCost.name = 'aninv_cost';
totalInvestmentCost.form = 'full';
totalInvestmentCost.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
totalInvestmentCost = rgdx(inputFilename, totalInvestmentCost);

electricity.name = 'gen_region';
electricity.form = 'full';
electricity.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}, timeSteps.uels{1,1}};
electricity = rgdx(inputFilename, electricity);

electricityRenewable.name = 'tot_RES';
electricityRenewable.form = 'full';
electricityRenewable.uels = {years.uels{1,1}};
electricityRenewable = rgdx(inputFilename, electricityRenewable);

adjustedMaxLoad.name = 'system_max_load';
adjustedMaxLoad.form = 'full';
adjustedMaxLoad.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
adjustedMaxLoad = rgdx(inputFilename, adjustedMaxLoad);

% adjustedActualLoad.name = 'system_capEQU1';
% adjustedActualLoad.form = 'full';
% adjustedActualLoad.field = 'l';
% adjustedActualLoad.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
% adjustedActualLoad = rgdx(inputFilename, adjustedActualLoad);

totalCO2emissions.name = 'VCO2';
totalCO2emissions.form = 'full';
totalCO2emissions.uels = {years.uels{1,1}};
totalCO2emissions = rgdx(inputFilename, totalCO2emissions);

upperLimitCO2emissions.name = 'VCO2';
upperLimitCO2emissions.form = 'full';
upperLimitCO2emissions.field = 'up';
upperLimitCO2emissions.uels = {years.uels{1,1}};
upperLimitCO2emissions = rgdx(inputFilename, upperLimitCO2emissions);

storageLevel.name = 'VNEStorageLevel';
storageLevel.form = 'full';
storageLevel.uels = {storageTypes.uels{1,1}, regionsInSimulation.uels{1,1}, years.uels{1,1}, timeSteps.uels{1,1}};
storageLevel = rgdx(inputFilename, storageLevel);

storageIn.name = 'VNEStorageIn';
storageIn.form = 'full';
storageIn.uels = {storageTypes.uels{1,1}, regionsInSimulation.uels{1,1}, years.uels{1,1}, timeSteps.uels{1,1}};
storageIn = rgdx(inputFilename, storageIn);

storageOut.name = 'VNEStorageOut';
storageOut.form = 'full';
storageOut.uels = {storageTypes.uels{1,1}, regionsInSimulation.uels{1,1}, years.uels{1,1}, timeSteps.uels{1,1}};
storageOut = rgdx(inputFilename, storageOut);

capacityStorage.name = 'VNEStorageCap';
capacityStorage.form = 'full';
capacityStorage.uels = {storageTypes.uels{1,1}, regionsInSimulation.uels{1,1}, years.uels{1,1}};
capacityStorage = rgdx(inputFilename, capacityStorage);

capacityNewConventional.name = 'VNPTtype';
capacityNewConventional.form = 'full';
capacityNewConventional.uels = {regionsInSimulation.uels{1,1}, fuelsConventional.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
capacityNewConventional = rgdx(inputFilename, capacityNewConventional);

capacityNewPeakingGas.name = 'VNPPgas';
capacityNewPeakingGas.form = 'full';
capacityNewPeakingGas.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
capacityNewPeakingGas = rgdx(inputFilename, capacityNewPeakingGas);

capacityNewCCS.name = 'VNPCCStype';
capacityNewCCS.form = 'full';
capacityNewCCS.uels = {regionsInSimulation.uels{1,1}, fuelsCCS.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
capacityNewCCS = rgdx(inputFilename, capacityNewCCS);

capacityNewWind.name = 'VNPW';
capacityNewWind.form = 'full';
capacityNewWind.uels = {nuts2regions.uels{1,1}, windClasses.uels{1,1}, years.uels{1,1}};
capacityNewWind = rgdx(inputFilename, capacityNewWind);

capacityNewSolar.name = 'VNPSol';
capacityNewSolar.form = 'full';
capacityNewSolar.uels = {solarTypes.uels{1,1}, solarSites.uels{1,1}, years.uels{1,1}};
capacityNewSolar = rgdx(inputFilename, capacityNewSolar);

capacityNewHydro.name = 'VNPH';
capacityNewHydro.form = 'full';
capacityNewHydro.uels = {regionsInSimulation.uels{1,1}, hydroTypes.uels{1,1}, years.uels{1,1}};
capacityNewHydro = rgdx(inputFilename, capacityNewHydro);

capacityNewGeothermal.name = 'VNPGEO';
capacityNewGeothermal.form = 'full';
capacityNewGeothermal.uels = {regionsInSimulation.uels{1,1}, geothermalTypes.uels{1,1}, years.uels{1,1}};
capacityNewGeothermal = rgdx(inputFilename, capacityNewGeothermal);

capacityNewOther.name = 'VNPO';
capacityNewOther.form = 'full';
capacityNewOther.uels = {regionsInSimulation.uels{1,1}, otherTypesWoutPV.uels{1,1}, years.uels{1,1}};
capacityNewOther = rgdx(inputFilename, capacityNewOther);

electricityExistingConventional.name = 'VEETtype';
electricityExistingConventional.form = 'full';
electricityExistingConventional.uels = {regionsInSimulation.uels{1,1}, fuelsConventional.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
electricityExistingConventional = rgdx(inputFilename, electricityExistingConventional);

electricityNewConventional.name = 'VNETtype';
electricityNewConventional.form = 'full';
electricityNewConventional.uels = {regionsInSimulation.uels{1,1}, fuelsConventional.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
electricityNewConventional = rgdx(inputFilename, electricityNewConventional);

electricityNewPeakingGas.name = 'VNEPgas';
electricityNewPeakingGas.form = 'full';
electricityNewPeakingGas.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
electricityNewPeakingGas = rgdx(inputFilename, electricityNewPeakingGas);

electricityNewCCS.name = 'VNECCStype';
electricityNewCCS.form = 'full';
electricityNewCCS.uels = {regionsInSimulation.uels{1,1}, fuelsCCS.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
electricityNewCCS = rgdx(inputFilename, electricityNewCCS);

electricityExistingWind.name = 'EEW';
electricityExistingWind.form = 'full';
electricityExistingWind.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
electricityExistingWind = rgdx(inputFilename, electricityExistingWind);

electricityNewWind.name = 'VNEW';
electricityNewWind.form = 'full';
electricityNewWind.uels = {regionsInSimulation.uels{1,1}, windClasses.uels{1,1}, years.uels{1,1}};
electricityNewWind = rgdx(inputFilename, electricityNewWind);

electricityExistingSolar.name = 'EESol';
electricityExistingSolar.form = 'full';
electricityExistingSolar.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
electricityExistingSolar = rgdx(inputFilename, electricityExistingSolar);

electricityNewSolar.name = 'VNESol';
electricityNewSolar.form = 'full';
electricityNewSolar.uels = {solarTypes.uels{1,1}, regionsInSimulation.uels{1,1}, years.uels{1,1}};
electricityNewSolar = rgdx(inputFilename, electricityNewSolar);

electricityExistingRunOfRiverHydro.name = 'EEH_RO';
electricityExistingRunOfRiverHydro.form = 'full';
electricityExistingRunOfRiverHydro.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
electricityExistingRunOfRiverHydro = rgdx(inputFilename, electricityExistingRunOfRiverHydro);

electricityNewRunOfRiverHydro.name = 'VNEH_RO';
electricityNewRunOfRiverHydro.form = 'full';
electricityNewRunOfRiverHydro.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
electricityNewRunOfRiverHydro = rgdx(inputFilename, electricityNewRunOfRiverHydro);

electricityExistingRegulatedHydro.name = 'VEEH_REG';
electricityExistingRegulatedHydro.form = 'full';
electricityExistingRegulatedHydro.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
electricityExistingRegulatedHydro = rgdx(inputFilename, electricityExistingRegulatedHydro);

electricityNewRegulatedHydro.name = 'VNEH_REG';
electricityNewRegulatedHydro.form = 'full';
electricityNewRegulatedHydro.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
electricityNewRegulatedHydro = rgdx(inputFilename, electricityNewRegulatedHydro);

electricityNewGeothermal.name = 'VNEGEO';
electricityNewGeothermal.form = 'full';
electricityNewGeothermal.uels = {regionsInSimulation.uels{1,1}, geothermalTypes.uels{1,1}, years.uels{1,1}};
electricityNewGeothermal = rgdx(inputFilename, electricityNewGeothermal);

electricityExistingOther.name = 'EEO';
electricityExistingOther.form = 'full';
electricityExistingOther.uels = {regionsInSimulation.uels{1,1}, otherTypesWoutPV.uels{1,1}, years.uels{1,1}};
electricityExistingOther = rgdx(inputFilename, electricityExistingOther);

electricityNewOther.name = 'VNEO';
electricityNewOther.form = 'full';
electricityNewOther.uels = {regionsInSimulation.uels{1,1}, otherTypesWoutPV.uels{1,1}, years.uels{1,1}};
electricityNewOther = rgdx(inputFilename, electricityNewOther);

importExistingTransmission.name = 'EE_import';
importExistingTransmission.form = 'full';
importExistingTransmission.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}, timeSteps.uels{1,1}};
importExistingTransmission = rgdx(inputFilename, importExistingTransmission);

importNewTransmission.name = 'NE_import';
importNewTransmission.form = 'full';
importNewTransmission.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}, timeSteps.uels{1,1}};
importNewTransmission = rgdx(inputFilename, importNewTransmission);

exportExistingTransmission.name = 'EE_export';
exportExistingTransmission.form = 'full';
exportExistingTransmission.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}, timeSteps.uels{1,1}};
exportExistingTransmission = rgdx(inputFilename, exportExistingTransmission);

exportNewTransmission.name = 'NE_export';
exportNewTransmission.form = 'full';
exportNewTransmission.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}, timeSteps.uels{1,1}};
exportNewTransmission = rgdx(inputFilename, exportNewTransmission);

capacityNewTransmission.name = 'NP_trade';
capacityNewTransmission.form = 'full';
capacityNewTransmission.uels = {regionsInSimulation.uels{1,1}, regionsInSimulation.uels{1,1}, years.uels{1,1}};
capacityNewTransmission = rgdx(inputFilename, capacityNewTransmission);

totalHeatExistingCHP.name = 'VEHTtype';
totalHeatExistingCHP.form = 'full';
totalHeatExistingCHP.uels = {regionsInSimulation.uels{1,1}, fuelsConventional.uels{1,1}, {'CHP'}, years.uels{1,1}};
totalHeatExistingCHP = rgdx(inputFilename, totalHeatExistingCHP);

totalHeatNewCHP.name = 'VNHTtype';
totalHeatNewCHP.form = 'full';
totalHeatNewCHP.uels = {regionsInSimulation.uels{1,1}, fuelsConventional.uels{1,1}, {'CHP'}, years.uels{1,1}};
totalHeatNewCHP = rgdx(inputFilename, totalHeatNewCHP);

totalFuelExistingConventional.name = 'VEFTtype';
totalFuelExistingConventional.form = 'full';
totalFuelExistingConventional.uels = {regionsInSimulation.uels{1,1}, fuelsConventional.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
totalFuelExistingConventional = rgdx(inputFilename, totalFuelExistingConventional);

totalFuelNewConventional.name = 'VNFTtype';
totalFuelNewConventional.form = 'full';
totalFuelNewConventional.uels = {regionsInSimulation.uels{1,1}, fuelsConventional.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
totalFuelNewConventional = rgdx(inputFilename, totalFuelNewConventional);

totalFuelNewPeakingGas.name = 'VNFPgas';
totalFuelNewPeakingGas.form = 'full';
totalFuelNewPeakingGas.uels = {regionsInSimulation.uels{1,1}, years.uels{1,1}};
totalFuelNewPeakingGas = rgdx(inputFilename, totalFuelNewPeakingGas);

totalFuelNewCCS.name = 'VNFCCStype';
totalFuelNewCCS.form = 'full';
totalFuelNewCCS.uels = {regionsInSimulation.uels{1,1}, fuelsConventional.uels{1,1}, plantTypes.uels{1,1}, years.uels{1,1}};
totalFuelNewCCS = rgdx(inputFilename, totalFuelNewCCS);

save('ElinOutput.mat');

end

