function [scal] = fluidInput
% Edition and use of a Simulis Calculator Object
%
% Creation of a Simulis Calculator
scal = stCALCreate;
fprintf('\n');
% Edition of the parameters of the Simulis Calculator Object
modified = stCALEdit(scal);
if modified
    fprintf('The Simulis Calculator Object has been modified.\n');
else
    fprintf('The Simulis Calculator Object has NOT been modified.\n');
end
fprintf('\n');
% Edition of the INPUT unit system of the Simulis Calculator Object
inSyst = 1;
modifiedInput = stCALSystemEdit(scal,1);
if modifiedInput
    fprintf('The INPUT unit system of the Simulis Calculator Object has been modified.\n');
else
    fprintf('The INPUT unit system of the Simulis Calculator Object has NOT been modified.\n');
end
fprintf('\n');
% Edition of the OUTPUT unit system of the Simulis Calculator Object
outSyst = 2;
modifiedOutput = stCALSystemEdit(scal,2);
if modifiedOutput
    fprintf('The OUTPUT unit system of the Simulis Calculator Object has been modified.\n');
else
    fprintf('The OUTPUT unit system of the Simulis Calculator Object has NOT been modified.\n');
end
fprintf('\n');
% Get the number of compounds
cmpdCount = stCALCompoundCount(scal);
if (cmpdCount==0)
    fprintf('Error : you must select one compound at least.\n');
else
    fprintf('- Number of compounds = %d\n',cmpdCount);
    fprintf('\n');
    displayName = '';
    for i=1:cmpdCount
        displayName = strvcat(displayName, stCALCompoundDisplayName(scal,i));
        fprintf('%d - %s\n',i,strtrim(displayName(i,:)));
    end
%     fprintf('\n');
%     % ... Select a temperature
%     curInUnitTemperature = stCALGetUnitNameInSystem(scal,inSyst,'Temperature');
%     fprintf('... current unit of temperature = %s',strtrim(curInUnitTemperature));
%     curTemperature = input(' --> Choice a temperature : ');
%     fprintf('\n');
%     % ... Select a pressure
%     curInUnitPressure = stCALGetUnitNameInSystem(scal,inSyst,'Pressure');
%     fprintf('... current unit of pressure = %s',strtrim(curInUnitPressure));
%     curPressure = input(' --> Choice a Pressure : ');
%     fprintf('\n');
%     % ... Equimolar composition
%     zTmp = 1.0 / cmpdCount;
%     for i=1:cmpdCount
%         zMolar(i) = zTmp;
%     end
%     fprintf('... equimolar composition = %f\n',zTmp);
%     fprintf('\n');
%     % Molecular weight calculation
%     mixtCompositionType = 0; % molar
%     valMw = stCALMw(scal,zMolar,mixtCompositionType);
%     curOutUnitMw = stCALGetUnitNameInSystem(scal,outSyst,'Molar mass');
%     fprintf('- Molecular weight = %f %s\n',valMw, curOutUnitMw);
%     fprintf('\n');
%     % Flash TP
%     init = false;            % automatic initialization
%     mixtCompositionType = 0; % molar
%     resultType = 0;          % molar
%     [molarVapRatio,liquidMolarFractions,vaporMolarFractions,equiConstants] = stCALFlashTP(scal,curTemperature,curPressure,zMolar,mixtCompositionType,resultType,init);
% 	fprintf('- TP Flash:\n');
% 	fprintf('\n');
% 	fprintf('\tTemperature:              %f %s\n',curTemperature,strtrim(curInUnitTemperature));
% 	fprintf('\tPressure:                 %f %s\n',curPressure,strtrim(curInUnitPressure));
% 	fprintf('\tMolar vaporization ratio: %f \n',molarVapRatio);
% 	fprintf('\n');
% 	for i=1:cmpdCount
%         fprintf('\t%s xl=%f yv=%f ki=%f\n',strtrim(displayName(i,:)),liquidMolarFractions(i),vaporMolarFractions(i),equiConstants(i));
%     end
% 	fprintf('\n');
%     % Dynamic viscosity and thermal conductivity calculation for each phase
%     curOutUnitMu = stCALGetUnitNameInSystem(scal,outSyst,'Dynamic viscosity');
%     curOutUnitLambda = stCALGetUnitNameInSystem(scal,outSyst,'Thermal conductivity');
%     % ... liquid phase
%     if (molarVapRatio<1.0)
%         muL = stCALMuL(scal,curTemperature,curPressure,liquidMolarFractions,mixtCompositionType);
%         lambdaL = stCALLambdaL(scal,curTemperature,curPressure,liquidMolarFractions,mixtCompositionType);
%     else
%         muL = 0.0;
%         lambdaL = 0.0;
%     end
%     % ... vapor phase
%     if (molarVapRatio>0.0)
%         muV = stCALMuV(scal,curTemperature,curPressure,vaporMolarFractions,mixtCompositionType);
%         lambdaV = stCALLambdaV(scal,curTemperature,curPressure,vaporMolarFractions,mixtCompositionType);
%     else
%         muV = 0.0;
%         lambdaV = 0.0;
%     end
% 	fprintf('\tLiq. viscosity: %f %s\t - Vap. viscosity: %f %s\n',muL, strtrim(curOutUnitMu), muV, strtrim(curOutUnitMu));
% 	fprintf('\tLiq. th. cond.: %f %s\t - Vap. th. cond.: %f %s\n',lambdaL, strtrim(curOutUnitLambda), lambdaV, strtrim(curOutUnitLambda));
% 	fprintf('\n');
end
% % Free the Simulis Calculator
% stCALFree(scal); 